#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const long long mod=1e9+7;

long long n,k;
long long a[MAXN];
long long fact[MAXN];

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (a*power(power(a,b/2),2))%mod;
}

long long solve(int l,int r,long long mins){
    if(l>=r)return 1;

    int maxpos=0;
    for(int i=l;i<=r;i++){
        if(a[i]>a[maxpos] and a[i]>mins)maxpos=i;
    }
    if(maxpos==0)return 1;

    int cnt=0,len=0,br=0;
    long long del=1;
    vector<int> v={};

    for(int i=l;i<=r;i++){
        if(a[i]>mins)len++;
    }
    for(int i=l;i<maxpos;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins){
            v.push_back(a[i]);cnt++;
        }
    }
    for(int i=maxpos+1;i<=r;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins){
            v.push_back(a[i]);cnt++;
        }
    }

    sort(v.begin(),v.end());
    for(int i=0;i<v.size();i++){
        br++;
        if(i==v.size()-1 or v[i]!=v[i+1]){
            del*=fact[br]; del%=mod;
            br=0;
        }
    }

    long long lt=solve(l,maxpos-1,max(k-a[maxpos],mins));
    long long rt=solve(maxpos+1,r,max(k-a[maxpos],mins));

    return (((lt*rt)%mod)*((((fact[len]*power(fact[len-cnt],mod-2))%mod)*power(del,mod-2))%mod))%mod;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    fact[0]=1;
    for(long long i=1;i<=n;i++){
        fact[i]=(fact[i-1]*i)%mod;
    }

    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    cout<<solve(1,n,-1)<<"\n";

    return 0;
}

/**

7 200
127 70 122 45 127 135 58 1



*/
