#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1000000007;

const ll MAX_N = 3e5 + 10;
ll arr[MAX_N];
ll n, k;
bool ok[MAX_N];

ll fpow(ll x, ll p) {
	if(p == 0) return 1;

	ll ans = fpow(x, p / 2);
	ans = (ans * ans) % mod;

	if(p & 1) {
		return (ans * x) % mod;
	} else {
		return ans;
	}
}

ll perm[MAX_N], inv[MAX_N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

	perm[0] = inv[0] = 1;
	for(ll i = 1; i < MAX_N; i ++) {
		perm[i] = (perm[i - 1] * ll(i)) % mod;
		inv[i] = fpow(perm[i], mod - 2);
		assert(perm[i] * inv[i] % mod == 1);
	}

	cin >> n >> k;
	for(ll i = 0; i < n; i ++) {
		cin >> arr[i];
	}
	
	ll ret = 1;
	for(ll i = 0; i < n; i ++) {
		if(ok[i]) continue;
		ll cnt = 1;
		ll cnt_bad = 1;
		for(ll j = i - 1; j >= 0; j --) {
			if(arr[i] + arr[j] > k) {
				break;
			}
			if(arr[i] == arr[j]) {
				ok[j] = true;
				cnt_bad ++;
			} else if(arr[j] > arr[i]) {
				cnt ++;
			}
		}
		for(ll j = i + 1; j < n; j ++) {
			if(arr[i] + arr[j] > k) {
				break;
			}
			if(arr[i] == arr[j]) {
				ok[j] = true;
				cnt_bad ++;
			} else if(arr[j] > arr[i]) {
				cnt ++;
			}
		}

		// cerr << i << " " << arr[i] << " " << cnt << " " << cnt_bad << " " << ret << endl;
		ret = ret * perm[cnt + cnt_bad - 1] % mod * inv[cnt - 1] % mod * inv[cnt_bad] % mod;
	}

	cout << ret << endl;

	return 0;
}	
