#include <bits/stdc++.h>
#include "ones.h"
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1e9 + 7;

vector<int> last;

int randomize(int n) {
	vector<bool> flips = {};
	last = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(rand() % 2);
		if(flips.back()) {
			last.push_back(i);
		}
	}
	return flip_bits(flips);
}

int only_one(int n, int who) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(i == who);
	}
	return flip_bits(flips);
}

int apply(int n, const vector<int> &arr, int x) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
			flips.push_back(0);
	}
	for(int i = 0; i < x; i ++) {
			flips[last[i]] = 1;
	}
	return flip_bits(flips);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
	int what = randomize(n);
	int where = -1;
	while(true) {
		int now = randomize(n);
		if(now < what) {
			int l = 0, r = last.size();
		
			apply(n, last, last.size());

			const auto eval = [&](int x) {
				int to_check = apply(n, last, x);
				apply(n, last, x);
				if(to_check == what) {
					return false;
				} else {
					return true;
				}
			};

			while(l < r - 1) {
				int m = (l + r) / 2ll;
				if(eval(m)) {
					r = m;
				} else {
					l = m;
				}
			}

			//cerr << " now " << now << endl;
			for(const auto it : last) {
				//cerr << it << " ";
			}
			//cerr << endl;
			where = last[l];
			apply(n, last, l);
			break;
		} else {
			what = now;
		}
	}

	//cerr << " where " << where << endl;

	pair<int, int> ret;

	{
		if(where == 0) {
			ret.first = where;
		} else {
			int l = 0, r = where;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				only_one(n, m);
				
				if(now < what) {
					r = m;
				} else {
					l = m;
				}
			}
			
			if(l == 0) {
				if(only_one(n, l) < what) {
					r --;
				}
				only_one(n, l);
			}
			ret.first = r;
		}
	}

	{
		if(where == n - 1) {
			ret.second = where;
		} else {
			int l = where, r = n - 1;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				only_one(n, m);
				
				if(now < what) {
					l = m;
				} else {
					r = m;
				}
			}
			if(r == n - 1) {
				if(only_one(n, r) < what) {
					l ++;
				}
				only_one(n, r);
			}
			ret.second = l;
		}
	}

	//cerr << ret.first << " " << ret.second << endl;

	return ret;
}
