#include <bits/stdc++.h>
#include "ones.h"
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1e9 + 7;

vector<int> last;

int randomize(int n) {
	vector<bool> flips = {};
	last = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(rand() % 2);
		if(flips.back()) {
			last.push_back(i);
		}
	}
	return flip_bits(flips);
}

int only_one(int n, int who) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(i == who);
	}
	return flip_bits(flips);
}

int apply(int n, const vector<int> &arr, int x) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
			flips.push_back(0);
	}
	for(int i = 0; i < x; i ++) {
			flips[last[i]] = 1;
	}
	return flip_bits(flips);
}

pair<int, int> find_big(int n, int lval, int rval, const vector<int> &last) {	
	if(last.size() == 1) {
		if(rval > lval) {
			apply(n, last, 1);
			return {rval, last[0]};
		} else {
			return {lval, last[0]};
		}
	}

	int m = last.size() / 2;
	int to_check = apply(n, last, m);

	if(to_check == lval) {
		vector<int> right;
		for(int i = m; i < last.size(); i ++) {
			right.push_back(last[i]);
		}
		return find_big(n, to_check, rval, right);
	} else {
		vector<int> lft;
		for(int i = 0; i < m; i ++) {
			lft.push_back(last[i]);
		}
		return find_big(n, to_check, lval, lft);
	}
}

pair<int, int> find_longest_subarray_of_ones(int n) {
	int what = randomize(n);
	int where = -1;
	while(true) {
		int now = randomize(n);
		if(now != what) {
			auto ans = find_big(n, now, what, last);
			what = ans.first;
			where = ans.second;
			break;
		}
	}

	//cerr << " where " << where << endl;

	pair<int, int> ret;

	{
		if(where == 0) {
			ret.first = where;
		} else {
			int l = 0, r = where;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				only_one(n, m);
				
				if(now < what) {
					r = m;
				} else {
					l = m;
				}
			}
			
			if(l == 0) {
				if(only_one(n, l) < what) {
					r --;
				}
				only_one(n, l);
			}
			ret.first = r;
		}
	}

	{
		if(where == n - 1) {
			ret.second = where;
		} else {
			int l = where, r = n - 1;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				only_one(n, m);
				
				if(now < what) {
					l = m;
				} else {
					r = m;
				}
			}
			if(r == n - 1) {
				if(only_one(n, r) < what) {
					l ++;
				}
				only_one(n, r);
			}
			ret.second = l;
		}
	}

	//cerr << ret.first << " " << ret.second << endl;

	return ret;
}
