#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1e9 + 7;

const ll MAX_N = 1e5 + 10;
ll mob[MAX_N];
bool prime[MAX_N];
ll ret[MAX_N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	
	ll p, q, n = 10000000;
	cin >> p >> q >> n;

	prime[0] = prime[1] = true;
	mob[1] = 0;

	fill_n(mob, MAX_N, 1);

	for(ll i = 2; i < MAX_N; i ++) {
		if(prime[i]) continue;
	
		mob[i] = -1;

		for(ll j = i * 2; j < MAX_N; j += i) {
			prime[j] = false;	
			mob[j] *= 1;
		}
		for(ll j = i * i; j < MAX_N; j += i * i) {
			mob[i] = 0;
		}
	}

	for(ll m = 1; m * m <= p + q; m ++) {
		for(ll d = m; d <= p + q; d += m) {
			ll small = m - q / d;
			ll big = p / d;
			
			ll now = max(0ll, big - small + 1);
			ret[d] += now;	
			ret[d] -= ret[m] * mob[d / m];
		}
	}

	ll ans = 0;
	for(ll i = 0; i < MAX_N; i ++) {
		ans += ret[i];
	}

	cout << ans << endl;

	return 0;
}	
