// I taka produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kiucheka konq vihur 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const llong MAXN = 300000 + 10;
const llong MOD  = 1e9 + 7;
const llong INF  = 1e9;

llong fact[MAXN];
llong sorted[MAXN];
llong a[MAXN], n, k;
llong taken[MAXN];

llong power(llong value, llong base)
{
	if (base == 0) return 1;
	if (base & 1) return (value * power(value, base - 1)) % MOD;
	llong res = power(value, base / 2);
	return (res * res) % MOD;
}

inline llong var(llong n, llong k)
{
	return (fact[n] * power(fact[n - k], MOD - 2)) % MOD;
}

inline llong comb(llong n, llong k)
{
	return (((fact[n] * power(fact[n - k], MOD - 2)) % MOD) * power(fact[k], MOD - 2)) % MOD;
}

inline bool good(llong x, llong y)
{
	return a[x] + a[y] <= k;
}

llong ans = 1;
std::unordered_map <llong,llong> count;
void divide(const std::vector <llong> &nums)
{
	if (nums.size() <= 1) return;

	llong max = 0;
	for (llong i = 1 ; i < nums.size() ; ++i)
	{
		if (a[nums[i]] > a[nums[max]]) max = i;
	}

	llong cnt = 0;
	std::vector <llong> curr;
	for (llong i = 0 ; i < nums.size() ; ++i)
	{
		if (a[nums[i]] == a[nums[max]])
		{
			divide(curr);
			curr.clear();
			continue;
		}

		if (good(nums[i], nums[max])) cnt++, count[a[nums[i]]]++;
		else curr.push_back(nums[i]);
	}

	divide(curr);
	llong add = 1;
	llong left = nums.size();
	for (auto [key, value] : count)
	{
		add *= comb(left, value);
		left -= value;
		add %= MOD;
	}

	ans *= add;
	ans %= MOD;
	count.clear();
}

void solve()
{
	fact[0] = 1;
	for (llong i = 1 ; i <= n ; ++i)
	{
		fact[i] = (fact[i - 1] * i) % MOD;
	}

	std::vector <llong> nums; nums.resize(n);
	std::iota(nums.begin(), nums.end(), 1);
	divide(nums);

	std::cout << ans << '\n';
}

void read()
{
	std::cin >> n >> k;
	for (llong i = 1 ; i <= n ; ++i)
	{
		std::cin >> a[i];
	}
}

void fastIOI()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	fastIOI();
	read();
	solve();

	return 0;
}