// I taka produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kiucheka konq vihur 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include "ones.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 10000 + 10;
const int INF  = 1e9;

int n;
std::vector <int> ones, flipOnes;
std::vector <bool> flips, curr;
int askQuery()
{
	for (const int &i : ones)
	{
		flips[i] = !flips[i];
		if (flips[i] == 1) flipOnes.push_back(i);
	}

	int res = flip_bits(flips);
	for (const int &i : flipOnes) flips[i] = 0;
	flipOnes.clear();
	for (const int &i : ones)
	{
		flips[i] = 1;
		flipOnes.push_back(i);
	}

	return res;
}

std::pair <int,int> find_longest_subarray_of_ones(int N)
{
	n = N;
	curr.resize(n);
	flips.resize(n);
	ones.clear();
	flipOnes.clear();
	std::fill(curr.begin(), curr.end(), false);
	std::fill(flips.begin(), flips.end(), false);
	
	int begin = askQuery();
	if (begin == n) return {0, n - 1};
	if (begin == 0)
	{
		curr[0] = 1;
		ones.push_back(0);
		askQuery();
		return {0, 0};
	}
	
	int len;
	int pos = 0;
	for (int i = 1 ; i < n ; ++i)
	{
		ones.clear();
		ones.push_back(i);
		curr[i-1] = 0;
		curr[i] = 1;
		len = askQuery();
		if (len > begin)
		{
			pos = i;
			break;
		}
	}

	bool lastIsOne = false;
	std::fill(curr.begin(), curr.end(), false);
	ones.clear();

	bool addToConsequtive = true;
	int consequtive = 0;
	int lenIs = len;
	for (int j = pos - 1 ; j >= 0 ; --j)
	{
		for (const int &i : ones) curr[i] = 0;
		ones.clear();

		if (lastIsOne) 
		{
			curr[j + 1] = 1;
			ones.push_back(j + 1);
		}

		lastIsOne = false;
		curr[j] = 1;
		ones.push_back(j);
		int res = flip_bits(curr); 
		if (res <= len)
		{
			consequtive += addToConsequtive;
			lastIsOne = true;
		} else
		{
			addToConsequtive = false;
			len = res;
		}
	}


	if (lastIsOne)
	{
		std::fill(curr.begin(), curr.end(), false);
		curr[0] = 1;
		len = flip_bits(curr);
	}	

	lastIsOne = false;
	for (int j = pos + lenIs - consequtive ; j < n ; ++j)
	{
		std::fill(curr.begin(), curr.end(), false);
		if (lastIsOne) curr[j - 1] = 1;
		lastIsOne = false;
		curr[j] = 1;
		int res = flip_bits(curr);
		if (res < len)
		{
			lastIsOne = true;
		} else
		{
			len = res;
		}
	}

	if (lastIsOne)
	{
		std::fill(curr.begin(), curr.end(), false);
		curr[n-1] = 1;
		len = flip_bits(curr);
	}

	return {0, n-1};
}