#include "ones.h"
#include <bits/stdc++.h>
using namespace std;
mt19937 mt(69);
pair<int,int> find_longest_subarray_of_ones(int n)
{
	vector<bool>flips(n,0);
	vector<bool>flip_all(n,1);
	vector<bool>random_flip(n,0);
	int best1=flip_bits(flips),best2=flip_bits(flip_all);
	while(best1==best2)
	{
		for(int j=0;j<n;j++)
		{
			random_flip[j]=mt()%2;
		}
		flip_bits(random_flip);
		best1=flip_bits(flips);
		best2=flip_bits(flip_all);
	}
	if(best1>best2)
	{
		flip_bits(flip_all);
	}
	int low=0,high=n-1,lidx=-1,mid;
	int best=max(best1,best2);
	vector<bool>previous_flips(n,0);
	vector<bool>new_flips(n,0);
	vector<bool>xor_flips(n,0);
	while(low<=high)
	{
		mid=(low+high)/2;
		new_flips=vector<bool>(n,0);
		for(int j=0;j<=mid;j++)
		{
			new_flips[j]=1;
		}
		for(int j=0;j<n;j++)
		{
			xor_flips[j]=new_flips[j]^previous_flips[j];
		}
		previous_flips=new_flips;
		int nb1=flip_bits(xor_flips);
		new_flips=vector<bool>(n,0);
		for(int j=0;j<mid;j++)
		{
			new_flips[j]=1;
		}
		for(int j=0;j<n;j++)
		{
			xor_flips[j]=new_flips[j]^previous_flips[j];
		}
		previous_flips=new_flips;
		int nb2=flip_bits(xor_flips);
		int nb=min(nb1,nb2);//max bits if we cut {0,...,mid}
		if(nb<best)
		{
			lidx=mid;
			high=mid-1;
		}
		else
		{
			low=mid+1;
		}
	}
	flip_bits(previous_flips);
	return {lidx,lidx+best-1};
}
