#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll mod=1e9+7;

struct alo{
  ll val,lef,rig;

  bool operator<(const alo & toll)const{
    if(val!=toll.val)return val<toll.val;
    else if(lef!=toll.lef)return lef<toll.lef;
    else return rig<toll.rig;
    }
  };

unordered_map<ll,pair<ll,ll>> mp;
vector<pair<ll,ll>> v;
ll bin[900900];
ll fen[400400];
ll a[300300];
ll fact[300300];
ll toleft[300300];
ll toright[300300];
ll n,k;

ll binpow(ll a,ll b){
  ll x=1;

  while(b){
    if(b%2)x=(x*a)%mod;
    a=(a*a)%mod;
    b/=2;
    }

  return x;
  }

void insfen(ll pos){
  ++pos;
  while(pos<400400){
    ++fen[pos];
    pos+=pos&(-pos);
    }
  }

ll qfen(ll pos){
  ++pos;
  ll s=0;

  while(pos>0){
    s+=fen[pos];
    pos-=pos&(-pos);
    }
  return s;
  }

void ins1(ll pos,ll l,ll r,ll id,ll val){
  if(l==r){
    bin[pos]=val;
    return ;
    }

  ll mid=(l+r)/2;
  if(id<=mid)ins1(pos*2,l,mid,id,val);
  else ins1(pos*2+1,mid+1,r,id,val);

  bin[pos]=max(bin[pos*2],bin[pos*2+1]);
  }

void ins2(ll pos,ll l,ll r,ll id,ll val){
  if(l==r){
    bin[pos]=val;
    return ;
    }

  ll mid=(l+r)/2;
  if(id<=mid)ins2(pos*2,l,mid,id,val);
  else ins2(pos*2+1,mid+1,r,id,val);

  bin[pos]=min(bin[pos*2],bin[pos*2+1]);
  }

ll q1(ll pos,ll l,ll r,ll ql,ll qr){
  if(l>qr || r<ql)return -1e9;
  if(ql<=l && r<=qr)return bin[pos];

  ll mid=(l+r)/2;
  ll ans1=q1(pos*2,l,mid,ql,qr);
  ll ans2=q1(pos*2+1,mid+1,r,ql,qr);
  return max(ans1,ans2);
  }

ll q2(ll pos,ll l,ll r,ll ql,ll qr){
  if(l>qr || r<ql)return 1e9;
  if(ql<=l && r<=qr)return bin[pos];

  ll mid=(l+r)/2;
  ll ans1=q2(pos*2,l,mid,ql,qr);
  ll ans2=q2(pos*2+1,mid+1,r,ql,qr);
  return min(ans1,ans2);
  }

int main(){

/*
insfen(1);
insfen(2);
insfen(3);
insfen(5);
insfen(7);
insfen(10);

for(ll i=1;i<=12;++i){
  cout<<i<<" "<<qfen(i)<<endl;
  }
*/

fact[0]=1;
for(ll i=1;i<300300;++i){
  fact[i]=(fact[i-1]*i)%mod;
  }

cin>>n>>k;
for(ll i=1;i<=n;++i){
  cin>>a[i];
  v.push_back({a[i],i});
  }

sort(v.begin(),v.end());

for(ll i=0;i<n;++i){
  ll l=0,mid,r=n-1,lst=-2;

  while(l<=r){
    mid=(l+r)/2;
    if(v[i].first+v[mid].first<=k){
      lst=mid;
      l=mid+1;
      }
    else {
      r=mid-1;
      }
    }

  mp[v[i].first]={i+1,lst+1};
  }

//cout<<endl;
//for(ll i=1;i<=n;++i){
//  cout<<a[i]<<" "<<mp[a[i]].first<<" "<<mp[a[i]].second<<endl;
//  }cout<<endl;

pair<ll,ll> now;
for(ll i=1,x;i<=n;++i){
  now=mp[a[i]];
  if(now.second==-1){
    toleft[i]=i;
    ins1(1,1,n,now.first,i);
    continue;
    }
  if(now.second==n){
    toleft[i]=1;
    ins1(1,1,n,now.first,i);
    continue;
    }
  x=q1(1,1,n,now.second+1,n);
  if(x==-1e9 || x==0)x=1;
  else ++x;

  toleft[i]=x;

  ins1(1,1,n,now.first,i);
  }

for(ll i=0;i<900900;++i)bin[i]=n+1;

for(ll i=n,x;i>0;--i){
  now=mp[a[i]];
  if(now.second==-1){
    toright[i]=i;
    ins2(1,1,n,now.first,i);
    continue;
    }
  if(now.second==n){
    toright[i]=n;
    ins2(1,1,n,now.first,i);
    continue;
    }
  x=q2(1,1,n,now.second+1,n);
  if(x==1e9 || x==n+1)x=n;
  else --x;

  toright[i]=x;

  ins2(1,1,n,now.first,i);
  }

//cout<<endl<<endl;
//for(ll i=1;i<=n;++i){
//  cout<<a[i]<<" "<<toleft[i]<<" "<<toright[i]<<endl;
//  }

ll res=1;
for(ll i=0,x;i<n;++i){
  now=v[i];
  x=toright[now.second]-toleft[now.second]+1;
  x-=(qfen(toright[now.second])-qfen(toleft[now.second]-1));
  insfen(now.second);

  res=(res*x)%mod;
  }

vector<alo> xd;
for(ll i=0;i<n;++i){
  now=v[i];
  xd.push_back({now.first,toleft[now.second],toright[now.second]});
  }

sort(xd.begin(),xd.end());

//for(ll i=0;i<n;++i){
//  cout<<xd[i].val<<" "<<xd[i].lef<<" "<<xd[i].rig<<endl;
//  }

ll br=1;
for(ll i=1;i<n;++i){
  //cout<<xd[i].val<<" "<<xd[i].lef<<" "<<xd[i].rig<<endl;
  //cout<<br<<endl;

  if(xd[i].val==xd[i-1].val && xd[i].lef==xd[i-1].lef && xd[i].rig==xd[i-1].rig)++br;
  else {
    if(br>1)res=(res*binpow(fact[br],mod-2))%mod;
    br=1;
    }
  }
if(br>1)res=(res*binpow(fact[br],mod-2))%mod;

cout<<res<<endl;

return 0;
}
/*
4 5
1 2 1 3



5 4
4 3 1 5 2

6 7
8 123 7 8 9 10


*/
