#include <iostream>
#include <stdint.h>

int is_interesting(int64_t a, int64_t b, int64_t n) {
	return (a * b) % (a + b) == 0 && (a * b) / (a + b) <= n;
}

int64_t p, q, n;
int64_t count;

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> p >> q >> n;

	for (int64_t a = 1; a <= p; a += 1) {
		for (int64_t b = 1; b <= q; b += 1) {
			if (is_interesting(a, b, n)) count += 1;
		}
	}

	std::cout << count << std::endl;
}
