#include <iostream>
#include <cmath>
#include <map>
#define endl '\n'
using namespace std;

const int maxn = 1024, mod = 1e9+7;
int n, k, a[maxn], p[maxn], pos[maxn], cpos[maxn];
unordered_map <int, int> m;
bool used[maxn];
long long ans = 0;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    for (int i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        m[a[i]] = i;
    }
}

bool check()
{
    int i, j;
    for (i=1; i<=n; ++i) cpos[i] = pos[i];
    for (i=1; i<n; ++i)
    {
        if (pos[m[a[i]]] != i)
        {
            for (j=pos[m[a[i]]]; j>i; --j)
            {
                if (p[j] + p[j-1] <= k)
                {
                    swap(cpos[j], cpos[j-1]);
                    swap(p[j], p[j-1]);
                }
                else return false;
            }
        }
    }
    return true;
}

void solve(int i)
{
    if (i > n)
    {
        if (check()) ++ ans;
        return;
    }
    for (int j=1; j<=n; ++j)
    {
        if (!used[m[a[j]]])
        {
            p[i] = a[j];
            pos[m[a[j]]] = i;
            used[m[a[j]]] = true;
            solve(i+1);
            used[m[a[j]]] = false;
        }
    }
}

void print()
{
    solve(1);
    cout << (ans % mod) << '\n' ;
}

int main()
{
    read();
    print();
    return 0;
}