#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr); cout.tie(nullptr);
}


int flip_bits(const std::vector<bool> &flips);

std::pair<int, int> find_longest_subarray_of_ones(int n) {
  vector<bool> all_false(n, false);
  vector<bool> all_true(n, true);

  int maxim1 = flip_bits(all_false);
  int maxim2 = flip_bits(all_true);
  if(maxim1 > maxim2) {
    maxim2 = flip_bits(all_true);
  }

  int ina = 1, inb = n, answ = 1;
  while(ina <= inb) {
    int mid = (ina + inb) / 2;
    vector<bool> ask(n, false);
    for(int i = 0; i < mid; i++) {
      ask[i] = true;
    }
    int ansi = flip_bits(ask);
    if(ansi > maxim2) {
      int l = mid + 1, r = n, patasxan_right = -1;
      dbg(mid + 1)
      dbg(r)
      while(l <= r) {
        int m = (l + r) / 2;
        vector<bool> new_ask(n, false);
        new_ask[m - 1] = 1;
        int pt = flip_bits(new_ask);
        if(pt < ansi) {
          patasxan_right = m;
          l = m + 1;
        } else {
          r = m - 1;
        }
        pt = flip_bits(new_ask);
      }
      // vector<bool> new_ask(n, false);
      // new_ask[patasxan_right - 1] = 1;
      // flip_bits(new_ask);

      assert(patasxan_right != -1);
      return make_pair(patasxan_right - ansi, patasxan_right - 1);
    }

    if(ansi < maxim2) {
      answ = mid;
      inb = mid - 1;
    } else {
      ina = mid + 1;
    }
    flip_bits(ask);
  }

  return make_pair(answ - 1, answ + maxim2 - 2);
}

/*
int main() {
  long long p, q, n; cin >> p >> q >> n;

  long long answ = 0;
  for(long long i = 1; i <= min(n, (p * q) / 4); i++) {
    for(long long j = 1; j <= p; j++) {
      long long xd = i * j, xd_ = (j - i);
      if(xd > 0 && xd_ > 0 && xd % xd_ == 0 && xd / xd_ <= q) {
        answ++;
      }
    }
  }

  cout << answ << endl;
  return 0;
}\
*/