#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define add push_back
#define len(a) ((int)(a).size())

const ll MOD = 1e9 + 7;
const int N = 3e5 + 5;

ll n, k, ans = 0;
ll a[N], lt[N], rt[N], ind[N];
vector<int> gin[N], gout[N];
bool color[N];

void count(int cnt){
	if(cnt == n){
		ans++;
		return;
	}

	for(int i = 1; i <= n; i++){
		if(color[i]) continue;
		if(ind[i] == 0){
			color[i] = true;
			for(auto v : gout[i]) ind[v]--;
			count(cnt + 1);
			color[i] = false;
			for(auto v : gout[i]) ind[v]++;
		}
	}
}

void solve(){
	cin >> n >> k;
	for(int i = 1; i <= n; i++){
		cin >> a[i];
	}
	stack<ll> st;
	for(int i = 1; i <= n; i++){
		for(int j = i - 1; j >= 1; j--){
			if(a[i] + a[j] > k || a[i] == a[j]){
				lt[i] = j;
				break;
			}
		}
	}
	for(int i = n; i >= 1; i--){
		for(int j = i + 1; j <= n; j++){
			if(a[i] + a[j] > k || a[i] == a[j]){
				rt[i] = j;
				break;
			}
		}
	}
	for(int i = 1; i <= n; i++){
		if(rt[lt[i]] != i && lt[i] != 0) gin[i].add(lt[i]), gout[lt[i]].add(i);
		if(rt[i] != 0) gin[rt[i]].add(i), gout[i].add(rt[i]);
	}
//	for(int i = 1; i <= n; i++){
//		cout << i << ": " << lt[i] << " " << rt[i] << "\n";
//	}
//	for(int i = 1; i <= n; i++){
//		for(auto v : gout[i]){
//			cout << i << " -> " << v << "\n";
//		}
//	}
//	for(int i = 1; i <= n; i++) {
//		ind[i] = len(gin[i]);
//	}
	count(0);
	cout << ans << "\n";
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
	return 0;
}
