#include "ones.h"

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    using namespace std;
    vector<bool> flips(n);
    int len = flip_bits(flips);
    if (len == 0) {
        flips[0] = 1;
        flip_bits(flips);
        return {0, 0};
    }
    if (len == n) {
        return {0, n - 1};
    }
    flips[0] = 1;
    int res = flip_bits(flips);
    flips[0] = 0;
    if (res < len) {
        return {0, len - 1};
    } else {
        for (int i = 0; i < n; i++) {
            flips[i] = 1;
            res = flip_bits(flips);
            flip_bits(flips);
            flips[i] = 0;
            if (res > len) {
                return {i + 1, i + len};
            }
        }
    }
}