#include <iostream>
#include <bitset>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

set<vector<int>> cnt;

void gen(vector<int>& w, int n, int k) {
	cnt.insert(w);
	for (int i = 0; i < n - 1; ++i) {
		if (w[i] + w[i + 1] <= k) {
			swap(w[i], w[i + 1]);
			if (cnt.find(w) == cnt.end())
				gen(w, n, k);
			swap(w[i], w[i + 1]);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, k;
	cin >> n >> k;
	vector<int> w(n);
	for (int& i : w)
		cin >> i;
	gen(w, n, k);
	cout << cnt.size() << "\n";
}