#include "ones.h"

using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector <bool> now(n);
    int cur = flip_bits(now);
    if (cur == 0) return make_pair(0, -1);
    for (int i = 0; i < n; ++i) {
        now[i] = true;
        int cha = flip_bits(now);
        if (cha == 0) return make_pair(0, -1);
        now[i] = false;
        if (cha < cur) {
            flip_bits(now);
        } else if (cha == cur) {
            cur = cha;
            continue;
        }
        cur = cha;
        for (int j = i - 1; j >= 0; --j) {
            now[j] = true;
            cha = flip_bits(now);
            if (cha == 0) return make_pair(0, -1);
            flip_bits(now);
            if (cha > cur) {
                return make_pair(j + 1, j + cur);
            }
            now[j] = false;
        }
        return make_pair(0, cur - 1);
    }
}