#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(331);

pair<int, int> find_longest_subarray_of_ones(int n) {
	vector<bool> flips(n, false);
	for (int i = 0; i < n; ++i) {
		if (rnd() & 1) {
			flips[i] = true;
		} else {
			flips[i] = false;
		}
	}
	int len = flip_bits(flips);
	fill(flips.begin(), flips.end(), false);
	if (len == 0) {
		flips[0] = true;
		flip_bits(flips);
		return {0, 0};
	}
	int ind = -1;
	for (int i = 0; i < n; i += len) {
		flips[i] = true;
		int nlen = flip_bits(flips);
		if (nlen > len) {
			flips[i] = false;
			ind = i;
			len = nlen;
			break;
		}
		if (nlen < len) {
			flip_bits(flips);
			ind = i;
			flips[i] = false;
			break;
		}
		flips[i] = false;
	}
	int l = ind, r = n;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			r = mid;
		} else {
			l = mid;
		}
		flip_bits(flips);
		flips[mid] = false;
	}
	int R = l;
	l = -1, r = ind;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			l = mid;
		} else {
			r = mid;
		}	
		flip_bits(flips);
		flips[mid] = false;
	}
	int L = r;
	return {L, R};
}	
