#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;

int n, k;
vector <int> a;
set <vector <int>> cnt;

void dfs(vector <int> a)
{
	if (cnt.count(a)) return;
	cnt.insert(a);

	for (int i = 0; i < n - 1; ++i)
	{
		if (a[i] + a[i + 1] <= k)
		{
			swap(a[i], a[i + 1]);
			dfs(a);
			swap(a[i], a[i + 1]);
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k;
	a.resize(n);
	
	for (int i = 0; i < n; ++i) cin >> a[i];

	dfs(a);
	cout << cnt.size();

	return 0;
}
