#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
#define int long long

int gcd(int a, int b)
{
	while (a)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

int p, q, n;
ll ans;

ll gt(int p, int q, int n)
{
	ll ans = 0;
	ans += min({ p / 2, q / 2, n });

	for (int f = 1; f <= n; ++f)
	{
		for (int i = 1; i <= p; ++i)
		{
			if (f * i * (i + 1) > n) break;
			int l = i, r = q + 1;
			while (l + 1 < r)
			{
				int j = (l + r) >> 1;
				if (f * (i + j) * i > p || f * (i + j) * j > q || f * i * j > n) r = j;
				else l = j;
			}
			for (int j = i + 1; j <= l; ++j)
			{
				if (gcd(i, j) > 1) continue;
				ans++;
			}
		}

		for (int i = 1; i <= q; ++i)
		{
			if (f * i * (i + 1) > n) break; int l = i, r = q + 1;
			while (l + 1 < r)
			{
				int j = (l + r) >> 1;
				if (f * (i + j) * i > q || f * (i + j) * j > p || f * i * j > n) r = j;
				else l = j;
			}
			for (int j = i + 1; j <= l; ++j)
			{
				if (gcd(i, j) > 1) continue;
				ans++;
			}
		}

	}

	return ans;
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> p >> q >> n;

	auto got = gt(p, q, n);
	cout << got;

	return 0;
}
