#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
using namespace std;
vector<long long> facts(300001);
const long long mod = 1e9 + 7;
int n, k;
vector<int> a;
long long ans = 0;
vector<int> match;
vector<int> logs;
long long binpow(long long a, long long d) {
    if (d == 0) {
        return 1;
    }
    if (d == 1) {
        return a;
    }
    if (d % 2 == 1) {
        return (a * binpow(a, d - 1)) % mod;
    }
    long long v = binpow(a, d / 2);
    return (v * v) % mod;
}
long long rev(long long a) {
    return binpow(a, mod - 2);
}

vector<int> reqans;
vector<pair<int, int> > req;
vector<int> reqval;
int ctr = 0;
vector < vector<pair<int, int> > > evs;
int ctr2 = 0;
vector<int> parent;
vector<int> parans;


vector<vector<int> > spt;
void build() {
    for (int i = 0; i < n; i++) {
        spt[0][i] = i;
    }
    for (int lvl = 1; lvl < 18; lvl++) {
        for (int i = 0; i + (1 << lvl) <= n; i++) {
            int ll = spt[lvl - 1][i];
            int rr = spt[lvl - 1][i + (1 << (lvl - 1))];
            if (a[rr] >= a[ll]) {
                spt[lvl][i] = rr;
            }
            else {
                spt[lvl][i] = ll;
            }
        }
    }
}
int getfromst(int l, int r) {
    int lvl = logs[r - l + 1];
    int ll = spt[lvl][l];
    int rr = spt[lvl][r - (1 << lvl) + 1];
    if (a[rr] >= a[ll]) {
        return rr;
    }
    return ll;
}



vector<int> prevs(n);
vector<int> lastmeet(n, -1);


void rec(int l, int r) {
    if (l >= r) {
        return;
    }
    int mxm = 0;
    for (int i = l; i <= r; i++) {
        mxm = a[getfromst(l, r)];
    }
    if (mxm < match[mxm]) {
        return;
    }

    deque<int> mxpos = { getfromst(l, r) };
    int mxnum = 1;
    while (prevs[mxpos.front()] >= l) {
        mxpos.push_front(prevs[mxpos.front()]);
        mxnum++;
    }
    mxpos.push_front(l - 1);
    mxpos.push_back(r + 1);

    /*vector<int> mxpos = {l - 1};
    int mxnum = 0;
    for (int i = l; i <= r; i++) {
        if (a[i] == mxm) {
            mxpos.push_back(i);
            mxnum++;
        }
    }
    mxpos.push_back({ r + 1 });*/




    int globalsz = mxnum;

    long long multiply = 1;

    int cursz = 0;
    parans.push_back(globalsz);

    int parnum = ctr2++;

    for (int i = 0; i < mxpos.size() - 1; i++) {
        int ll = mxpos[i] + 1;
        int rr = mxpos[i + 1] - 1;
        if (rr >= ll) {
            req.push_back({ ll,rr });
            reqval.push_back(match[mxm]);
            evs[ll].push_back({ -1,ctr });
            evs[rr].push_back({ 1,ctr });
            ctr++;
            reqans.push_back(0);
            parent.push_back(parnum);
            rec(ll, rr);
        }
    }

    //parans.push_back(0);
    /*for (int i = l; i <= r; i++) {
        if (a[i] == mxm) {
            multiply *= facts[cursz];
            multiply %= mod;
            globalsz++;
            cursz = 0;
        }
        else if (a[i] + mxm > k) {
            cursz++;
            globalsz++;
        }
    }*/
    /*multiply *= facts[cursz];
    multiply %= mod;
    ans *= rev(facts[globalsz]);
    ans %= mod;
    ans *= multiply;
    ans %= mod;
    int prev = l;
    for (int i = l; i <= r; i++) {
        if (a[i] == mxm) {
            rec(prev, i - 1);
            prev = i + 1;
        }
    }
    rec(prev, r);*/
}
int maxat(int l, int r) {
    int mxm = 0;
    for (int i = l; i <= r; i++) {
        mxm = max(mxm, a[i]);
    }
    return mxm;
}
map<int, vector<int> > mp;

vector<int> d;
void add(int v, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }
    if (l == pos && r == pos) {
        d[v] += val;
        return;
    }
    add(2 * v + 1, l, (l + r) / 2, pos, val);
    add(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
    d[v] = d[2 * v + 1] + d[2 * v + 2];
    return;
}
int ask(int v, int l, int r, int askl, int askr) {
    if (l > askr || r < askl) {
        return 0;
    }
    if (l >= askl && r <= askr) {
        return d[v];
    }
    int aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
    int bb = ask(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
    return aa + bb;
}


int main() {
    facts[0] = 1;
    logs.resize(500000);
    logs[1] = 0;
    for (int i = 2; i < 500000; i++) {
        logs[i] = logs[i / 2] + 1;
    }
    for (int i = 1; i <= 300000; i++) {
        facts[i] = facts[i - 1] * i;
        facts[i] %= mod;
    }
    cin >> n >> k;
    ans = facts[n];

    evs.resize(n);
    d.resize(4 * n);
    a.resize(n);
    match.resize(n);
    set<int> st;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert(a[i]);
    }
    vector<int> vst;
    map<int, int> shorten, unshort;
    int iiii = 0;
    for (auto h : st) {
        unshort[iiii] = h;
        shorten[h] = iiii++;

    }
    for (auto h : st) {
        vst.push_back(h);
    }
    //int p1 = 0;
    int p2 = vst.size() - 1;
    for (int p1 = 0; p1 < st.size(); p1++) {
        while (p2 >= 0 && vst[p1] + vst[p2] > k) {
            p2--;
        }
        match[p1] = p2 + 1;
    }



    for (int i = 0; i < n; i++) {
        a[i] = shorten[a[i]];
    }
    prevs = vector<int>(n);
    lastmeet = vector<int>(n, -1);
    for (int i = 0; i < n; i++) {
        mp[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        prevs[i] = lastmeet[a[i]];
        lastmeet[a[i]] = i;

    }
    spt = vector<vector<int> >(18, vector<int>(n));
    build();


    rec(0, n - 1);

    for (int i = 0; i < n; i++) {
        evs[i].push_back({ 0,a[i] });
    }
    for (int i = 0; i < n; i++) {
        sort(evs[i].begin(), evs[i].end());
        for (auto h : evs[i]) {
            if (h.first == 0) {
                add(0, 0, n - 1, a[i], 1);

            }
            if (h.first == 1) {
                int ans = ask(0, 0, n - 1, reqval[h.second], n - 1);
                reqans[h.second] += ans;
            }
            if (h.first == -1) {
                int ans = ask(0, 0, n - 1, reqval[h.second], n - 1);
                reqans[h.second] -= ans;
            }
        }
    }
    for (int i = 0; i < ctr; i++) {
        parans[parent[i]] += reqans[i];
        ans *= facts[reqans[i]];
        ans %= mod;
    }
    for (int i = 0; i < ctr2; i++) {
        ans *= rev(facts[parans[i]]);
        ans %= mod;
    }

    for (auto h : mp) {
        int globalsz = 0;
        int cursz = 0;
        if (h.first < match[h.first]) {
            int curprev = 0;
            long long multiply = 1;
            for (auto hh : h.second) {
                globalsz++;
                if (a[getfromst(curprev, hh)] < match[h.first]) {
                    cursz++;
                }
                else {
                    ans *= rev(facts[cursz]);
                    ans %= mod;
                    cursz = 1;
                }
                curprev = hh + 1;
            }
            ans *= rev(facts[cursz]);
            ans %= mod;



        }
    }







    cout << ans;
}