#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

//#define int long long

void solve() {
    long long p = 10000, q = 1000000, n = 10000;
    cin >> p >> q >> n;
    long long cnt = 0;
    vector<bool> good(sqrt(q) + 10, 1);
    map<vector<int>, vector<int> > mp;
    int lst =1 ;
    for(;1LL * lst * lst <= q;++lst){}
    for (int i = 1; i * i <= p; ++i) {
        vector<int> help;
        int x = i;
        for (int y = 2; y * y <= x; y++) {
            if (x % y == 0)
                help.push_back(y);
            while (x % y == 0)
                x /= y;
        }
        if (x > 1)
            help.push_back(x);
        if(mp.find(help) != mp.end()){
            for (auto j : mp[help]) {
                cnt += min(min(p / i, q / j) * 1LL / (i + j),  1LL * n / (i * j));
            }
            continue;
        }
        for (auto u: help) {
            for (int j = u; j < lst; j += u)
                good[j] = 0;
        }
        vector<int> now;
        for (int j = 1; j < lst;++j) {
            if (!good[j])
                continue;
            if(help.size() >= 3)
                now.push_back(j);
            cnt += min(min(p / i, q / j) * 1LL  / (i + j),  1LL * n / (i * j));
        }
        if(help.size() >= 3)
            mp[help] = now;
        for (auto u: help) {
            for (long long j = u; j < lst; j += u)
                good[j] = 1;
        }
    }
    cout << cnt << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--)
        solve();
}
