#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

const int MAXN = 3e5 + 123;
vector<int> edg[MAXN];

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] == a[j] || a[i] + a[j] > k) {
                edg[i].push_back(j);
            }
        }
    }
    int ans = 0;
    vector<int> permut(n);
    for (int i = 0; i < n; ++i) {
        permut[i] = i;
    }
    vector<int> permut0 = permut;
    do {
        bool isok = true;
        for (int i = 0; i < n && isok; ++i) {
            for (auto u : edg[i]) {
                isok &= permut[u] > permut[i];
            }
        }
        if (isok)
            ++ans;
        next_permutation(permut.begin(), permut.end());
    } while (permut != permut0);
    cout << ans << '\n';
}
