#include "ones.h"
#include <iostream>
using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flip(n);
    int ln = flip_bits(flip);
    if (ln == 0) {
        return {1, 0};
    }
    for (int i = 0; i < n; i += ln) {
        flip[i] = 1;
        int ln0 = flip_bits(flip);
        if (ln0 != ln) {
            if (ln0 < ln) {
                flip_bits(flip);
            } else {
                ln = ln0;
            }
            flip[i] = 0;
            while (i + 1 < n) {
                flip[i + 1] = 1;
                if (flip_bits(flip) > ln) {
                    flip_bits(flip);
                    break;
                }
                flip_bits(flip);
                flip[i + 1] = 0;
                ++i;
            }
            return {i - ln + 1, i};
        }
        flip[i] = 0;
    }
    return {1, 0};
}
