#include "ones.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;


pair<int, int> find_longest_subarray_of_ones(int n) {
    auto flip = [&](int i) -> int  {
        vector<bool> a(n);
        a[i] = true;
        return flip_bits(a);
    };

    int init = flip_bits(vector<bool>(n));
    for (int i = 0; i < n; ++i) {
        int now = flip(i);
        if (now < init) {
            flip(i);
            return {i, i + init - 1};
        } else if (now > init) {
            int r = n - 1, l = 0;
            for (int j = i + 1; j < n; ++j) {
                int nw = flip(j);
                flip(j);
                if (nw >= now) {
                    r = j - 1;
                    break;
                }
            }
            for (int j = i - 1; j >= 0; --j) {
                int nw = flip(j);
                flip(j);
                if (nw >= now) {
                    l = j + 1;
                    break;
                }
            };
            return {l, r};
        }
    }
    return {0, -1};
}
