#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 1500;

bitset<N> B[N];

int mind[N];

vector<int> sieve() {
    vector<int> primes;
    for (int i = 2; i < N; ++i) {
        if (mind[i] == 0) {
            primes.push_back(i);
            mind[i] = i;
        }
        for (int x: primes) {
            if (x > mind[i] || x * i > N) {
                break;
            }
            mind[x * i] = x;
        }
    }
    return primes;
}

bool good[N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    sieve();

    ll p, q, n;
    cin >> p >> q >> n;

    ll ans = 0;
    ll lima = sqrt(p);
    ll limb = sqrt(q);

    for (ll a = 1; a <= lima; ++a) {
        ll x = a;
        memset(good, 1, sizeof(good));
        while (x > 1) {
            ll p = mind[x];
            while (x % p == 0) x /= p;
            for (int k = p; k < N; k += p) good[k] = false;
        }
        ll fi = p / a;
        for (ll b = 1; b * b <= q; ++b) {
            if (good[b]) {
                ll d = min({fi, q / b, (a + b) * n / (a * b)});
                ans += d / (a + b);
            }
        }
    }
    cout << ans << '\n';


    return 0;
}
