﻿#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 1e9 + 7;

int bin_pow(int x, int s) {
    if (s == 0)
        return 1;
    int y = bin_pow(x, s >> 1);
    y = (ll)y * y % MOD;
    if (s & 1)
        y = (ll)y * x % MOD;
    return y;
}

vi f, bf;

int C(int n, int k) {
    return (ll)f[n] * bf[n - k] % MOD * bf[k] % MOD;
}

int main() {
    fast;
    int n, k;
    cin >> n >> k;
    f.resize(n + 1);
    bf.resize(n + 1);
    f[0] = 1;
    for (int i = 1; i <= n; ++i)
        f[i] = (ll)f[i - 1] * i % MOD;
    bf[n] = bin_pow(f[n], MOD - 2);
    for (int i = n - 1; i >= 0; --i)
        bf[i] = (ll)bf[i + 1] * (i + 1) % MOD;
    vi w(n);
    vector<pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        a[i] = {w[i], i};
    }
    vi l(n, -1), r(n, n);
    vector<pii> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && st.back().first <= w[i])
            st.pop_back();
        int ll = -1, rr = (int)st.size();
        while (rr - ll > 1) {
            int m = (ll + rr) / 2;
            if (st[m].first + w[i] > k)
                ll = m;
            else
                rr = m;
        }
        if (ll != -1)
            l[i] = st[ll].second;
        st.emplace_back(w[i], i);
    }
    st.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && st.back().first <= w[i])
            st.pop_back();
        int ll = -1, rr = (int)st.size();
        while (rr - ll > 1) {
            int m = (ll + rr) / 2;
            if (st[m].first + w[i] > k)
                ll = m;
            else
                rr = m;
        }
        if (ll != -1)
            r[i] = st[ll].second;
        st.emplace_back(w[i], i);
    }
    sort(all(a));
    int ans = 1, i = 0, d = 0;
    map<pii, int> mp;
    oset s;
    for (int j = -1; j <= n; ++j)
        s.insert(j);
    while (i < n) {
        ++mp[{l[a[i].second], r[a[i].second]}];
        if (i == n - 1 || a[i].first != a[i + 1].first) {
            for (auto p: mp)
                ans = (ll)ans * C((int)s.order_of_key(p.first.second) - (int)s.order_of_key(p.first.first) - 1, p.second) % MOD;
            mp.clear();
            for (int j = d; j <= i; ++j)
                s.erase(a[j].second);
            d = i + 1;
        }
        ++i;
    }
    cout << ans << '\n';
}
