#include "ones.h"
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

random_device rd;
mt19937 rnd(rd());

pii find_longest_subarray_of_ones(int n) {
    vector<bool> f1(n, false), f2(n, true);
    int x = flip_bits(f2), p, l;
    for (int i = 0; i < n; ++i) {
        f1[i] = true;
        int z = flip_bits(f1);
        if (z > x) {
            p = i;
            l = z;
            break;
        }
        else if (z < x) {
            flip_bits(f1);
            p = i;
            l = x;
            break;
        }
        f1[i] = false;
    }
    f1[p] = false;
    int bl = max(p - l, -1), br = p;
    while (br - bl > 1) {
        int m = (bl + br) / 2;
        f1[m] = true;
        int z = flip_bits(f1);
        if (z >= l)
            bl = m;
        else
            br = m;
        flip_bits(f1);
        f1[m] = false;
    }
    return {br, br + l - 1};
}
