﻿#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e5 + 10;

int GCD(int x, int y) {
    while (y > 0) {
        int z = x;
        x = y;
        y = z % y;
    }
    return x;
}

pii min_div(int x) {
    int y = 2;
    while (y * y <= x) {
        if (x % y == 0) {
            while (x % y == 0)
                x /= y;
            return {x, y};
        }
        ++y;
    }
    return {1, x};
}

int main() {
    fast;
    ll p, q, n;
    cin >> p >> q >> n;
    ll ans = 0;
    vector<vi> d(N);
    for (int y = 1; (ll)y * y <= q; ++y)
        d[1].push_back(y);
    for (int x = 1; (ll)x * x <= p; ++x) {
        if (x > 1) {
            pii e = min_div(x);
            for (int y: d[e.first]) {
                if (y % e.second != 0)
                    d[x].push_back(y);
            }
        }
        for (int y: d[x])
            ans += min({n / (x * y), p / x / (x + y), q / y / (x + y)});
    }
    cout << ans << '\n';
}
