﻿#pragma GCC optimize("O3")
#pragma GCC target("avx2,sse4,sse4.2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e5 + 10;

int GCD(int x, int y) {
    while (y > 0) {
        int z = x;
        x = y;
        y = z % y;
    }
    return x;
}

vi primes(int x) {
    vi res;
    int y = 2;
    while (y * y <= x) {
        if (x % y == 0)
            res.push_back(y);
        while (x % y == 0)
            x /= y;
        ++y;
    }
    if (x > 1)
        res.push_back(x);
    return res;
}

int main() {
    fast;
    ll p, q, n;
    cin >> p >> q >> n;
    ll ans = 0;
    for (ll x = 1; x * x <= p; ++x) {
        ll mx = min(min(n, p) / x, (ll)N);
        vector<bool> b(mx + 1, true);
        vi pr = primes(x);
        for (int y: pr) {
            for (int z = y; z <= mx; z += y)
                b[z] = false;
        }
        for (ll y = 1; y * (x + y) <= q && y <= mx; ++y) {
            if (b[y])
                ans += min({n / x / y, p / x / (x + y), q / y / (x + y)});
        }
    }
    cout << ans << '\n';
}
