#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e5 + 5, mod = 1e9 + 7;

int binpow(int n, int k) {
    int ans = 1;
    while (k) {
        if (k & 1) {
            ans = ans * 1LL * n % mod;
        }
        n = n * 1LL * n % mod;
        k >>= 1;
    }
    return ans;
}

int f[maxn], _f[maxn];

int get_ans(vector<int> nw, int k) {
    if (nw.empty()) {
        return 1;
    }
    int pos_mx = 0;
    for (int i = 0; i < (int)nw.size(); ++i) {
        if (nw[pos_mx] < nw[i]) {
            pos_mx = i;
        }
    }
    vector<int> l, r;
    for (int i = 0; i < pos_mx; ++i) {
        if (nw[i] + nw[pos_mx] > k) {
            l.push_back(nw[i]);
        }
    }
    for (int i = pos_mx + 1; i < (int)nw.size(); ++i) {
        if (nw[i] + nw[pos_mx] > k) {
            r.push_back(nw[i]);
        }
    }
    int ans = get_ans(l, k) * 1LL * get_ans(r, k) % mod;
    int used = l.size() + r.size() + 1;
    int free = nw.size() - used;
    ans = ans * 1LL * f[used + free] % mod * _f[used] % mod;
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    f[0] = _f[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        f[i] = f[i - 1] * 1LL * i % mod;
        _f[i] = binpow(f[i], mod - 2);
    }
    cout << get_ans(a, k) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
