#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e7 + 5;

int mask[maxn];

void solve() {
    int p, q, n;
    cin >> p >> q >> n;
    long long ans = 0;
    for (int i = 1; i < maxn; ++i) {
        mask[i] = 1;
    }
    for (int i = 2; i < maxn; ++i) {
        if (mask[i] == 1) {
            for (int j = i; j < maxn; j += i) {
                mask[j] *= i;
            }
        }
    }
    for (int sum = 2; sum <= p + q; ++sum) {
        int l_a = 1, r_a = p;
        l_a = max(l_a, sum - q);
        r_a = min(r_a, sum - 1);
        int l_less = 0, r_less = sum / 2 + 1;
        while (l_less < r_less - 1) {
            int m_less = (l_less + r_less) / 2;
            if (m_less * 1LL * (sum - m_less) <= n * 1LL * sum) {
                l_less = m_less;
            } else {
                r_less = m_less;
            }
        }
        long long ans_old = ans;
        int vl_l = l_a, vl_r = r_a;
        vl_r = min(vl_r, l_less);
        if (vl_l <= vl_r) {
            ans += vl_r / mask[sum];
            ans -= (vl_l - 1) / mask[sum];
        }
        vl_l = l_a, vl_r = r_a;
        vl_l = max(vl_l, sum - l_less);
        if (vl_l <= vl_r) {
            ans += vl_r / mask[sum];
            ans -= (vl_l - 1) / mask[sum];
        }
        if (sum % 2 == 0 && (sum / 2) % mask[sum] == 0 && sum / 2 <= p && sum / 2 <= q && sum * 1LL * sum / 4 / sum <= n) {
            ans--;
        }
        // if (sum == 4) {
        //     cout << l_a << ' ' << r_a << ' ' << ans - ans_old << endl;
        // }
        // cout << sum << ": " << ans - ans_old << '\n';
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
