#include "ones.h"
#include <bits/stdc++.h>
using namespace std;

mt19937 rnd(1337 /*chrono::high_resolution_clock::now().time_since_epoch().count()*/);

pair<int, int> find_longest_subarray_of_ones(int n) {
    int init_cnt = flip_bits(vector<bool>(n, false));
    if (init_cnt == 0) return {0, -1};
    if (init_cnt == n) return {0, n - 1};
    vector<bool> toflip(n, false);
    int okpos = 0;
    for (int i = 0; i < n; ++i) {
        toflip[i] = true;
        int res = flip_bits(toflip);
        toflip[i] = false;
        if (res > init_cnt) {
            okpos = i;
            break;
        } else if (res < init_cnt) {
            okpos = i;
            toflip[i] = true;
            flip_bits(toflip);
            toflip[i] = false;
            break;
        }
    }
    int left = okpos;
    int right = okpos;
    int cnt = init_cnt;
    while (left > 0) {
        toflip[left - 1] = true;
        if (flip_bits(toflip) <= cnt) {
            flip_bits(toflip);
            toflip[left - 1] = false;
            --left;
        } else {
            flip_bits(toflip);
            toflip[left - 1] = false;
            break;
        }
    }
    while (right < n - 1) {
        toflip[right + 1] = true;
        if (flip_bits(toflip) <= cnt) {
            flip_bits(toflip);
            toflip[right + 1] = false;
            ++right;
        } else {
            flip_bits(toflip);
            toflip[right + 1] = false;
            break;
        }
    }
    assert(right - left + 1 == flip_bits(vector<bool>(n, false)));
    return {left, right};
}
