#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr int MOD = 1000000007;

ll binpow(int n, int k) {
    if (k == 0) return 1;
    if (k % 2 == 0) {
        ll t = binpow(n, k / 2);
        return t * t % MOD;
    }
    return n * binpow(n, k - 1) % MOD;
}

ll invert(int n) {
    return binpow(n, MOD - 2);
}
vector<ll> fact;

ll cnk(int n, int k) {
    return fact[n] * invert(fact[k]) % MOD * invert(fact[n - k]) % MOD;
}

int gcd(int a, int b) {
    if (b % a == 0) return a;
    if (a % 2 == 0 && b % 2 == 0) return 2;
    return __gcd(a, b);
}


/*
2 2 =>  1 1 (2)
3 6 =>  1 2 (3)
4 4 =>  1 1 (4)
4 12 => 1 3 (4)
6 3  => 2 1 (3)
6 6  => 1 1 (6)
6 12 => 1 2 (6)
8 8 => 1 1 (8)
10 10 => 1 1 (10)
12 4 => 3 1 (4)
12 6 => 2 1 (6)
 */

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    ll p, q, n;
    cin >> p >> q >> n;
    if (p > q) swap(p, q);
    ll ans = 0;
    for (ll a = 1; a <= p; ++a) {
//        if (a * 1ll * a > n) break;
        ll upper_bound = min(q, n / a);
//        ll kek = min({q, (q * a) / p, (p == n ? LLONG_MAX : n * a / (p - n))});
//        ll kek2 = min(kek, p);
//        ans += 2 * kek2 * p / a;
//        for (ll b = a; b <= kek2; ++b) {
//            if (__gcd(a, b) != 1) continue;
//            ans += 2 * ((p / a) / (a + b));
//        }
//        for (ll b = kek2 + 1; b <= kek; ++b) {
//            if (__gcd(a, b) != 1) continue;
//            ans += ((p / a) / (a + b));
//        }
        ll add = 0;
        for (ll b = 1; b <= upper_bound; ++b) {
            if (__gcd(a, b) != 1) continue;
//            if (a * b * (a + b) > n) break;
            ll max_d = min({p / a, q / b, n * 1ll * (a + b) / (a * 1ll * b)});
//            ll max_d_s = min({p / a, p / b, n * 1ll * (a + b) / (a * 1ll * b)});
            add += max_d / (a + b);// + max_d_s / (a + b);
            if (max_d < a + b) break;
//            cerr << ans << ' ';
        }
        if (add == 0) break;
        ans += add;
//        cerr << ans << '\n';
    }
    cout << ans;
    return 0;
}