#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

inline void solve(void) {
    int p, q, n;
    cin >> p >> q >> n;
    int ans = 0;
    for (int gc = 1; gc <= min(p, q); ++gc) {
        for (int a = 1; a <= gc; ++a) {
            if (a * gc > p) {
                break;
            }
            for (int b = 1; b <= gc; ++b) {
                if (b * gc > q) {
                    break;
                }
                if (gcd(a, b) == 1 && gc % (a + b) == 0 && (ll)gc * (ll)a * (ll)b / (ll)(a + b) <= n) {
                    ++ans;
                }
            }
        }
    }
    cout << ans << '\n';
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
