#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

int resh[25000001];
int ch[1025];
int wh[1025];

inline void solve(void) {
    int p, q, n; cin >> p >> q >> n;
    for (int i = 2; i <= n; ++i) {
        if (resh[i] == 0) {
            resh[i] = i;
            for (ll j = (ll)i * (ll)i; j <= (ll)n; j += i) {
                if (resh[j] == 0) {
                    resh[j] = i;
                }
            }
        }
    }
    vector<int> pr;
    pr.reserve(25);
    ch[0] = 1;
    for (int i = 0; i < 10; ++i) {
        wh[(1 << i)] = i;
    }
    ll ans = 0;
    for (int ab = 1; ab <= n; ++ab) {
        pr.clear();
        int tmp = ab;
        int lst = -1;
        while (tmp != 1) {
            if (resh[tmp] == lst) {
                pr.back() *= lst;
            } else {
                lst = resh[tmp];
                pr.push_back(lst);
            }
            tmp /= resh[tmp];
        }
        int a = 1, b = ab;
        ans += min(min((ll)p / ((ll)a * (ll)(a + b)), (ll)q / ((ll)b * (ll)(a + b))), (ll)n / (ll)ab);
        for (int mask = 1; mask < (1 << (int)pr.size()); ++mask) {
            ch[mask] = ch[(mask & (mask - 1))] * pr[wh[mask - (mask & (mask - 1))]];
            a = ch[mask];
            b = ab / a;
            ans += min(min((ll)p / ((ll)a * (ll)(a + b)), (ll)q / ((ll)b * (ll)(a + b))), (ll)n / (ll)ab);
        }
    }
    cout << ans << '\n';
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
