#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()
const int mod = 1e9 + 7;

int binpow(int a, int b) {
    int p = 1;
    while (b)
        if (b & 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b >>= 1;
    return p;
}

int n, k;
vector<int> a;
vector<int> fact(1e5 + 1, 1), inv_fact(1e5 + 1, 1);
int ans = 1;

void rec(int l, int r) {
    if (l + 1 >= r)
        return;
    int mx = l;
    for (int i = l; i < r; ++i)
        if (a[i] > a[mx])
            mx = i;
    int L = 0, R = 0;
    for (int i = l; i < mx; ++i)
        if (a[i] + a[mx] > k)
            ++L;
    for (int i = mx + 1; i < r; ++i)
        if (a[i] + a[mx] > k)
            ++R;
    (ans *= inv_fact[L + R + 1]) %= mod;
    (ans *= fact[L]) %= mod;
    (ans *= fact[R]) %= mod;
    rec(l, mx);
    rec(mx + 1, r);
}

void solve() {
    for (int i = 2; i < 1e5 + 1; ++i) {
        (fact[i] = fact[i - 1] * i) %= mod;
        inv_fact[i] = binpow(fact[i], mod - 2);
    }
    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    ans = fact[n];
//    cout << ans << "\n";
    rec(0, n);
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
