#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()
const int mod = 1e9 + 7;
const int R = 1 << 19;
const int inf = 2e9;
const int N = 3e5 + 1;

int binpow(int a, int b) {
    int p = 1;
    while (b)
        if (b & 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b >>= 1;
    return p;
}

int n, k;
vector<int> a;
vector<int> fact(N, 1), inv_fact(N, 1);
int ans = 1;
vector<pair<int, int>> sg_mx(2 * R);
vector<pair<int, int>> sg_mn(2 * R);
vector<int> alive(2 * R);
vector<pair<int, int>> MN(2 * R);


pair<int, int> get_mx(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return {-inf, -1};
    if (ql <= xl && xr <= qr)
        return sg_mx[x];
    int mid = (xl + xr) >> 1;
    return max(get_mx(x * 2, xl, mid, ql, qr), get_mx(x * 2 + 1, mid, xr, ql, qr));
}

pair<int, int> get_mn(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return {inf, -1};
    if (ql <= xl && xr <= qr)
        return sg_mn[x];
    int mid = (xl + xr) >> 1;
    return min(get_mn(x * 2, xl, mid, ql, qr), get_mn(x * 2 + 1, mid, xr, ql, qr));
}

int get_alive(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return alive[x];
    int mid = (xl + xr) >> 1;
    return get_alive(x * 2, xl, mid, ql, qr) + get_alive(x * 2 + 1, mid, xr, ql, qr);
}

struct mem {
    unordered_map<int, int> cnt, sizes;
    int sum = 0;

    void add(int x) {
        if (cnt[x] != 0)
            sizes[cnt[x]]--;
        if (sizes[cnt[x]] == 0)
            sizes.erase(cnt[x]);
        ++cnt[x];
        sizes[cnt[x]]++;
        ++sum;
    }

    void del(int i) {
        int x = a[i];
        int v = i + R;
        alive[v] = 0;
        sg_mn[v] = {inf, -1};
        sg_mx[v] = {-inf, -1};
        v >>= 1;
        while (v > 0) {
            sg_mx[v] = max(sg_mx[v * 2], sg_mx[v * 2 + 1]);
            sg_mn[v] = min(sg_mn[v * 2], sg_mn[v * 2 + 1]);
            alive[v] = alive[v * 2] + alive[v * 2 + 1];
            v >>= 1;
        }
        sizes[cnt[x]]--;
        if (sizes[cnt[x]] == 0)
            sizes.erase(cnt[x]);
        --cnt[x];
        if (cnt[x] == 0)
            cnt.erase(x);
        else
            sizes[cnt[x]]++;
        --sum;
    }
};

void del_only_mx(int v) {
    v += R;
    sg_mx[v] = {-inf, -1};
    v >>= 1;
    while (v > 0) {
        sg_mx[v] = max(sg_mx[v * 2], sg_mx[v * 2 + 1]);
        v >>= 1;
    }
}

void add_only_mx(int v) {
    v += R;
    sg_mx[v] = {a[v - R], v - R};
    v >>= 1;
    while (v > 0) {
        sg_mx[v] = max(sg_mx[v * 2], sg_mx[v * 2 + 1]);
        v >>= 1;
    }
}

void rec(int l, int r, mem &prev) {
    if (l + 1 >= r)
        return;
    auto[x, ind] = get_mx(1, 0, R, l, r);
    if (ind == -1)
        return;
    int gt = -1;
    while ((gt = get_mn(1, 0, R, l, r).second) != -1) {
        if (a[gt] + a[ind] > k)
            break;
        prev.del(gt);
    }

    (ans *= inv_fact[prev.sum]) %= mod;
    for (auto[x, y]:prev.sizes)
        (ans *= binpow(fact[x], y) % mod) %= mod;
    prev.del(ind);
    int pl = l;
    int pr = ind;
    int dl = ind + 1;
    int dr = r;
    if (get_alive(1, 0, R, l, ind) < get_alive(1, 0, R, ind + 1, r)) {
        swap(pl, dl);
        swap(pr, dr);
    }
    vector<int> remember;
    gt = -1;
    mem next;
    while ((gt = get_mx(1, 0, R, dl, dr).second) != -1) {
        remember.push_back(gt);
        del_only_mx(gt);
        prev.del(gt);
        next.add(a[gt]);
    }
    for (auto x:remember)
        add_only_mx(x);
    (ans *= fact[prev.sum]) %= mod;
    for (auto[x, y]:prev.sizes)
        (ans *= binpow(inv_fact[x], y) % mod) %= mod;
    (ans *= fact[next.sum]) %= mod;
    for (auto[x, y]:next.sizes)
        (ans *= binpow(inv_fact[x], y) % mod) %= mod;
    rec(pl, pr, prev);
    rec(dl, dr, next);
}

void solve() {
    for (int i = 2; i < N; ++i) {
        (fact[i] = fact[i - 1] * i) %= mod;
        inv_fact[i] = binpow(fact[i], mod - 2);
    }
    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sg_mx[i + R] = {a[i], i};
        sg_mn[i + R] = {a[i], i};
        alive[i + R]++;
    }
    for (int i = R - 1; i > 0; --i) {
        sg_mx[i] = max(sg_mx[i * 2], sg_mx[i * 2 + 1]);
        sg_mn[i] = min(sg_mn[i * 2], sg_mn[i * 2 + 1]);
        alive[i] = alive[i * 2] + alive[i * 2 + 1];
    }
    ans = fact[n];
    mem prev;

    for (int i = 0; i < n; ++i)
        prev.add(a[i]);

    for (auto[x, y]:prev.cnt)
        (ans *= inv_fact[y]) %= mod;
    rec(0, n, prev);
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
