/**
⣿⡟⠙⠛⠋⠩⠭⣉⡛⢛⠫⠭⠄⠒⠄⠄⠄⠈⠉⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⡇⠄⠄⠄⠄⣠⠖⠋⣀⡤⠄⠒⠄⠄⠄⠄⠄⠄⠄⠄⠄⣈⡭⠭⠄⠄⠄⠉⠙
⣿⡇⠄⠄⢀⣞⣡⠴⠚⠁⠄⠄⢀⠠⠄⠄⠄⠄⠄⠄⠄⠉⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⠄⡴⠁⡜⣵⢗⢀⠄⢠⡔⠁⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⡜⠄⡜⠄⠄⠄⠉⣠⠋⠠⠄⢀⡄⠄⠄⣠⣆⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⢸
⣿⠸⠄⡼⠄⠄⠄⠄⢰⠁⠄⠄⠄⠈⣀⣠⣬⣭⣛⠄⠁⠄⡄⠄⠄⠄⠄⠄⢀⣿
⣏⠄⢀⠁⠄⠄⠄⠄⠇⢀⣠⣴⣶⣿⣿⣿⣿⣿⣿⡇⠄⠄⡇⠄⠄⠄⠄⢀⣾⣿
⣿⣸⠈⠄⠄⠰⠾⠴⢾⣻⣿⣿⣿⣿⣿⣿⣿⣿⣿⢁⣾⢀⠁⠄⠄⠄⢠⢸⣿⣿
⣿⣿⣆⠄⠆⠄⣦⣶⣦⣌⣿⣿⣿⣿⣷⣋⣀⣈⠙⠛⡛⠌⠄⠄⠄⠄⢸⢸⣿⣿
⣿⣿⣿⠄⠄⠄⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠇⠈⠄⠄⠄⠄⠄⠈⢸⣿⣿
⣿⣿⣿⠄⠄⠄⠘⣿⣿⣿⡆⢀⣈⣉⢉⣿⣿⣯⣄⡄⠄⠄⠄⠄⠄⠄⠄⠈⣿⣿
⣿⣿⡟⡜⠄⠄⠄⠄⠙⠿⣿⣧⣽⣍⣾⣿⠿⠛⠁⠄⠄⠄⠄⠄⠄⠄⠄⠃⢿⣿
⣿⡿⠰⠄⠄⠄⠄⠄⠄⠄⠄⠈⠉⠩⠔⠒⠉⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠐⠘⣿
⣿⠃⠃⠄⠄⠄⠄⠄⠄⣀⢀⠄⠄⡀⡀⢀⣤⣴⣤⣤⣀⣀⠄⠄⠄⠄⠄⠄⠁⢹
*/
#ifdef LOCAL
    //#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
#include "ones.h"
using namespace std;
mt19937 rnd(101);

#define int long long
#define f first
#define s second
//#define endl '\n'
//#define double long double

const int mod=1000000007;

vector <int> fac,fac_inv;

int step(int a, int n)
{
    if (n==0)return 1;
    if (n==1)return a;
    int b=step(a,n/2);
    return b*b%mod*step(a,n%2)%mod;
}

int c(int n, int k)
{
    if (k<0)return 0;
    if (k>n)return 0;
    return fac[n]*fac_inv[k]%mod*fac_inv[n-k]%mod;
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL
    fac.resize(300001,1);
    fac_inv.resize(300001,1);
    for (int i=1; i<=300000; i++){
        fac[i]=fac[i-1]*i%mod;
        fac_inv[i]=step(fac[i],mod-2);
    }

    int n,k;
    cin >> n >> k;
    int ans=1;
    vector <int> a(n);
    for (int i=0; i<n; i++){
        cin >> a[i];
    }
    vector <pair <int,int> > b(n);
    for (int i=0; i<n; i++){
        b[i]={a[i],i};
    }
    sort(b.begin(),b.end());
    vector <int> now(n,1);

    for (int t=0; t<n; t++){
        int i=b[t].s;
        if (now[i]==0)continue;
        int q=1;
        int l=i,r=i;
        int cnt=1;
        now[i]=0;
        while (l-1>=0 && k>=a[i]+a[l-1]){
            l--;
            if (a[l]==a[i]){
                q++;
                now[l]=0;
            }
            cnt+=now[l];
        }
        while (r+1<n && k>=a[i]+a[r+1]){
            r++;
            if (a[r]==a[i]){
                q++;
                now[r]=0;
            }
            cnt+=now[r];
        }

        //cout << "? " << q << " " << cnt << " " << c(q+cnt-1,cnt-1) << endl;
        ans*=c(q+cnt-1,cnt-1);
        ans%=mod;
    }
    cout << ans << endl;
}
