#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? (a = b, 1) : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? (a = b, 1) : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 3e5 + 5;
const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

int bpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int n, k;
int a[N];
int L[N], R[N];

int brute() {
    ve<int> idx;
    fr (i, 1, n) {
        idx.pb(i);
    }

    int ans = 1;
    while (sz(idx) > 1) {
        int mn = 1e9;
        int pos = -1;
        fr (i, 0, sz(idx) - 1) {
            if (a[idx[i]] < mn) {
                mn = a[idx[i]];
                pos = i;
            }
        }

        fr (i, pos, pos) {
            int cnt = 1;
            fr (j, i + 1, sz(idx) - 1) {
                if (idx[j] > R[idx[i]]) {
                    break;
                }
                cnt++;
            }
            rf (j, i - 1, 0) {
                if (idx[j] < L[idx[i]]) {
                    break;
                }
                cnt++;
            }

            ans = mult(ans, cnt);
        }
        idx.erase(idx.begin() + pos);
    }
    return ans;
}

map<ve<int>, bool> have;

ve<int> now;

void rec() {
    if (have[now]) {
        return;
    }
    have[now] = 1;
    fr (i, 0, sz(now) - 2) {
        if (now[i] + now[i + 1] <= k) {
            swap(now[i], now[i + 1]);
            rec();
            swap(now[i], now[i + 1]);
        }
    }
}

int fact[N];
int ifact[N];

int rnd(int l, int r) {
    return rng() % (r - l + 1) + l;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    fact[0] = 1;
    fr (i, 1, N - 1) fact[i] = mult(fact[i - 1], i);
    ifact[N - 1] = bpow(fact[N - 1], MOD - 2);
    rf (i, N - 2, 0) {
        ifact[i] = mult(ifact[i + 1], i + 1);
    }

    cin >> n >> k;
    fr (i, 1, n) {
        cin >> a[i];
    }


    {
        ve<int> st;
        fr (i, 1, n) {

            int l = 0;
            int r = sz(st) - 1;
            while (l < r) {
                int mid = l + ((r - l + 1) >> 1);
                if (a[st[mid]] + a[i] > k) {
                    l = mid;
                } else {
                    r = mid - 1;
                }
            }

            if (sz(st) && a[st[l]] + a[i] > k) {
                L[i] = st[l] + 1;
            } else {
                L[i] = 1;
            }

            while (sz(st) && a[i] >= a[st.back()]) {
                st.pop_back();
            }
            st.pb(i);
        }
    }

    ve<bool> mark(n + 1);

    int res = 1;
    fr (i, 1, n) {
//        int p = i;
//        while (p - 1 >= 1 && a[p - 1] + a[i] <= k) {
//            p--;
//        }
//        L[i] = p;
//        p = i;

        int cnt = 0;
        int p = i;
        while (p + 1 <= n && a[p + 1] + a[i] <= k) {
            if (!mark[p + 1] && a[p + 1] == a[i]) {
                cnt++;
                mark[p + 1] = 1;
            }
            p++;
        }
        R[i] = p;

        if (cnt > 0) {
            res = mult(res, ifact[cnt + 1]);
        }
    }

    fr (i, 1, n) {
        cout << L[i] << " ";
    }
    cout << "\n";

    int ans = brute();

    cout << mult(ans, res) << "\n";

    return 0;
}
