#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

const int MOD = 1e9 + 7;

int add(int a, int b){
    a += b;
    if (a >= MOD){
        a -= MOD;
    }
    return a;
}

int sub(int a, int b){
    a -= b;
    if (a < 0){
        a += MOD;
    }
    return a;
}

int mul(int a, int b){
    return (a * 1ll * b) % MOD;
}

ll h(const vector<int>& a){
    ll res = 0;
    ll p = 1;
    for (int i = 0; i < a.size(); i++, p *= 10){
        res += a[i] * p;
    }
    return res;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    // freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--){
        int n, k;
        cin >> n >> k;
        vector<int> a(n);
        vector<int> uniq;
        for (int i = 0; i < n; i++){
            cin >> a[i];
            uniq.push_back(a[i]);
        }
        sort(all(uniq));
        uniq.erase(unique(all(uniq)), uniq.end());
        for (int i = 0; i < n; i++){
            a[i] = lower_bound(all(uniq), a[i]) - uniq.begin();
        }
        // vector<vector<int>> dp(n + 1, vector<int>(n + 1));
        // dp[1][a[1]] = 1;
        // for (int i = 2; i <= n; i++){
        //     for (int j = 0; j < uniq.size(); j++){
        //         dp[i][a[i]] = add(dp[i][a[i]], dp[i - 1][j]);
        //     }
        //     for (int j = 0; j < uniq.size(); j++){
        //         if (uniq[a[i]] + uniq[j] <= k){
        //             dp[i][j] = add(dp[i][j], dp[i - 1][j]);
        //         }
        //     }
        // }
        // int res = 0;
        // for (int j = 0; j < uniq.size(); j++){
        //     res = add(res, dp[n][j]);
        // }
        // cout << res << "\n";
        vector<bool> used(7 * 1e6);
        int res = 0;
        function<void(vector<int>)> rec = [&](vector<int> b){
            res++;
            used[h(b)] = 1;
            for (int i = 0; i + 1 < b.size(); i++){
                if (uniq[b[i]] + uniq[b[i + 1]] <= k){
                    swap(b[i], b[i + 1]);
                    if (!used[h(b)]){
                        rec(b);
                    }
                    swap(b[i], b[i + 1]);
                }
            }
        };
        rec(a);
        cout << res << "\n";
    }
    return 0;
}