#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = a; i <= b; i++)
#define rf(i, a, b) for (int i = a; i >= b; i--)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define pw(x) (1LL << (x))

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ook order_of_key
#define fbo find_by_order

template <typename T>
using ve = vector<T>;

template <typename T>
bool umx(T& a, T b) {return a < b ? a = b, 1 : 0;}

template <typename T>
bool umn(T& a, T b) {return a > b ? a = b, 1 : 0;}


using ll = long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int oo = 1e9;
const ll OO = 2e18;
const int mod = 1e9 + 7;
const int N = 3e5 + 100;


int n;
int a[N];
int W;

int spar[N][20];
int st[N];

int mul(int a, int b) {
    return 1LL * a * b % mod;
}

void muls(int& a, int b) {
    a = mul(a, b);
}

int get(int l, int r) {
    int ln = r - l + 1;
    int ret = max(spar[l][st[ln]], spar[r - pw(st[ln]) + 1][st[ln]]);
    return ret;
}

int len[N];

oset <pii> fenv[N];
void add(pii val, int ps) {
    while(ps < n) {
        fenv[ps].insert(val);
        ps = (ps|(ps + 1));
    }
}

int gt(pii val, int ps) {
    int ret = 0;
    while(ps >= 0) {
        ret += fenv[ps].ook(val);
        ps = (ps&(ps + 1)) - 1;
    }
    return ret;
}

map <ve <int>, bool> mp;

void rec(ve <int> A) {
    fr(i, 0, n - 1) {
        if (i < n - 1 && A[i] + A[i + 1] <= W) {
            swap(A[i], A[i + 1]);
            if (!mp[A]) {
                mp[A] = 1;
                rec(A);
            }
            swap(A[i], A[i + 1]);
        }
    }
}


void brute() {
    ve <int> A;
    fr(i, 0, n - 1) A.pb(a[i]);
    mp[A] = 1;
    rec(A);
    cout << sz(mp) << "\n";
}
ve <int> A;
int ps[N];

int T[4 * N];
void build(int v, int tl, int tr) {
    if(tl == tr) {T[v] = a[tl]; return;}
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    T[v] = max(T[v << 1], T[v << 1 | 1]);
}
int get(int v, int tl, int tr, int l, int r) {
    if (l > r) return 0;
    if (tl == l && tr == r) return T[v];
    int tm = (tl + tr) >> 1;
    return max(get(v << 1, tl, tm, l, min(r, tm)), get(v << 1 | 1, tm + 1, tr, max(l, tm + 1), r));
}
void upd(int v, int tl, int tr, int ps, int vl) {
    if (tl == tr) {T[v] = vl;return;}
    int tm = (tl + tr) >> 1;
    if (tm < ps) upd(v << 1 | 1, tm + 1, tr, ps, vl);
    else upd(v << 1, tl, tm, ps, vl);
    T[v] = max(T[v << 1], T[v << 1 | 1]);
}


bool cmp(int x, int y) {
    bool c = (x < y);
    int l = ps[x] + 1;
    int r = ps[y] - 1;
    int mx = get(1, 0, n - 1, l, r);
    c &= (x + y <= W && mx + max(x, y) <= W);
    if (c) {
        swap(ps[x], ps[y]);
        upd(1, 0, n - 1, ps[x], x);
        upd(1, 0, n - 1, ps[y], y);
    }
    return c;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> W;
    a[n] = oo;
    fr(i, 0, n - 1) {
        cin >> a[i];
    }
    fr(i, 0, n - 1) {
        A.pb(a[i]);
        ps[a[i]] = i;
    }
    build(1, 0, n - 1);

//    sort(a, a + n, cmp);
//    return 0;
//    fr(i, 0, n - 1) cout << a[i] << " ";
//    cout << "\n";
    fr(i, 0, n - 1) {
        int ptr = i;
        while(ptr > 0 && a[ptr] + a[ptr - 1] <= W && a[ptr] < a[ptr - 1]) {
            swap(a[ptr], a[ptr - 1]);
            ptr--;
        }
    }

    fr(i, 0, n - 1) {
        spar[i][0] = a[i];
    }
    spar[n][0] = oo;
    int nn = n + 1;
    {
        fr(i, 1, 19) {
            fr(ps, 0, nn - pw(i)) {
                spar[ps][i] = max(spar[ps][i - 1], spar[ps + pw(i - 1)][i - 1]);
            }
        }
        int ptr = 0;
        fr(i, 1, n) {
            if (i > pw(ptr + 1)) ptr++;
            st[i] = ptr;
        }
    }


    int res = 1;
    fr(i, 0, n - 1) {
        int cnt = 0;
        {
            int l = i + 1;
            int r = n;
            while (l < r) {
                int md = (l + r) >> 1;
                if (get(i + 1, md) + a[i] <= W) l = md + 1;
                else r = md;
            }
            muls(res, r - i);
            cnt = r - i;
            len[i] = r - 1;
            add({len[i], i}, i);
        }
    }


    cout << res << "\n";
    return 0;
}
