#include "ones.h"
#define dcout \
    if (false) cout

#include <bits/stdc++.h>

using namespace std;

vector<bool> lst;
int _flip_bits(vector<bool> flips, bool tmp = false) {
    vector<bool> xored(flips.size());
    for (int i = 0; i < flips.size(); i++) {
        xored[i] = lst[i] ^ flips[i];
    }
    int res = flip_bits(xored);
    if (tmp) {
        lst = flips;
    } else {
        fill(lst.begin(), lst.end(), 0);
    }
    return res;
}

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> no_flips(n);
    lst = no_flips;
    int base = _flip_bits(no_flips);
    srand(time(0));
    while (true) {
        vector<bool> flips(n);
        for (int i = 0; i < n; i++) {
            flips[i] = rand() & 1;
        }
        // dcout << "X ";
        // for (int i = 0; i < n; i++) {
        //     dcout << lst[i] << " ";
        // }
        // dcout << " WITH ";
        // for (bool f : flips) {
        //     dcout << f << " ";
        // }
        // dcout << endl;
        int val_l = base;
        int val_r = _flip_bits(flips, true);
        if (val_r == base) {
            continue;
        }
        dcout << val_l << " " << val_r << "!" << endl;
        vector<int> idxs;
        dcout << "mask: ";
        for (int i = 0; i < n; i++) {
            dcout << flips[i] << " ";
            if (flips[i]) {
                idxs.push_back(i);
            }
        }
        dcout << endl;
        dcout << "idxs: ";
        for (int i : idxs) {
            dcout << i << " ";
        }
        dcout << endl;

        int l = 0, r = idxs.size() - 1;
        int tmp = val_r;
        while (l < r) {
            int mid = (l + r) / 2;
            dcout << " ? " << mid << endl;
            vector<bool> cur_flips(n);
            for (int i = 0; i <= mid; i++) {
                cur_flips[idxs[i]] = true;
            }
            tmp = _flip_bits(cur_flips, true);
            if (tmp == val_l) {
                l = mid + 1;
                val_l = tmp;
            } else {
                r = mid;
                val_r = tmp;
            }
        }
        int x = idxs[l];
        dcout << x << "!" << val_l << " -> " << val_r << endl;
        vector<bool> cur_flips(n);
        for (int i = 0; i <= l; i++) {
            cur_flips[idxs[i]] = true;
        }
        if (val_r > val_l) {
            l = x, r = min(n - 1, x + val_r - 1);
            int cur = tmp;
            while (l < r) {
                int mid = (l + r + 1) / 2;
                dcout << " ? " << mid << endl;
                vector<bool> tmp_flips = cur_flips;
                tmp_flips[mid] = true;
                cur = _flip_bits(tmp_flips, true);
                if (cur >= val_r) {
                    r = mid - 1;
                } else {
                    l = mid;
                }
            }
            return {l - val_r + 1, l - val_r + cur};
        } else {
            swap(val_l, val_r);
            cur_flips[idxs[l]] = false;
            l = x, r = min(n - 1, x + val_r - 1);
            int cur = tmp;
            while (l < r) {
                int mid = (l + r + 1) / 2;
                vector<bool> tmp_flips = cur_flips;
                tmp_flips[mid] = true;
                cur = _flip_bits(tmp_flips, true);
                if (cur >= val_r) {
                    r = mid - 1;
                } else {
                    l = mid;
                }
            }
            return {l - val_r + 1, l - val_r + cur};
        }
    }
    return {0, -1};
}
