#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int mx = 2.5e7 + 4;

ll ps[mx];

ll sqr_part(ll x) {
    ll r = 1;
    while (x > 1) {
        ll p = ps[x];
        ll p2 = p * p;
        while (x % (p2) == 0) {
            x /= p2;
            r *= p;
        }
        if (x % p == 0) {
            r *= p;
            x /= p;
        }
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    for (int i = 2; i < mx; i++) {
        if (ps[i]) {
            continue;
        }
        ps[i] = i;
        for (int j = i; j < (mx + i - 1) / i; j++) {
            if (ps[j * i] == 0) {
                ps[j * i] = i;
            }
        }
    }

    ll p, q, n;
    cin >> p >> q >> n;
    ll res = 0;
    for (ll s = 4; s <= p + q; s++) {
        ll a_l = max(1LL, s - q);
        ll a_r = min(s - 1, p - 1);
        if (s >= 4 * n) {
            a_r =
                min(a_r, -1LL + (s + (ll)sqrtl(s * (s - 4LL * n)) + 1LL) / 2LL);
            a_l = max(a_l, 1LL + (s - (ll)sqrtl(s * (s - 4LL * n))) / 2LL);
        }
        ll base = sqr_part(s);
        // cout << s << ": " << a_l << " -> " << a_r << endl;
        res += (a_r / base) - ((a_l - 1) / base);
        // cout << res << "!" << endl;
    }
    cout << res << "\n";
    // for (ll a = 2; a <= p; a++) {
    //     ll cnt = 0;
    //     for (ll b = 2; b <= min(q, a); b++) {
    //         if ((a * b) / (a + b) > n) {
    //             break;
    //         }
    //         if ((a * b) % (a + b) == 0) {
    //             cnt++;
    //             // cout << "  " << b << endl;
    //         }
    //         res += ((a * b) % (a + b) == 0);
    //     }
    //     cout << (cnt - (1 - (a % 2))) << " ";
    // }
    // cout << endl;
    // cout << res << "\n";
    return 0;
}

/*
20000 20000 1000000000
*/