// Ones.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include "ones.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;
typedef vector<int> vi;
typedef vector<bool> vb;

std::pair<int, int> find_longest_subarray_of_ones(int n)
{
	vb mask(n, 1);
	flip_bits(mask);
	int len = flip_bits(mask);
	int l = 0, r = n - 1, mid;
	while (l < r)
	{
		mid = (l + r) / 2;
		fill(mask.begin(), mask.end(), false);
		for (int i = l; i <= mid; i++) mask[i] = true;
		int l = flip_bits(mask);
		if (l > len)
		{
			r = mid; len = l;
		}
		else if(l == len)
		{
			vb temp_mask(n, false);
			temp_mask[mid] = true;
			int temp_len1 = flip_bits(mask);
			if (temp_len1 == len + 1)
			{
				vb temp_mask2 = mask;
				temp_mask2[mid] = false;
				int temp_len2 = flip_bits(temp_mask2);
				if (temp_len2 == temp_len1)
				{
					return { mid, mid + temp_len2 };
				}
				else l = mid + 1;
			}
		}
		else
		{
			flip_bits(mask);
			r = mid;
		}
	}
	return { l, l + len - 1 };
}

