#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;
typedef vector<pii> vp;

vi arr;
vi rightn;
vi leftn;
map<int, int> id;


void find(int k) {
	for (int i = 0; i < arr.size(); i++) {
		for (int j = i-1; j >= 0; j--) {
			if (arr[i] + arr[j] > k) {
				leftn[id[arr[i]]] = arr[j];
				break;
			}
		}

		for (int j = i+1; j < arr.size(); j++) {
			if (arr[i] + arr[j] > k) {
				rightn[id[arr[i]]] = arr[j];
				break;
			}
		}
	}
}


bool inBetween(int index, vi &order) {

	bool r = false;
	if (rightn[id[order[index]]] == -1)r = true;
	for (int i = index + 1 ; i < arr.size(); i++) {
		if (r)break;
		if (order[i] == rightn[id[order[index]]])r = true;
	}
	bool l = false;
	if (leftn[id[order[index]]] == -1)l = true;

	for (int i = index - 1; i >=0; i--) {
		if (l)break;
		if (order[i] == leftn[id[order[index]]])l = true;
	}

	return (r && l);
}

bool ok(vi& order) {
	for (int i = 0; i < arr.size(); i++) {
		bool curr = inBetween(i, order);
		if (!curr)return false;
	}
	return true;
}

int count(vi arr) {

	sort(arr.begin(), arr.end());
	int ans = 0;
	do
	{
		if (ok(arr))ans++;
	} while (next_permutation(arr.begin(), arr.end()));
	return ans;
}




int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	arr.resize(n);
	rightn.resize(n, -1);
	leftn.resize(n,-1);
	//id.resize(n);
	//vp sorted(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		id[arr[i]] = i;
		//sorted[i] = { arr[i],i };
	}
	find(k);

	//sort(sorted.begin(), sorted.end());
	//for (int i = 0; i < n; i++) {
		//id[sorted[i].first] = sorted[i].second;
	//}

	int ans = count(arr);
	cout << ans;
	
	return 0;
}