#include "ones.h"
#include <iostream>
#include <vector>
using namespace std;
typedef vector<bool> vb;
typedef pair<int, int> pii;

vb& operator^(vb& A, vb& B)
{
	vb C(A.size());
	for (int i = 0; i < A.size(); i++)
		C[i] = A[i] ^ B[i];
}

pii bin( int n,int l,int r,int m,int x)
{
	int l1 = l, r1 = m - 1;
	while (l1 < r1)
	{
		int m1 = (l1 + r1) / 2;
		vb tmp(n, false);
		tmp[m1] = true;
		if (flip_bits(tmp) != x)
		{
			flip_bits(tmp);
			r1 = m1;
		}
		else
			l1 = m1 + 1;
	}
	int l2 = m + 1, r2 = r;
	while (l2 < r2 - 1)
	{
		int m2 = (l2 + r2) / 2;
		vb tmp(n, false);
		tmp[m2] = true;
		if (flip_bits(tmp) != x)
		{
			flip_bits(tmp);
			r2 = m2;
		}
		else
			l2 = m2;
	}
	return { l1,l2 };
}

pii find_longest_subarray_of_ones(int n)
{
	vb all(n, true);
	int l = 0, r = n;
	int x = flip_bits(vb(n, false));
	while (l < r-1)
	{
		int X = flip_bits(all);
		if (X >= x)
			x = X;
		else
			flip_bits(all);
		int m = (l + r) / 2;
		vb temp(n, false);
		for (int i = l; i <= m; i++)
			temp[i] = true;
		vb tmp(n, false);
		tmp[m] = true;
		int y = flip_bits(temp);
		if (y > x)
		{
			return bin(n, l, r, m, y);
		}
		else if (y == x)
		{			
			if (flip_bits(tmp) == x)
				for (; l <= m; l++)//i couldnt prove this part works, i also think it doesn't, but i have 15 mins 
					all[l] = false;
			else
				return bin(n, l, r, m, x);
		}
		else
		{
			if (flip_bits(tmp ^ all) == x) 
			{
				for (; r > m; r--)
					all[r] = false;
				all[r] = false;
			}
			else
			{
				flip_bits(tmp);
				return bin(n, l, r, m, x);
			}
		}
	}
	//i'm not sure what to return here
	return { l,r - 1 };
}