#include<ext/pb_ds/assoc_container.hpp>
#include<bits/stdc++.h>
using namespace std;
using ll = long long;

const ll mod = 1000000007;
const int mx = 300005;
ll mpow(ll b, ll e) {
	ll r = 1;
	while(e) {
		if(e & 1)
			r = (r * b) % mod;
		b = (b * b) % mod;
		e /= 2;
	}
	return r;
}
ll fact[mx*2];
ll invf[mx*2];
ll nck(ll n, ll k) {
	return (((fact[n] * invf[k]) % mod) * invf[n - k]) % mod;
}
ll N, K;
vector<ll> nums;
set<int> inds;
ll solve(int l, int r, set<pair<ll, ll>> & s) {
	if(r < l) return 1;
	//cout << l << " " << r << endl;
	if(s.size() == 0) return 1;
	auto & [best_val, best_pos] = *s.rbegin();
	inds.erase(best_pos);
	s.erase(*s.rbegin());
	if(s.size() == 0) return 1;
	ll ans = 1;
	int cnt = 0;
	int last = s.begin()->first;
	for(auto it = s.begin(); it != s.end();) {
		if(it->first + best_val > K) break;
		if(it->first != last) {
			ans = (ans * nck(s.size() + 1 + cnt, cnt)) % mod;
			last = it->first;
			cnt = 0;
		}
		cnt++;
		inds.erase(it->second);
		it = s.erase(it);
	}
	ans = (ans * nck(s.size() + 1 + cnt, cnt)) % mod;
	set<pair<ll, ll>> s2;
	int l1 = l, r1 = best_pos - 1;
	int l2 = best_pos + 1, r2 = r;
	if((r1 - l1) > (r2 - l2)) {
		swap(l1, l2);
		swap(r1, r2);
	}
	for(auto it = inds.lower_bound(l1); it != inds.upper_bound(r1); it++) {
		int i = *it;
		if(s.find({nums[i], i}) != s.end()) {
			s.erase({nums[i], i});
			s2.insert({nums[i], i});
		}
	}
	ans = (ans * solve(l1, r1, s2)) % mod;
	ans = (ans * solve(l2, r2, s)) % mod;
	return ans;
}

main() {
	fact[0] = 1;
	for(int i = 1; i < mx*2; i++) {
		fact[i] = (i * fact[i - 1]) % mod;
	}
	invf[mx*2 - 1] = mpow(fact[mx*2 - 1], mod - 2);
	for(int i = mx*2 - 2; i >= 0; i--) {
		invf[i] = (invf[i + 1] * (i + 1)) % mod;
	}
	cin >> N >> K;
	nums.resize(N);
	for(ll & i : nums) cin >> i;
	set<pair<ll, ll>> s;
	inds.clear();
	for(int i = 0; i < N; i++) {
		s.insert({nums[i], i});
		inds.insert(i);
	}
	cout << solve(0, N - 1, s);
}
