std::pair<int, int> find_longest_subarray_of_ones(int n) {

    int l=0, r=n-1;
    vector<bool> scuza(n,0);
    int norm=flip_bits(scuza);
    if (norm==0) {
        scuza.assign(n,1);
        flip_bits(scuza);
        return {0,n-1};
    }
    if (norm==n) {
        return {0,n-1};
    }

    while (l<r) {
        scuza[l]=1;
        int x=flip_bits(scuza);
        //cout<<"! "<<x<<' '<<norm<<'\n';
        if (x<norm) {
            norm=flip_bits(scuza);
            break;
        } else {
            norm=max(norm,x);
        }
        scuza[l]=0;
        ++l;
    }
    scuza.assign(n,0);
    while (l<r) {
        scuza[r]=1;
        int x=flip_bits(scuza);
        if (x<norm) {
            norm=flip_bits(scuza);
            break;
        } else {
            norm=max(norm,x);
        }
        scuza[r]=0;
        --r;
    }
    //cout<<"! "<<l<<' '<<r<<'\n';
    scuza.assign(n,0);
    --l, ++r;
    while (l>=0) {
        scuza[l]=1;
        int x=flip_bits(scuza);
        if (x>norm) {
            norm=x;
        } else {
            norm=flip_bits(scuza);
        }
        scuza[l]=0;
        --l;
    }
    while (r<n) {
        scuza[r]=1;
        int x=flip_bits(scuza);
        if (x>norm) {
            norm=x;
        } else {
            norm=flip_bits(scuza);
        }
        scuza[r]=0;
        ++r;
    }
    return {0,n-1};
}