#include "ones.h"
#include "bits/stdc++.h"
using namespace std;

#define ll long long

#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back


mt19937 rng(156);

pair<int,int> find_longest_subarray_of_ones(int n) {
    vector<bool> ask(n, 0);
    int len = flip_bits(ask);
    if(len == n) {
        return {0, n - 1};
    } else if(!len) {
        return {0, -1};
    }

    vector<int> queries(n, 0);
    iota(all(queries), 0);
    shuffle(all(queries), rng);
    int prev = -1;
    for(int i = n - 1; i >= 0; --i) {
        if(i - len < 0) continue;
        ask[i] = 1;
        if(prev != -1) {
            ask[prev] = 1;
        }
        int f = flip_bits(ask);
        if(prev != -1) ask[prev] = 0;
        ask[i] = 0;
        prev = i;
        if(f > len) {
            ask[i] = 1;
            flip_bits(ask);
            return {i - len, i - 1};
        }
    }
}
