#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

pair<int,int> find_longest_subarray_of_ones(int n) {
    vector <bool> bts (n, 0);
    int k = flip_bits(bts);
    if (k == n) return make_pair(0, n-1);
    if (k == 0) return make_pair(0, -1);
    for (int i = 0; i < n; i++){
        bts[i] = 1;
        int now = flip_bits(bts);
        if (now == n) return make_pair(0, n-1);
        if (now == 0) return make_pair(0, -1);
        bts[i] = 0;
        if (now > k) { // this is somewhere inside the sequence
            // cout << i << "\n";
            int l = 0, r = i, rs1 = -1, rs2 = -1;
            while (l <= r) {
                int mid = (l + r) / 2;
                bts[mid] = 1;
                if (flip_bits(bts) < now) {
                    r = mid - 1;
                    rs1 = mid;
                }
                else {
                    l = mid + 1;
                }
                flip_bits(bts);
                bts[mid] = 0;
            }
            l = i, r = n - 1;
            while (l <= r) {
                int mid = (l + r) / 2;
                bts[mid] = 1;
                if (flip_bits(bts) < now) {
                    l = mid + 1;
                    rs2 = mid;
                }
                else {
                    r = mid - 1;
                }
                flip_bits(bts);
                bts[mid] = 0;
            }
            // cout << rs1 << " " << rs2 << "\n";
            return make_pair(rs1, rs2);
        }
        k = now;
    }
    assert(0);
    return make_pair(-1, -1);
}