#include <bits/stdc++.h>

#define ff first
#define ss second
#define PHB push_back
#define UBD upper_bound
#define sz(w) ((int) w.size())
#define rng(w) w.begin(), w.end()
#define fastio ios::sync_with_stdio(false); cin.tie(nullptr);
#define ln '\n'
#define nwln cout<<ln;

using namespace std;

typedef bool oo;
typedef pair<int, int> pi;
typedef long long ll;
typedef vector<int> vri;

const int mod = (1e9 + 7);
const int MAXN = (3e5 + 3);

// we just need a static seg tree
int N, K, t[MAXN<<2];
vri w, x, y;
ll ans, fact[MAXN];

void build(int v, int tl, int tr) {
	if(tl == tr) t[v] = w[tl];
	else {
		int tm = (tl+tr)>>1;
		build(v<<1, tl, tm);
		build((v<<1)|1, tm+1, tr);
		t[v] = max(t[v<<1], t[(v<<1)|1]);
	}
}

int min_id(int v, int lv, int rv, int l, int r, int val) {
	if((lv>r) || (rv<l)) return -1;
	
	if((l<=lv) && (rv<=r)) {
		if(t[v] <= val) return -1;
		
		while(lv != rv) {
			int mid = (rv+lv)>>1;
			if(t[v<<1] > val) v <<= 1, rv = mid;
			else v <<= 1, v |= 1, lv = mid+1;
		}

		return lv;
	}

	int mid = (rv+lv)>>1;
	int pos = min_id(v<<1, lv, mid, l, r, val);

	if(pos != -1) return pos;
	return min_id((v<<1)|1, mid+1, rv, l, r, val);
}

int max_id(int v, int lv, int rv, int l, int r, int val) {
	// cout<<"Vertex "<<v<<" cover ["<<lv<<", "<<rv<<"]"<<ln;
	if((lv>r) || (rv<l)) return -1;

	if((l<=lv) && (rv<=r)) {
		if(t[v] <= val) return -1;
		
		while(lv != rv) {// changed
			int mid = (rv+lv)>>1;
			if(t[(v<<1)|1] > val) v<<=1, v|=1, lv = mid+1;
			else v <<= 1, rv = mid;
		}

		return lv;
	}

	int mid = (rv+lv)>>1;
	int pos = max_id((v<<1)|1, mid+1, rv, l, r, val);

	if(pos != -1) return pos;
	return max_id(v<<1, lv, mid, l, r, val);
}

ll bp(ll a, ll b = (mod-2)) {
	ll res = 1;

	while(b) {
		if(b&1) res = (res*a) % mod;
		a = (a*a) % mod, b >>= 1;
	}

	return res;
}

void go(int L, int R) {
	map<int, int> freq;
	for(int i=L; i<=R; ++i) ++freq[w[i]];
	
	ans *= fact[R-L+1], ans %= mod;
	for(pi z: freq) ans *= bp(fact[z.ss]), ans %= mod;
}

int main()
{
	fastio
	cin>>N>>K, w.resize(N);

	fact[0] = 1;
	for(int i=1; i<=N; ++i) fact[i] = (i*fact[i-1])%mod;
	
	for(int i=0; i<N; ++i) cin>>w[i];
	build(1, 0, N-1);

	for(int i=0; i<N; ++i) {
		int l = max_id(1, 0, N-1, 0, i-1, K-w[i]);
		int r = min_id(1, 0, N-1, i+1, N-1, K-w[i]);
		
		if(r == -1) r = N;
		x.PHB(++l), y.PHB(--r);
	}

	vri b = w, pos(N);
	for(int i=0; i<N; ++i) pos[b[i]] = i;
	sort(rng(b));

	do {
		oo flag = false;

		for(int i=0; i<N; ++i) {
			int j = pos[b[i]];
			flag |= (x[i] > j);
			flag |= (y[i] < j);
		}

		ans += (!flag);
	} while(next_permutation(rng(b)));

	cout<<ans<<ln;

	return 0;
}
