#include <bits/stdc++.h>
#include "ones.h"

#pragma GCC optimize("Ofast")


#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int nrbits = 13;

int N;
int last = 0;

int intreaba(vector <int> v){
    vector <bool> flip(N, 0);
    for(auto x : v)
        flip[x] = 1;
    return flip_bits(flip);
}

pii inSecv(int x){
    int r = x, pas = (1 << nrbits);
    while(pas){
        if(r - pas >= 0){
            vector <int> toFlip;
            toFlip.push_back(r - pas);
            int rez = intreaba(toFlip);
            if(rez < last)
                r -= pas;
            intreaba(toFlip);
        }
        pas /= 2;
    }
    return {r, r + last - 1};
}

pair <int, int> solveBrut(vector <int> v){
    vector <int> toFlip;
    for(auto x : v){
        toFlip.clear();
        toFlip.push_back(x);
        int rez = intreaba(toFlip);
        if(rez != last){
            if(rez > last){
                last = rez;
            }else{
                intreaba(toFlip);
            }
            return inSecv(x);
        }
    }
    return {0, N - 1};
}

pair<int, int> find_longest_subarray_of_ones(int n){
    N = n;
    srand(time(0));
    vector <int> ind;
   ind.clear();
    last = intreaba(ind);
    if(last == n){
        return {0, n - 1};
    }
    for(int i = 0; i < n; i+=max(1, last)){
        ind.push_back(i);
    }
    return solveBrut(ind);
}
