#include <vector>
#include <utility>
#include <cassert>
#include <iostream>
#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

static int _n;
static std::vector<bool> _a;
static long long num_queries;

/*
static int longest_seq_of_1s(){
    int ans = 0, curr = 0;
    for(int i = 0; i < _n; ++i){
        if(_a[i]){
            ++curr;
        }
        else{
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips){
    assert((int)flips.size() == _n);
    ++num_queries;
    for(int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];
    return longest_seq_of_1s();
}*/

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    vector <bool> v(n);
    fill(v.begin(), v.end(), 0);
    int a = flip_bits(v), l, r;
    v[0] = 1;
    if(flip_bits(v) < a) {
        flip_bits(v);
        return make_pair(0, a - 1);
    }
    flip_bits(v);
    for(int i = 0; i < n; i++) {
        v[i] = 1;
        int x = flip_bits(v);

        if(i > 0)
            v[i - 1] = 0;

        if(x > a && i + a < n) {
            a = x;
            //cout << i << " " << a << " " << x << "\n";
            int poz;
            while(i >= 0) {
                v[i] = 1;
                int val = flip_bits(v);
                if(val == a - 1) {
                    poz = i;
                }
                flip_bits(v);
                v[i] = 0;
                i--;
            }
            return {poz, poz + a - 1};
        }

    }
}

/*
1
3
1 0 1

1
9
1 0 1 0 0 0 1 1 0

1
5
1 0 0 1 0
*/

/*
int main(){
    int t;
    std::cin >> t;
    srand(time(0));

    long long max_qs = 0;

    while(t--){
        num_queries = 0;

        //std::cin >> _n;
        _n = rand() % 10 + 1;
        cout << _n << "\n";
        _a.resize(_n);
        for(int i = 0; i < _n; ++i){
            bool val;
            //std::cin >> val;
            val = rand() % 2;

            _a[i] = val;
            cout << _a[i] << " ";
        }
        cout << "\n";

        auto [l, r] = find_longest_subarray_of_ones(_n);
        if(longest_seq_of_1s() != r - l + 1){
            std::cout << "0\n";
            return 0;
        }
        if(l == 0 && r == -1){
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if(r < l || l < 0 || l >= _n || r < 0 || r >= _n){
            std::cout << "0\n";
            return 0;
        }

        for(int i = l; i <= r; ++i){
            if(_a[i] != 1){
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
    }

    std::cout << "1 " << max_qs << "\n";
    return 0;
}*/

