#include "ones.h"
#include <random>
#include <ctime>

using namespace std;

mt19937 rng(time(NULL));

pair <int, int> find_longest_subarray_of_ones(int n)
{
    vector <bool> aux;
    aux.resize(n);
    int init_max = flip_bits(aux);
    if(init_max == 0)
        return {0, -1};
    if(init_max == n)
        return {0, n - 1};
    for(int i = 1; i <= 60; i++)
    {
        int poz = rng() % n;
        aux[poz] = 1;
        int curr = flip_bits(aux);
        if(curr > init_max)
        {
            int add = curr - init_max - 1, st, dr;
            st = poz - add;
            dr = st + curr - 1;
            return {st, dr};
        }
    }
}
