#include "ones.h"
#include <iostream>
#include <random>
#include <ctime>

using namespace std;

mt19937 rng(time(NULL));

pair <int, int> find_longest_subarray_of_ones(int n)
{
    vector <bool> aux;
    aux.resize(n);
    int init_max = flip_bits(aux);
    if(init_max == 0)
        return {0, -1};
    if(init_max == n)
        return {0, n - 1};
    for(int i = 1; i <= 1000; i++)
    {
        int poz = rng() % n;
        if(poz == 2)
            continue;
        //cout << poz << '\n';
        aux[poz] = 1;
        int st, dr, curr = flip_bits(aux);
        if(curr == 0)
            return {0, -1};
        if(curr == n)
            return {0, n - 1};
        if(curr == 2 * init_max + 1)
        {
            st = poz - init_max;
            dr = poz + init_max;
            return {st, dr};
        }
        if(curr > init_max)
        {
            if(poz == n - 1)
            {
                st = n - curr;
                dr = poz;
                return {st, dr};
            }
            if(poz == 0)
            {
                st = 0;
                dr = curr - 1;
                return {st, dr};
            }
            int init2 = curr - init_max - 1;
            /// CHECKING IF LEFT OR RIGHT
            aux[poz] = 0;
            if(init2 == 0)
            {
                int poz2 = poz - 1;
                aux[poz2] = 1;
                int curr2 = flip_bits(aux);
                flip_bits(aux);
                if(curr2 < curr)
                {
                    st = poz - curr + 1;
                    dr = poz;
                    return {st, dr};
                }
                else
                {
                    st = poz;
                    dr = st + curr - 1;
                    return {st, dr};
                }
            }
            int poz2 = poz - init2;
            aux[poz2] = 1;
            int curr2 = flip_bits(aux);
            flip_bits(aux);
            aux[poz2] = 0;
            //cout << poz2 << ' ' << curr << ' ' << curr2;
            if(curr2 >= curr)
            {
                st = poz - init2;
                dr = st + curr - 1;
            }
            else
            {
                st = poz - init_max;
                dr = st + curr - 1;
            }
            return {st, dr};
        }
        flip_bits(aux);
        aux[poz] = 0;
    }
}
