#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

map <int, int> used;

vector <int> get_div(int n)
{
    vector <int> aux;
    for(int i = 1; i * i <= n; i++)
    {
        if(n % i != 0)
            continue;
        aux.push_back(i);
        if(n/i != i)
            aux.push_back(n/i);
    }
    sort(aux.begin(), aux.end());
    return aux;
}

int main()
{
    int p, q, n;
    long long ans = 0;
    cin >> p >> q >> n;
    for(int a = 1; a <= p; a++)
    {
        vector <int> aux = get_div(a);
        int b, c;
        for(int elem : aux)
        {
            if(elem > q)
                break;
            if(elem * elem > a)
            {
                b = elem * elem - a;
                c = (a * b) / (a + b);
                if(c <= n && b <= q)
                {
                    ans++;
                    used[b] = a;
                }
            }
            b = a * (elem - 1);
            c = (a * b) / (a + b);
            if(elem != 1 && c <= n && used[b] != a && b <= q)
            {
                ans++;
                used[b] = a;
            }
        }
    }
    cout << ans;
    return 0;
}
