#include "ones.h"
unsigned seed = chrono :: system_clock :: now().time_since_epoch().count();
mt19937 rng(seed);
std::vector <bool> randv(int n) {
    std::vector <bool> v(n);
    for(int i = 0; i < n; i++)
        v[i] = rng() & 1;
    return v;
}
std::pair<int, int> find_longest_subarray_of_ones(int n)
{
    std :: vector <bool> fl(n, 0);
    int l = flip_bits(fl), sz = l + 1;
    if(l == n) return {0, n - 1};
    if(!l) return {0, -1};
    while(l <= n / 2) {
        fl = randv(n);
        l = flip_bits(fl);
    }
    int res = -1;
    std :: fill(fl.begin(), fl.end(), 0);
    for(int pas = 1 << 12; pas; pas >>= 1) {
        if(res + pas <= n / 2) {
            fl[res + pas] = 1;
            int flip = flip_bits(fl);
            if(flip >= l) res += pas;
            flip_bits(fl);
            fl[res + pas] = 0;
        }
    }
    return {res + 1, res + l};
}