#include <bits/stdc++.h>
using namespace std;

int flip_bits(const std::vector<bool> &flips);

vector<bool> flips;

int flip_one_bit(int pos) {
    flips[pos] = 1;
    int mx = flip_bits(flips);
    flips[pos] = 0;
    return mx;
}

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    int sq = sqrt(n);
    flips.resize(n);
    int mx = flip_one_bit(0);
    if (mx == n)
        return {0, n - 1};

    int nmx = mx, st = -1;

    while (mx == nmx && st + 1 < sq) {
        st++;
        for (int i = st; i < n; i += sq)
            flips[i] = 1;

        //for (int i : flips)
          //  cout << i << " " ;
        //cout << '\n' << nmx << '\n';
        int nmx = flip_bits(flips);

        for (int i = st; i < n; i += sq)
            flips[i] = 0;
    }

    mx = nmx;
    int pos = st - sq;
    while (mx == nmx) {
        pos += sq;
        nmx = flip_one_bit(pos);
    }

    if (nmx < mx)
        mx = flip_one_bit(pos);
    else
        mx = nmx;

    int l = pos, step = (1 << 13);
    while (step) {
        if (l - step >= 0 && flip_one_bit(l - step) < mx)
            l -= step;
        step >>= 1;
    }
    int r = pos;
    step = (1 << 13);
    while (step) {
        if (r + step < n && flip_one_bit(r + step) < mx)
            r += step;
        step >>= 1;
    }

    return {l, r};

}
