#include <bits/stdc++.h>
using namespace std;

int flip_bits(const std::vector<bool> &flips);

vector<bool> flips;

int flip_one_bit(int pos) {
    flips[pos] = 1;
    int mx = flip_bits(flips);
    flips[pos] = 0;
    return mx;
}

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    int sq = sqrt(n);
    flips.resize(n);
    int mx = flip_one_bit(0);
    if (mx == n)
        return {0, n - 1};

    int nmx = mx, st = sq / 2 - 1;

    while (mx == nmx && st + 1 < sq) {
        st++;
        for (int i = st; i < n; i += sq)
            flips[i] = 1;

        //for (int i : flips)
         //   cout << i << " " ;
       // cout << '\n' << nmx << '\n';
        nmx = flip_bits(flips);

        for (int i = st; i < n; i += sq)
            flips[i] = 0;
    }

    if (mx == nmx) {
        st = 0;
            while (mx == nmx && st + 1 < sq / 2 - 1) {
        st++;
        for (int i = st; i < n; i += sq)
            flips[i] = 1;

        //for (int i : flips)
         //   cout << i << " " ;
       // cout << '\n' << nmx << '\n';
        nmx = flip_bits(flips);

        for (int i = st; i < n; i += sq)
            flips[i] = 0;
    }
    }

    mx = nmx;
    int pos = st - sq;
    while (mx == nmx) {
        pos += sq;
        nmx = flip_one_bit(pos);
    }

    if (nmx < mx)
        mx = flip_one_bit(pos);
    else
        mx = nmx;


    st = max(0, pos - mx + 1);
    int dr = pos;
    while (st < dr) {
        int mid = (st + dr) / 2;
        nmx = flip_one_bit(mid);
        if (nmx < mx)
            dr = mid;
        else
            st = mid + 1;
        flip_one_bit(mid);
    }
    int l = st;

    st = pos, dr = min(n - 1, pos + mx - 1);
    while (st < dr) {
        int mid = (st + dr + 1) >> 1;
        nmx = flip_one_bit(mid);
        if (nmx < mx)
            st = mid;
        else
            dr = mid - 1;
        flip_one_bit(mid);
    }
    int r = st;

    return {l, r};

}
