#include "ones.h"
#include <bits/stdc++.h>
#define dbg(x) cerr << #x << ' ' << x << '\n'

using namespace std;

// int flip_bits(const std::vector<bool> &flips);

int getLeft(int n, int &ansinit, int pos) {
    vector <bool> flips(n);
    
    int st = 0, dr = pos;
    while (st <= dr) {
        int mid = (st + dr) / 2;
        flips[mid] = true;
        int r = flip_bits(flips);
        assert(r != ansinit);

        if (r > ansinit) {
            st = mid + 1;
        } else if (r == ansinit) {
            flip_bits(flips);
            return mid + 1;
        } else {
            dr = mid - 1;
        }
    }

    /*for (int i = pos; i >= 0; i--) {
        flips[i] = true; 
        int r = flip_bits(flips);
        assert(r != ansinit);

        if (r > ansinit) {
            if (r == ansinit + 1) {
                ansinit = r;
                return i;
            } else {
                flip_bits(flips);
                return i + 1;
            }
        }

        flip_bits(flips);
        flips[i] = false;
    }*/

    return 0;
}

pair <int, int> find_longest_subarray_of_ones(int n) {
    random_device rd;
    mt19937 rng(rd());
    uniform_int_distribution<> dis(0, n - 1);

    vector <bool> flips(n);
    int ansinit = flip_bits(flips);
    int foundpos = 0;
    while (true) {
        auto pos = dis(rng);
        flips[pos] = true;

        int r = flip_bits(flips);

        if (r < ansinit) {
            cerr << "Smaller r at pos " << pos << '\n';
            flip_bits(flips);
            int l = getLeft(n, ansinit, pos);
            
            dbg(l); dbg(l + ansinit - 1);
            return {l, l + ansinit - 1};
        } else if (r > ansinit) {
            cerr << "Bigger r at pos " << pos << '\n';
            ansinit = r;
            int l = getLeft(n, ansinit, pos);
            
            dbg(l); dbg(l + ansinit - 1);
            return {l, l + ansinit - 1};
        }
        
        flips[pos] = false;
    }
}
