#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll dumb(ll p, ll q, ll n)
{
  ll sol = 0;
  for (ll a = 1; a <= p; a++)
  {
    for (ll b = 1; b <= q; b++)
    {
      if ((a * b) % (a + b) == 0)
      {
        ll c = (a * b) / (a + b);
        assert(c < b);
        assert(a == c * b / (b - c));
        if (c <= n)
        {
          sol++;
        }
      }
    }
  }
  return sol;
}

ll get_num(ll a)
{
  ll sol = 1;
  for (ll d = 2; d * d <= a; d++)
  {
    if (a % d == 0)
    {
      int cnt = 0;
      while (a % d == 0)
      {
        a /= d;
        cnt++;
      }
      for (int j = 1; j <= (cnt + 1) / 2; j++)
      {
        sol *= d;
      }
    }
  }
  sol *= a;
  return sol;
}

ll dmax = 0;

ll f2(ll p, ll q, ll n)
{
  ll sol = 0;
  for (ll d = 1; d <= q; d++)
  {
    ll st = 1 + d;
    ll dr = min(q, n + d);
    ll low = st, high = dr, ndr = st - 1;
    while (low <= high)
    {
      ll b = (low + high) / 2;
      if (b * b - d * b <= p * d)
      {
        ndr = b;
        low = b + 1;
      }
      else
      {
        high = b - 1;
      }
    }
    ll d2 = get_num(d);
    sol += ndr / d2 - (st - 1) / d2;
  }
  return sol;
}

int main()
{
  /**if (1)
  {

    for (int n = 1; n <= 100; n++)
    {
      cout << n << " : " << dumb(n, n, n) - dumb(n - 1, n - 1, n - 1) << "\n";
    }
    return 0;
  }**/
  if (1)
  {
    ll p, q, n;
    cin >> p >> q >> n;
    cout << f2(p, q, n) << "\n";
    return 0;
  }
  if (0)
  {
    ll p = 2, q = 1, n = 1;
    cout << dumb(p, q, n) << "\n";
    cout << f2(p, q, n) << "\n";
    return 0;
  }
  cout << dumb(100, 100, 100) << "\n";
  cout << f2(100, 100, 100) << "\n";

 // exit(0);
  cout << "done\n";
 // exit(0);
  if (1)
  {
    /// testing time:
    ll lim = 30;
    for (ll p = 1; p <= lim; p++)
    {
      for (ll q = 1; q <= lim; q++)
      {
        for (ll n = 1; n <= lim; n++)
        {
          ll val1 = dumb(p, q, n);
          ll val2 = f2(p, q, n);
          if (val1 != val2)
          {
            cout << "bad\n";
            cout << p << " " << q << " " << n << "\n";
            return 0;
          }
        }
      }
    }
    cout << "all is good!\n";
    cout << "dmax = " << dmax << "\n";
    return 0;
  }
  ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  ll p, q, n;
  cin >> p >> q >> n;
  cout << dumb(p, q, n) << "\n";
  return 0;
}

