#include <bits/stdc++.h>
using namespace std;

#define MOD 1000000007

int binpow(int b, int e){
	int sol=1;
	while(e){
		if(e&1) sol=(1LL*sol*b)%MOD;
		e>>=1;
		b=(1LL*b*b)%MOD;
	}
	return sol;
}

int n, k;
vector<int> v;

int getMax(int l, int r){

	int maxi=l;
	for(int i=l+1;i<=r;++i){
		if(v[i]>v[maxi]) maxi=i;
	}
	return maxi;
}

int fact[300002], inv[300002];
void getFact(int n){
	fact[0]=1;
	for(int i=1;i<=n;++i) fact[i]=1LL*fact[i-1]*i%MOD;
	inv[n]=binpow(fact[n], MOD-2);
	for(int i=n-1;i;--i){
		inv[i]=1LL*inv[i+1]*(i+1)%MOD;
	}
	inv[1]=inv[0]=1;
}

vector<int> getSmaller;
int id;
int solve(int l, int r, int deleted){
	if(l>=r) return 1;
	int maxi=getMax(l, r);
	if(v[maxi]<=deleted) return 1;
	int newDeleted=k-v[maxi];
	int a=getSmaller[id];
	id++;
	int b=getSmaller[id];
	id++;
	int cntDeleted=a-b;
	//cout<<l<<" "<<r<<" "<<cntDeleted<<" "<<1LL*fact[r-l+1]*inv[r-l+1-cntDeleted]%MOD<<"\n";
	return 1LL*(1LL*solve(l, maxi-1, newDeleted)*solve(maxi+1, r, newDeleted)%MOD)*(1LL*fact[r-l+1]*inv[r-l+1-cntDeleted]%MOD)%MOD;

}

struct query{
	int id;
	int l, r, val;
};
vector<query> qrys;

int fakeId;
void fakeSolve(int l, int r, int deleted){
	if(l>=r) return;
	int maxi=getMax(l, r);
	if(v[maxi]<=deleted) return;
	int newDeleted=k-v[maxi];
	qrys.push_back({fakeId, l, r, newDeleted});
	fakeId++;
	qrys.push_back({fakeId, l, r, deleted});
	fakeId++;
	fakeSolve(l, maxi-1, newDeleted);
	fakeSolve(maxi+1, r, newDeleted);
}

int main(){
	cin>>n>>k;
	getFact(n+1);
	v.resize(n+1);
	for(int i=1;i<=n;++i) cin>>v[i];
	fakeSolve(1, n, -1e9);
	getSmaller.resize(fakeId, 0);
	for(int i=0;i<fakeId;++i){
		int l=qrys[i].l, r=qrys[i].r, val=qrys[i].val;
		for(int j=l;j<=r;++j) if(v[j]<=val) getSmaller[i]++;
	}
	cout<<solve(1, n, -1e9)<<"\n";
}
