#include <bits/stdc++.h>
using namespace std;
#define MOD 1000000007

struct FenwickTree{
	vector<int> v;
	FenwickTree(int n):v(n+2, 0){}
	void upd(int poz, int val){
		for(++poz;poz<(int)v.size();poz+=(poz&(-poz))) v[poz]+=val;
	}
	int qry(int poz){
		int sol=0;
		for(++poz;poz;poz-=(poz&(-poz))) sol+=v[poz];
		return sol;
	}
	int qry(int l, int r){
		return qry(r)-qry(l-1);
	}
};

int binpow(int b, int e){
    int sol=1;
    while(e){
        if(e&1) sol=(1LL*sol*b)%MOD;
        e>>=1;
        b=(1LL*b*b)%MOD;
    }
    return sol;
}
int n, k;
vector<int> v;
int lg(int x){
	return 31-__builtin_clz(x);
}
int rmq[20][100002];
int getMax(int l, int r){
	int k=lg(r-l+1);
	if(v[rmq[k][l]]>v[rmq[k][r-(1<<k)+1]]) return rmq[k][l];
  return rmq[k][r-(1<<k)+1];
}
int fact[300002], inv[300002];
void getFact(int n){
	fact[0]=1;
	for(int i=1;i<=n;++i) fact[i]=1LL*fact[i-1]*i%MOD;
	inv[n]=binpow(fact[n], MOD-2);
	for(int i=n-1;i;--i){
		inv[i]=1LL*inv[i+1]*(i+1)%MOD;
	}
	inv[1]=inv[0]=1;
}
struct query{
	int id;
	int l, r, val;

	bool operator<(const query &ot) const{
		return val<ot.val;
	}
};
vector<query> qrys;
vector<int> getSmaller;
int id;
int solve(int l, int r, int deleted){
	if(l>=r) return 1;
	int maxi=getMax(l, r);
	//cout<<l<<" "<<r<<" "<<maxi<<"*\n";
	if(v[maxi]<=deleted) return 1;
	int newDeleted=k-v[maxi];
	int a=getSmaller[id];
	id++;
	int b=getSmaller[id];
	id++;
	int cntDeleted=a-b, cntElem=(r-l+1)-b;
	return 1LL*solve(l, maxi-1, newDeleted)%MOD*solve(maxi+1, r, newDeleted)%MOD*(1LL*fact[cntElem]*inv[cntElem-cntDeleted]%MOD)%MOD;
}
int fakeId;
void fakeSolve(int l, int r, int deleted){
	if(l>=r) return;
	int maxi=getMax(l, r);
	if(v[maxi]<=deleted) return;
	int newDeleted=k-v[maxi];
	qrys.push_back({fakeId, l, r, newDeleted});
	fakeId++;
	qrys.push_back({fakeId, l, r, deleted});
	fakeId++;
	fakeSolve(l, maxi-1, newDeleted);
	fakeSolve(maxi+1, r, newDeleted);
}
int32_t main(){
    cin>>n>>k;
    getFact(n+1);
    v.resize(n+1);
    for(int i=1;i<=n;++i) cin>>v[i], rmq[0][i]=i;
		for(int j=1;(1<<j)<=n;++j){
			//cout<<j<<": ";
			for(int i=1;i+(1<<j)-1<=n;++i){
				if(v[rmq[j-1][i]]>v[rmq[j-1][i+(1<<(j-1))]]) rmq[j][i]=rmq[j-1][i];
				else rmq[j][i]=rmq[j-1][i+(1<<(j-1))];
				//cout<<rmq[j][i]<<" ";
			}
			//cout<<"\n";
		}
    fakeSolve(1, n, -1e9);
		sort(qrys.begin(), qrys.end());
		vector<pair<int, int>> elems;
		for(int i=1;i<=n;++i) elems.push_back({v[i], i});
		sort(elems.begin(), elems.end());
    getSmaller.resize(fakeId, 0);
		int cr=0;
		FenwickTree aib(n);
		for(auto q:qrys){
			while(cr<(int)elems.size()&&elems[cr].first<=q.val){
				//cout<<"+ "<<elems[cr].first<<" "<<elems[cr].second<<"*\n";
				aib.upd(elems[cr].second, 1);
				cr++;
			}
			getSmaller[q.id]=aib.qry(q.l, q.r);
			//cout<<aib.qry(q.l, q.r)<<" "<<q.l<<" "<<q.r<<" "<<q.val<<" "<<getSmaller[q.id]<<"\n";
		}
		/*
    for(int i=0;i<fakeId;++i){
        int l=qrys[i].l, r=qrys[i].r, val=qrys[i].val;
        for(int j=l;j<=r;++j) if(v[j]<=val) getSmaller[i]++;
    }
		*/
    cout<<solve(1, n, -1e9)<<"\n";
}
