#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    vector <bool> op;
    op.resize(n);

    for (int i = 0; i < n; ++ i )
        op[i] = 0;

    int l = flip_bits(op);

    if (l == 0) {
        return {0, -1};
    }

    for (int i = 0; i < n; ++ i ) {
        op[i] = 1;
        int aux = flip_bits(op);
        op[i] = 0;

        if (aux != l) {
            int st = max(0, i - aux + 1);
            int dr = i;
            int ans = st;

            while (st <= dr) {
                int mij = (st + dr) / 2;

                op[mij] = 1;
                int cnt = flip_bits(op);
                flip_bits(op);
                op[mij] = 0;

                if (cnt < aux) {
                    dr = mij - 1;
                    ans = mij;
                }
                else st = mij + 1;
            }

            return {ans, ans + aux - 1};
        }
    }
}
