#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
constexpr int NMAX = 25e6 + 2;

int P, Q, N;
int ind[NMAX];
int need[NMAX];
bitset <NMAX> coprim;

void Precompute () {
    for (int i = 1; i <= P; ++ i )
        need[i] = 1;

    need[2] = 2;
    need[1] = 1;

    ind[2] = 1;
    for (int i = 4; i <= P; i += 2 ) {
        ind[i] = ind[i/2] + 1;

        need[i] = need[i/2];
        if (ind[i] % 2 == 1)
            need[i] *= 2;
    }

    for (int i = 3; i <= P; i += 2 ) {
        if (!coprim[i]) {
            for (int j = i; j <= P; j += i) {
                coprim[j] = 1;
                if ((j/i) % i != 0) ind[j] = 1;
                else ind[j] = ind[j/i] + 1;

                need[j] = need[j/i];
                if (ind[j] % 2 == 1)
                    need[j] *= i;
            }
            coprim[i] = 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> P >> Q >> N;

    LL ans = 0;
    Precompute();

    for (int ac = 1; ac <= P; ++ ac ) {
        int right = 0;

        int st = 1, dr = min((P - ac) / need[ac], N / need[ac]);

        while (st <= dr) {
            int mij = (st + dr) / 2;

            int c = mij * need[ac];
            LL bc = (1LL * c * c) / ac;

            if (bc + 1LL * c > 1LL * Q) {
                dr = mij - 1;
            }
            else {
                right = mij;
                st = mij + 1;
            }
        }

        ans += 1LL * right;

        /*
        for (int c = need[ac]; c <= N && ac + c <= P; c += need[ac] ) {
            int bc = (1LL * c * c) / ac;

            if (bc + c > Q) break;

            ++ ans;
        }*/
    }

    cout << ans << '\n';

    return 0;
}
