#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

int flip_bits (const vector <bool> &flips);

pair <int, int> find_longest_subarray_of_ones (int n) {
    vector <bool> flips(n, 0);
    int prv = flip_bits(flips);
    if (n == 1) {
        if (prv == 1) {
            return {0, 0};
        } else {
            return {0, -1};
        }
    }
    for (int i = 0; i < n; i++) {
        flips[i] = 1;
        int curr = flip_bits(flips);
        flips[i] = 0;
        if (curr > prv) {
            int l = 0, r = i;
            while (l < r) {
                int mid = (l + r) / 2;
                flips[mid] = 1;
                int now = flip_bits(flips);
                flip_bits(flips);
                flips[mid] = 0;
                if (now < curr) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
            }
            return {l, l + curr - 1};
        }
        prv = curr;
    }
    return {0, -1};
}