#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

int flip_bits (const vector <bool> &flips);

pair <int, int> find_longest_subarray_of_ones (int n) {
    vector <bool> flips(n, 0);
    int mx = flip_bits(flips);
    if (n == 1) {
        if (mx == 1) {
            return {0, 0};
        } else {
            return {0, -1};
        }
    }
    int k;
    if (mx * mx < n) {
        vector <int> curr, last;
        int jump = mx + 1;
        int x;
        for (x = 0; x < jump; x++) {
            for (int i = x; i < n; i += jump) {
                flips[i] = !flips[i];
                curr.push_back(i);
            }
            int now = flip_bits(flips);
            if (now > mx) {
                mx = now;
                break;
            }
            for (int i : last) {
                flips[i] = !flips[i];
            }
            last = curr; curr.clear();
        }
        for (int i : last) {
            flips[i] = !flips[i];
        }
        for (int i : curr) {
            flips[i] = !flips[i];
        }
        last.clear(); curr.clear();
        {
            int l = 0, r = (n - 1 - x) / jump;
            while (l < r) {
                int mid = (l + r) / 2;
                for (int i = x; i <= x + jump * mid; i += jump) {
                    flips[i] = !flips[i];
                    curr.push_back(i);
                }
                if (flip_bits(flips) < mx) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
                for (int i : last) {
                    flips[i] = !flips[i];
                }
                last = curr; curr.clear();
            }
            k = x + l * jump;
            last.clear();
            for (int i = x; i < k - mx + 1; i += jump) {
                flips[i] = !flips[i];
            }
            flip_bits(flips);
        }
    } else {
        for (k = 0; k < n; k += mx) {
            flips[k] = 1;
            int now = flip_bits(flips);
            if (now > mx) {
                mx = now;
                break;
            }
            flip_bits(flips);
            if (now < mx) {
                break;
            }
            flips[k] = 0;
        }
    }
    fill(flips.begin(), flips.end(), 0);
    int l = 0, r = k;
    while (l < r) {
        int mid = (l + r) / 2;
        flips[mid] = 1;
        int now = flip_bits(flips);
        flip_bits(flips);
        flips[mid] = 0;
        if (now < mx) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }
    return {l, l + mx - 1};
}