#include <random>
#include <ctime>
#include <iostream>
#include "ones.h"

using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n)
{
    srand(time(NULL));
    vector<bool> flips(n);
    int i = 0;
    for (i = 0; i < n; i++)
        flips[i] = false;
    int len = flip_bits(flips);
    if (len == 0) {
        for (i = 0; i < n; i++)
            flips[i] = true;
        flip_bits(flips);
        return{0, n-1};
    }
    int starti = rand() % (len+1);
    for (i = starti; i < n; i += (len+1)) {
        flips[i] = true;
    }
    int st = 0;
    int dr = (i / (len+1));
    int len2 = flip_bits(flips);
    if (len2 == len) {
        unsigned int a = 2;
        while (true) {
            a *= a;
        }
        return {a, a+1};
    }
    else if (len2 < len) {
        if (len2 == 0) {
            for (i = 0; i < n; i++)
                flips[i] = true;
            flip_bits(flips);
            return{0, n-1};
        }
        else { /// avem chipperi, cautam un resuscitator
            for (i = starti; i < n; i += (len+1))
                flips[i] = false;
            int mij = 0;
            while (st < dr-1) {
                mij = (st + dr) / 2;
                for (i = st; i < mij; i++) {
                    flips[i*(len+1)+starti] = true;
                }
                int len3 = flip_bits(flips);
                flip_bits(flips);
                for (i = st; i < mij; i++) {
                    flips[i*(len+1)+starti] = false;
                }
                if (len3 == len)
                    dr = mij;
                else
                    st = mij;
            }
            flips[st*(len+1)+starti] = true;
            len2 = flip_bits(flips);
            flips[st*(len+1)+starti] = false;
            dr = st*(len+1)+starti;
            st = -1;
            while (st < dr-1) {
                mij = (st + dr) / 2;
                flips[mij] = true;
                int newlen = flip_bits(flips);
                flip_bits(flips);
                flips[mij] = false;
                if (newlen < len2) {
                    dr = mij;
                }
                else
                    st = mij;
            }
            st = dr;
            dr = st + len2 - 1;
            return {st, dr};
        }
    }
    else { /// avem un contributor
        flip_bits(flips);
        for (i = starti; i < n; i += (len+1))
            flips[i] = false;
        int mij = 0;
        while (st < dr-1) {
            mij = (st + dr) / 2;
            for (i = st; i < mij; i++) {
                flips[i*(len+1)+starti] = true;
            }
            len2 = flip_bits(flips);
            flip_bits(flips);
            for (i = st; i < mij; i++) {
                flips[i*(len+1)+starti] = false;
            }
            if (len2 > len)
                dr = mij;
            else
                st = mij;
        }
        flips[st*(len+1)+starti] = true;
        len2 = flip_bits(flips);
        flips[st*(len+1)+starti] = false;
        dr = st*(len+1)+starti;
        st = -1;
        while (st < dr-1) {
            mij = (st + dr) / 2;
            flips[mij] = true;
            int newlen = flip_bits(flips);
            flip_bits(flips);
            flips[mij] = false;
            if (newlen < len2) {
                dr = mij;
            }
            else
                st = mij;
        }
        st = dr;
        dr = st + len2 - 1;
        return {st, dr};
    }
}
