#pragma GCC optimize("03,unroll-loops")
#include <iostream>
#include <cmath>

using namespace std;

long long p, q, n, x, y, lx, ly, sol;
bool euarray[16010][16010], viz[16010][16010];

bool euclid(short a, short b)
{
    if (!b) {
        if (a == 1)
            return true;
        else
            return false;
    }
    if (viz[a][b])
        return euarray[a][b];
    euarray[a][b] = euclid(b, a%b);
    viz[a][b] = true;
    return euarray[a][b];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> p >> q >> n;
    lx = ((long long)(sqrt(p))) + 2;
    ly = ((long long)(sqrt(q))) + 2;
    if (p > 250000000LL || q > 250000000LL)
        return 0;
    for (x = 1; x <= lx; x++) {
        for (y = 1; y <= ly; y++) {
            if (euclid(x, y)) {
                sol += min(n / (x*y), min(p / (x*(x+y)), q / (y*(x+y))));
            }
        }
    }
    cout << sol;
    return 0;
}
