#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn=3e5+10;
const int mod=1e9+7;

int a[maxn];
int srt[maxn];
bool uzeo[maxn];
vector<int> poz[maxn];
int fakt[maxn];
int invfakt[maxn];

int add(int a,int b){
    if(a+b>=mod) return a+b-mod;
    return a+b;
}

int mul(int a,int b){
    if(ll(a)*ll(b)>=mod) return ll(a)*ll(b)%mod;
    return a*b;
}

int pwr(int a,int b){
    int ret=1;
    while(b){
        if(b&1) ret=mul(ret,a);
        b/=2;
        a=mul(a,a);
    }
    return ret;
}

void init(){
    fakt[0]=1;
    for(int i=1;i<maxn;i++){
        fakt[i]=mul(fakt[i-1],i);
    }
    invfakt[maxn-1]=pwr(fakt[maxn-1],mod-2);
    for(int i=maxn-2;i>=0;i--){
        invfakt[i]=mul(invfakt[i+1],i+1);
    }
}

int nck(int n,int k){
    if(k>n) return 0;
    return mul(fakt[n],mul(invfakt[n-k],invfakt[k]));
}

int izr(int n,int k){
    return nck(n+k-1,k-1);
}

int main(){
    init();
    int n,k;
    cin>>n>>k;
    int res=1;
    for(int i=0;i<n;i++){
        cin>>a[i];
        srt[i]=a[i];
    }
    sort(srt,srt+n);
    for(int i=0;i<n;i++){
        poz[lower_bound(srt,srt+n,a[i])-srt].push_back(i);
    }
    for(int i=0;i<n;i++){
        if(poz[i].empty()) continue;
        vector<pair<int,int> > poc;
        for(int j:poz[i]) uzeo[j]=true;
        for(int p:poz[i]){
            int l=INT_MAX,r=INT_MIN;
            for(int j=p;j<n;j++){
                if(uzeo[j]) continue;
                if(a[j]+a[p]>k) break;
                l=min(l,j);
                r=max(r,j);
            }
            for(int j=p;j>=0;j--){
                if(uzeo[j]) continue;
                if(a[j]+a[p]>k) break;
                l=min(l,j);
                r=max(r,j);
            }
            if(l!=INT_MAX) poc.push_back({l,r});
        }
        if(poc.empty()) continue;
        sort(poc.begin(),poc.end());
        //cout<<i<<":\n";
        //for(auto t:poc) cout<<t.first<<" "<<t.second<<"\n";
        int klk=0;
        int tpoz=0;
        pair<int,int> tren={-1,-1};
        for(auto j:poc){
            if(j==tren){
                klk++;
                continue;
            }
            if(tren!=pair<int,int>(-1,-1)) res=mul(res,izr(klk,tpoz));
            klk=1;
            tpoz=1;
            tren=j;
            for(int k=j.first;k<=j.second;k++) if(!uzeo[k]) tpoz++;
        }
        res=mul(res,izr(klk,tpoz));
        //cout<<res<<"\n";
        //
        /*
        if(poz[i].size()!=1) continue;
        int p=poz[i][0];
        int klk=0;
        uzeo[p]=true;
        for(int j=p;j<n;j++){
            if(uzeo[j]) continue;
            if(a[j]+a[p]>k) break;
            klk++;
        }
        for(int j=p;j>=0;j--){
            if(uzeo[j]) continue;
            if(a[j]+a[p]>k) break;
            klk++;
        }
        res=mul(res,klk+1);
        */
    }
    cout<<res;
    return 0;
}
