#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn=3e5+10;
const int mod=1e9+7;

int a[maxn];
int srt[maxn];
bool uzeo[maxn];
vector<int> poz[maxn];
int fakt[maxn];
int invfakt[maxn];
int n,k;

int add(int a,int b){
    if(a+b>=mod) return a+b-mod;
    return a+b;
}

int mul(int a,int b){
    if(ll(a)*ll(b)>=mod) return ll(a)*ll(b)%mod;
    return a*b;
}

int pwr(int a,int b){
    int ret=1;
    while(b){
        if(b&1) ret=mul(ret,a);
        b/=2;
        a=mul(a,a);
    }
    return ret;
}

void init(){
    fakt[0]=1;
    for(int i=1;i<maxn;i++){
        fakt[i]=mul(fakt[i-1],i);
    }
    invfakt[maxn-1]=pwr(fakt[maxn-1],mod-2);
    for(int i=maxn-2;i>=0;i--){
        invfakt[i]=mul(invfakt[i+1],i+1);
    }
}

int nck(int n,int k){
    if(k>n) return 0;
    return mul(fakt[n],mul(invfakt[n-k],invfakt[k]));
}

int izr(int n,int k){
    return nck(n+k-1,k-1);
}

int segt[4*maxn];

void update(int t,int v,int ind=1,int l=0,int r=n-1){
    if(l==r){
        segt[ind]=v;
        return;
    }
    int mid=l+(r-l)/2;
    if(t<=mid) update(t,v,2*ind,l,mid);
    else update(t,v,2*ind+1,mid+1,r);
    segt[ind]=max(segt[2*ind],segt[2*ind+1]);
}

int qrl(int p,int a,int ind=1,int l=0,int r=n-1){
    int mid=l+(r-l)/2;
    if(p<l) return -1;
    if(r>p) return max(qrl(p,a,2*ind,l,mid),qrl(p,a,2*ind+1,mid+1,r));
    if(l==r){
        if(segt[ind]+a>k) return l;
        return -1;
    }else{
        if(segt[2*ind+1]+a>k) return qrl(p,a,2*ind+1,mid+1,r);
        else return qrl(p,a,2*ind,l,mid);
    }
}

int qrr(int p,int a,int ind=1,int l=0,int r=n-1){
    int mid=l+(r-l)/2;
    if(p>r) return n;
    if(l<p) return min(qrr(p,a,2*ind,l,mid),qrr(p,a,2*ind+1,mid+1,r));
    if(l==r){
        if(segt[ind]+a>k) return l;
        return n;
    }else{
        if(segt[2*ind]+a>k) return qrr(p,a,2*ind,l,mid);
        else return qrr(p,a,2*ind+1,mid+1,r);
    }
}

int bit[maxn+10];

void bitup(int x,int v){
    x+=3;
    for(;x<maxn;x+=x&-x) bit[x]+=v;
}

int bitq(int x){
    x+=3;
    int ret=0;
    for(;x>0;x-=x&-x) ret+=bit[x];
    return ret;
}

int main(){
    init();
    cin>>n>>k;
    int res=1;
    for(int i=0;i<n;i++){
        cin>>a[i];
        srt[i]=a[i];
        update(i,a[i]);
        bitup(i,1);
    }
    sort(srt,srt+n);
    for(int i=0;i<n;i++){
        poz[lower_bound(srt,srt+n,a[i])-srt].push_back(i);
    }
    for(int i=0;i<n;i++){
        if(poz[i].empty()) continue;
        vector<pair<int,int> > poc;
        for(int j:poz[i]){
            update(j,0);
            bitup(j,-1);
        }
        for(int p:poz[i]){
            int l=INT_MAX,r=INT_MIN;
            for(int j=p;j<n;j++){
                if(uzeo[j]) continue;
                if(a[j]+a[p]>k) break;
                l=min(l,j);
                r=max(r,j);
            }
            for(int j=p;j>=0;j--){
                if(uzeo[j]) continue;
                if(a[j]+a[p]>k) break;
                l=min(l,j);
                r=max(r,j);
            }
            l=qrl(p,a[p]);
            l++;
            r=qrr(p,a[p]);
            r--;
            if(l<=r) poc.push_back({l,r});
        }
        if(poc.empty()) continue;
        sort(poc.begin(),poc.end());
        //cout<<i<<":\n";
        //for(auto t:poc) cout<<t.first<<" "<<t.second<<"\n";
        int klk=0;
        int tpoz=0;
        pair<int,int> tren={-1,-1};
        for(auto j:poc){
            if(j==tren){
                klk++;
                continue;
            }
            if(tren!=pair<int,int>(-1,-1)) res=mul(res,izr(klk,tpoz));
            klk=1;
            tpoz=1;
            tren=j;
            tpoz+=bitq(j.second)-bitq(j.first-1);
            //for(int k=j.first;k<=j.second;k++) if(!uzeo[k]) tpoz++;
        }
        res=mul(res,izr(klk,tpoz));
        //cout<<res<<"\n";
    }
    cout<<res;
    return 0;
}
