#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn=3e5+10;
const int mod=1e9+7;

int a[maxn];
int srt[maxn];
bool uzeo[maxn];
vector<int> poz[maxn];
int fakt[maxn];
int invfakt[maxn];
int n,k;

int add(int a,int b){
    if(a+b>=mod) return a+b-mod;
    return a+b;
}

int mul(int a,int b){
    if(ll(a)*ll(b)>=mod) return ll(a)*ll(b)%mod;
    return a*b;
}

int pwr(int a,int b){
    int ret=1;
    while(b){
        if(b&1) ret=mul(ret,a);
        b/=2;
        a=mul(a,a);
    }
    return ret;
}

const int logg=21;

int st[maxn][logg];
int lg[maxn];

int sqr(int l,int r){
    if(l>r) swap(l,r);
    int duz=(r-l+1);
    int ret=st[r][lg[duz]];
    ret=max(ret,st[l+(1<<lg[duz])-1][lg[duz]]);
    return ret;
}

void init(){
    for(int l=0;l<logg;l++){
        for(int i=0;i<n;i++){
            if(l==0) st[i][l]=a[i];
            else if(i<(1<<(l-1))) st[i][l]=st[i][l-1];
            else st[i][l]=max(st[i][l-1],st[i-(1<<(l-1))][l-1]);
        }
    }
    lg[1]=0;
    for(int i=2;i<maxn;i++){
        lg[i]=lg[i/2]+1;
    }
    fakt[0]=1;
    for(int i=1;i<maxn;i++){
        fakt[i]=mul(fakt[i-1],i);
    }
    invfakt[maxn-1]=pwr(fakt[maxn-1],mod-2);
    for(int i=maxn-2;i>=0;i--){
        invfakt[i]=mul(invfakt[i+1],i+1);
    }
}

int nck(int n,int k){
    if(k>n) return 0;
    return mul(fakt[n],mul(invfakt[n-k],invfakt[k]));
}

int izr(int n,int k){
    return nck(n+k-1,k-1);
}

int bit[maxn+10];

void bitup(int x,int v){
    x+=3;
    for(;x<maxn;x+=x&-x) bit[x]+=v;
}

int bitq(int x){
    x+=3;
    int ret=0;
    for(;x>0;x-=x&-x) ret+=bit[x];
    return ret;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    int res=1;
    for(int i=0;i<n;i++){
        cin>>a[i];
        srt[i]=a[i];
        bitup(i,1);
    }
    init();
    sort(srt,srt+n);
    for(int i=0;i<n;i++){
        poz[lower_bound(srt,srt+n,a[i])-srt].push_back(i);
    }
    for(int i=0;i<n;i++){
        if(poz[i].empty()) continue;
        vector<pair<int,int> > poc;
        for(int j:poz[i]){
            bitup(j,-1);
        }
        for(int p:poz[i]){
            //l = prvi levi tkd > k
            //r = prvi desni tkd > k
            int l=-1,r=n;
            int tl=0,tr=p;
            while(tl<=tr){
                int mid=tl+(tr-tl)/2;
                if(sqr(p,mid)+a[p]>k){
                    l=mid;
                    tl=mid+1;
                }else tr=mid-1;
            }
            tl=p,tr=n;
            while(tl<=tr){
                int mid=tl+(tr-tl)/2;
                if(sqr(p,mid)+a[p]>k){
                    r=mid;
                    tr=mid-1;
                }else tl=mid+1;
            }
            //l=qrl(p,a[p]);
            l++;
            //r=qrr(p,a[p]);
            r--;
            if(l<=r) poc.push_back({l,r});
        }
        if(poc.empty()) continue;
        //cout<<i<<":\n";
        //for(auto t:poc) cout<<t.first<<" "<<t.second<<"\n";
        int klk=0;
        int tpoz=0;
        pair<int,int> tren={-1,-1};
        for(auto j:poc){
            if(j==tren){
                klk++;
                continue;
            }
            if(tren!=pair<int,int>(-1,-1)) res=mul(res,izr(klk,tpoz));
            klk=1;
            tpoz=1;
            tren=j;
            tpoz+=bitq(j.second)-bitq(j.first-1);
            //for(int k=j.first;k<=j.second;k++) if(!uzeo[k]) tpoz++;
        }
        res=mul(res,izr(klk,tpoz));
        //cout<<res<<"\n";
    }
    cout<<res;
    return 0;
}
