#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define sp ' '
#define en '\n'
#define pv(v) for (auto x : v) cout << x << sp; cout << en;

using namespace std;

const int mxN = 3e5+10, mod = 1e9+7;
ll n, m, a[mxN], cnt[mxN];
vector<int> g[mxN];

ll mul(ll x, ll y){ return (x*y) % mod; }
#define smul(x, y) x = mul(x, y);

ll BackTrack(vector<int> q, vector<int> deg){

    if (q.empty()) return 1;
    ll sum = 0;
    for (int i = 0; i < q.size(); i++){
        int s = q[i];
        vector<int> q1, deg1(n);
        for (int u : q) if (u^s) q1.pb(u);
        for (int j = 0; j < n; j++) deg1[j] = deg[j];
        for (int u : g[s]){
            deg1[u]--;
            if (!deg1[u]) q1.pb(u);
        }
        sum += BackTrack(q1, deg1);
    }
    return sum;
}

int main(){

    cin >> n >> m;
    vector<int> q, deg(n, 0);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        for (int j = 0; j < i; j++){
            if (a[j] + a[i] > m){
                g[j].pb(i);
                deg[i]++;
            }
        }
    }
    for (int i = 0; i < n; i++)
        if (!deg[i]) q.pb(i);
    cout << BackTrack(q, deg) << en;
    return 0;
}
