#include <bits/stdc++.h>

using namespace std;

const int MAX = 300005;

const int md = 1e9 + 7;

long long f[MAX];

long long add(long long a, long long b) {
  return a + b >= md ? a + b - md : a + b;
}

long long mul(long long a, long long b) {
  return (a * b) % md;
}

long long sub(long long a, long long b) {
  return a - b < 0 ? a - b + md : a - b;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  f[1] = 1;
  for (int i = 2; i < MAX; i++) {
    f[i] = mul(f[i - 1], i);
  }
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<long long> dp(n);
  for (int i = 0; i < n; i++) {
    int mx = 0;
    int mn = 1e9;
    dp[i] = (i == 0 ? 1LL : dp[i - 1]);
    for (int j = i; j >= 0; j--) {
      mn = min(mn, a[j]);
      mx = max(mx, a[j]);
      if (j < i && mn + mx <= k) {
        dp[i] = add(dp[i], mul((j == 0 ? 1LL : dp[j - 1]), sub(f[i - j + 1], f[i - j])));
      }
    }
  }
//  for (int i = 0; i < n; i++) {
//    cout << dp[i] << " ";
//  }
//  cout << '\n';
  cout << dp[n - 1] << '\n';
  return 0;
}
