#include <bits/stdc++.h>

#define ll long long

using namespace std;

bool isSorted(int arr[], int n) {

    for(int i = 0; i < n - 1; i++)
        if(arr[i] > arr[i + 1])
            return false;
    return true;
}

bool possible(int dest[], int src[], int n, int k) {

    for(int i = 0; i < n; i++) {
        int j;
        for(j = 0; j < n; j++)
            if(src[j] == dest[i])
                break;
        for(int l = j; l > i; l--)
            if(src[l] + src[l - 1] <= k)
                swap(src[l], src[l - 1]);
            else
                return false;
    }
    return true;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    int arr[n], copy[n];
    for(int i = 0; i < n; i++) {
        cin >> arr[i];
        copy[i] = arr[i];
    }
    sort(arr, arr + n);

    int ans = 0;
    do {
        if(possible(arr, copy, n, k))
            ans++;
        next_permutation(arr, arr + n);
    } while(!isSorted(arr, n));
    cout << ans << endl;
    return 0;
}
