#include <vector>
#include <iostream>
#include <set>

using namespace std;

int n, k;
set<vector<int>> s;

void calc(vector<int> w) {
	for (int i=1; i<n; i++) {
		if (w[i-1] != w[i] && w[i-1] + w[i] <= k) {
			swap(w[i-1], w[i]);
			
			bool found = false;
			for (vector<int> w2 : s) {
				bool matches = true;
				for (int j=0; j<n; j++) {
					if (w[j] != w2[j]) {
						matches = false;
						break;
					}
				}
				
				if (matches) {
					found = true;
					break;
				}
			}
			
			if (!found) {
				s.insert(w);
				calc(w);
			}
			swap(w[i-1], w[i]);
		}
	}
}

int main() {
	cin >> n >> k;
	vector<int> w(n);
	for (int i=0; i<n; i++) cin >> w[i];
	s.insert(w);
	
	calc(w);
	cout << s.size() << endl;
}
