#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <string>

using namespace std;

int n, k;
vector<vector<int>> s;
map<pair<string, int>, bool> mp;

void calc(vector<int> w, int x) {
	/*cout << "W: ";
	for (int j=0; j<n; j++) cout << w[j] << " ";
	cout << endl;*/
	// cout << "X: " << x << endl;
	
	for (int i=x; i<n; i++) {
		if (w[i-1] != w[i] && w[i-1] + w[i] <= k) {
			swap(w[i-1], w[i]);
			
			bool found = false;
			for (vector<int> w2 : s) {
				bool matches = true;
				for (int j=0; j<n; j++) {
					if (w[j] != w2[j]) {
						matches = false;
						break;
					}
				}
				
				if (matches) {
					found = true;
					break;
				}
			}
			
			string ws = "";
			for (int wc : w) ws += to_string(wc) + "-";
			auto search = mp.find({ws, x});
			
			if (!found && search == mp.end()) {
				string ws2 = "";
				for (int wc : w) ws2 += to_string(wc) + "-";
				mp[{ws2, x}] = true;
				// cout << ws2 << endl;
				s.push_back(w);
				calc(w, x);
			}
			swap(w[i-1], w[i]);
		}
	}
}

int main() {
	cin >> n >> k;
	vector<int> w(n);
	for (int i=0; i<n; i++) cin >> w[i];
	s.push_back(w);
	
	calc(w, 1);
	cout << s.size() << endl;
}
