#include <vector>
// include <iostream>
#include "ones.h"

using namespace std;

std::pair<int,int> find_longest_subarray_of_ones(int n) {
	vector<short> field(n, 2);
	
	int before = flip_bits(vector<bool>(n, false));
	if (before == n) return {0, n};
	
	while (true) {
		bool calc = true;
		
		for (int i=0; i<n; i++) {
			vector<bool> flips(n, false);
			flips[i] = true;
			
			int now = flip_bits(flips);
			
			if (field[i] != 2) {
				if (field[i] == 0) field[i] = 1;
				else if (field[i] == 1) field[i] = 0;
			} else {
				if (now > before) field[i] = 1;
				else if (now < before) field[i] = 0;
			}
			
			if (field[i] == 2) calc = false;
			
			/*cout << "G: ";
			for (int j=0; j<n; j++) cout << field[j] << " ";
			cout << " -- " << before << " " << now;
			cout << endl;*/
			
			before = now;
		}
		
		// cout << endl;
		if (calc) break;
	}
	
	/*cout << "G: ";
	for (int i=0; i<n; i++) cout << field[i] << " ";
	cout << endl;*/
	
	int a=0, b=0, len=0;
	int maxa=0, maxb=0, maxlen=0;
	
	for (int i=0; i<=n; i++) {
		if (i == n || field[i] == 0) {
			if (len > maxlen) {
				maxa = a;
				maxb = b;
				maxlen = len;
			}
			
			continue;
		}
		
		if (field[i] == 1) {
			if (i > 0 && field[i-1] == 0) {
				a = i;
				len = 0;
			}
			
			b = i;
			len++;
		}
	}
	
	return {maxa, maxb};
}
