#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse2,sse3,ssse3,sse4,popcnt,lzcnt")

#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int N = 200064;

vector<int> d[N];
bitset<N> bs;

bool GCD(int x, int y) {
      int pl = 0, pr = 0;
      while (pl < d[x].size() || pr < d[y].size()) {
            if (pl < d[x].size() && pr < d[y].size() && d[x][pl] == d[y][pr])
                  return true;

            if (pl < d[x].size() && (pr == d[y].size() || d[x][pl] < d[y][pr]))
                  ++pl;
            else
                  ++pr;
      }
      return false;
}

signed main() {
      ll p, q, n;
      cin >> p >> q >> n;

      for (int i = 2; i < N; ++i)
            if (bs[i])
                  for (int j = i; j < N; j += i)
                        bs[j] = (i == j), d[j].push_back(i);

      ll ans = 0;

      for (ll x = 1; x * x <= p; ++x)
            for (ll y = 1; y * y <= q; ++y) {
                  if (__gcd(x, y) > 1 || x * (x + y) > p || y * (x + y) > q)
                        continue;

                  ll k = min({p / (x * (x + y)), q / (y * (x + y)), n / (x * y)});
                  ans += k;
            }

      cout << ans << '\n';

//      ll res = 0;
//
//      for (int i = 1; i <= p; ++i)
//            for (int j = 1; j <= q; ++j)
//                  if ((i * j) % (i + j) == 0 && (i * j) / (i + j) <= n) {
//                        ++res;
//                  }
//
//      cout << res << '\n';
}

