#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse2,sse3,ssse3,sse4,popcnt,lzcnt")

#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int N = 200064;

vector<int> d[N];
bitset<N> bs;

inline bool GCD(int x, int y) {
      if (x == 1 || y == 1)
            return true;

      int j = 0;
      for (int i = 0; i < d[x].size(); ++i) {
            while (j < d[y].size() && d[y][j] < d[x][i])
                  ++j;
            if (j < d[y].size() && d[x][i] == d[y][j])
                  return false;
      }
      return true;
}

signed main() {
      ll p, q, n;
      cin >> p >> q >> n;

      if (p > q)
            swap(p, q);

      bs.set();

      for (int i = 2; i < N; ++i)
            if (bs[i])
                  for (int j = i; j < N; j += i)
                        bs[j] = (i == j), d[j].push_back(i);

      ll ans = 0;

      for (int x = 1; 1ll * x * x <= p; ++x)
            for (ll y = x; 1ll * y * (x + y) <= q; ++y)
                  ans += GCD(x, y) * min({p / (x * (x + y)), q / (y * (x + y)), n / (x * y)}) * (1 + (x != y && y * (x + y) <= p));

      cout << ans << '\n';

//      ll res = 0;
//
//      for (int i = 1; i <= p; ++i)
//            for (int j = 1; j <= q; ++j)
//                  if ((i * j) % (i + j) == 0 && (i * j) / (i + j) <= n) {
//                        ++res;
//                  }
//
//      cout << res << '\n';
}
