#include <bits/stdc++.h>

const int N = 3e5;

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pi;

class seg_max{
    int n;
    vector<ll> s;
    ll comb(ll a, ll b){return max(a, b);}
    int set(int i){return i < 0 ?n + i :i;}
    bool ch(int i){return i >= 0 && i < n;}
    public:
    seg_max(int _n): n(_n), s(2 * _n){}
    void upd(int x, int d){
        s[x += n] = d; for(x >>= 1; x; x >>= 1) s[x] = comb(s[x << 1], s[x << 1 | 1]);}
    ll get(int l, int r){
        l = set(l); r = set(r);
        if(l > r) return INT_MAX;
        ll ra = 0, rb = 0;
        for(l += n, r += n + 1; l < r; l >>= 1, r >>= 1){
            if(l & 1) ra = comb(ra, s[l++]);
            if(r & 1) rb = comb(s[--r], rb);
        }
        return comb(ra, rb);
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k, a[N], rf[N];
    cin >> n >> k;
    for(int i = 0; i < n; ++i) cin >> a[i], rf[i] = i;
    seg_max sx(n);
    for(int i = 0; i < n; ++i)
        sx.upd(i, a[i]);
    vector<int> bf[N];
    for(int i = 1; i < n; ++i){
        int l = 0, r = i;
        while(l != r){
            int m = (l + r) >> 1;
            if((m == i || sx.get(m, i - 1) + a[i] <= k))
                r = m;
            else l = m + 1;
        }
        if(i == r){continue;}
        r = rf[r];
        if(a[r] < a[i]) swap(a[r], a[i]);
        bf[r].push_back(a[i]);
        sx.upd(i, a[r]);
        a[i] = a[r];
        rf[i] = r;
    }
    vector<int> rs;
    for(int i = 0; i < n; ++i) if(rf[i] == i){
        sort(bf[i].begin(), bf[i].end());
        for(auto c: bf[i])
            rs.push_back(c);
        rs.push_back(a[i]);
    }
    for(auto c: rs) cout << c << ' '; cout << '\n';
    for(int i = 0; i < n; ++i)
        sx.upd(i, rs[i]);
    int cnt = 1;
    ll ans = 1;
    for(int i = 0; i < n; ++i){
        if(i+1 < n && rs[i] == rs[i + 1]){++cnt; continue;}
        int l = i, r = n - 1;
        while(l < r){
            int m = (l + r + 1) >> 1;
            if(i == m || sx.get(i + 1, m) + rs[i] <= k)
                l = m;
            else r = m - 1;
        }
        ans *= (r - i + 1) * cnt;
        cnt = 1;
    }
    cout << ans << '\n';
}
