#include "bits/stdc++.h"

using namespace std;

#define DIM 300007
#define mod 1000000007
#define endl '\n'

typedef long long ll;

ll n, k, res, b[DIM], key[DIM], t[4*DIM];
string s;
set<string> ss;
struct gg{ll a, x;};
gg a[DIM];

vector<ll> tv[4*DIM];


void f(string s){
    
    if(ss.count(s)==0){
        ss.insert(s);
        res++;
    }
    else{
        return;
    }
    
    for(int i=1;i<n;i++){
        ll x1, x2;
        x1 = s[i-1]-'0';
        x2 = s[i] - '0';
        if(x1+x2<=k){
            string s1 = s;
            s1[i] = s[i-1];
            s1[i-1] = s[i];
            f(s1);
            
        }
    }
}

bool cmp(gg a, gg b){
    return a.a<b.a;
}


void build_tree(ll v, ll tl, ll tr){
    
    if(tl==tr){
        t[v] = b[tl];
        return;
    }
    
    ll tm = (tl+tr)/2;
    
    build_tree(v*2+1, tl, tm);
    build_tree(v*2+2, tm+1, tr);
    
    t[v] = max(t[v*2+1], t[v*2+2]);
    
}

long long tree_query(ll v, ll tl, ll tr, ll l, ll r){
    
    if(l<=tl && tr<=r){
        return t[v];
    }
    if(l>tr || r<tl){
        return 0;
    }
    
    ll tm = (tl+tr)/2;
    
    ll x = max(tree_query(v*2+1, tl, tm, l, r), tree_query(v*2+2, tm+1, tr, l, r));
    
    //cout<<"   "<<l<<" "<<r<<" "<<x<<endl;
    
    return x;
}


ll find_l(ll x){
    
    ll l = 0, r = x-1;
    ll c = key[b[x]];
    
    ll cc=0;
    
    while(l<r){
        
        ll m = (l+r+1)/2;
        
        ll x2 = tree_query(0, 1, n, m, x-1);
        
        ll c2 = key[x2];
        
        //cout<<" "<<m<<" "<<l<<" "<<r<<" "<<x2<<" "<<c2<<" "<<c<<endl;
        
        if(c+c2 > k){
            l = m;
        }
        else{
            r = m-1;
        }
        cc++; if(cc>100) return -1;
    }
    
    return l;
    
}

ll find_r(ll x){
    
    ll l = x+1, r = n+1;
    ll c = key[b[x]];
    
    ll cc = 0;
    
    while(l<r){
        
        ll m = (l+r)/2;
        
        ll x2 = tree_query(0, 1, n, x+1, m);
        
        ll c2 = key[x2];
        
        //cout<<m<<" "<<l<<" "<<r<<" "<<x2<<" "<<c2<<endl;
        
        if(c+c2 > k){
            r = m;
        }
        else{
            l = m+1;
        }
        
        cc++; if(cc>100) return -1;
        
    }
    
    return l;
    
}



void build_tree_2(ll v, ll tl, ll tr){
    
    if(tl==tr){
        tv[v].push_back(b[tl]);
        return;
    }
    
    ll tm = (tl+tr)/2;
    
    build_tree_2(v*2+1, tl, tm);
    build_tree_2(v*2+2, tm+1, tr);
    
    ll x1=0, x2=0, s1, s2;
    s1 = tv[v*2+1].size();
    s2 = tv[v*2+2].size();

    while(x1<s1 || x2<s2){
        if(x1>=s1){
            tv[v].push_back(tv[v*2+2][x2]);
            x2++;
                            
        }
        else if(x2>=s2){
            tv[v].push_back(tv[v*2+1][x1]);
            x1++;
        }
        else{
            if(x2>=s2 || tv[v*2+1][x1]<tv[v*2+2][x2]){
                tv[v].push_back(tv[v*2+1][x1]);
                x1++;
            }
            else{
                tv[v].push_back(tv[v*2+2][x2]);
                x2++;
            }
        }
    }
    
}



ll tree_query_2(ll v, ll tl, ll tr, ll l, ll r, ll k){
    
    if(l<=tl && tr<=r){
        
        auto x = upper_bound(tv[v].begin(), tv[v].end(), k) - tv[v].begin();
        
        return tv[v].size() - x;
        
    }
    if(l>tr || r<tl){
        return 0;
    }
    
    ll tm = (tl+tr)/2;
    
    ll x = tree_query_2(v*2+1, tl, tm, l, r, k)+ tree_query_2(v*2+2, tm+1, tr, l, r, k);
    
    //cout<<"   "<<l<<" "<<r<<" "<<x<<endl;
    
    return x;
    
}





int main() {
    
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
    
    cin>>n>>k;
    
    res = 1;
    
    for(int i=1;i<=n;i++){
        cin>>a[i].a;
        a[i].x = i;
    }
    
    sort(a+1, a+1+n, cmp);
    
    
    b[a[1].x] = 1;
    key[b[a[1].x]] = a[1].a;
    
    for(int i=2;i<=n;i++){
        if(a[i].a==a[i-1].a) b[i] = b[i-1];
        else{
            b[a[i].x] = b[a[i-1].x]+1;
            key[b[a[i].x]] = a[i].a;
        }
    }
    
    build_tree_2(0, 1, n);
    
    build_tree(0, 1, n);
    
    
    for(int i=1;i<=n;i++){
        
        ll l, r;
        l = find_l(i);
        r = find_r(i);
        
        
        ll x = tree_query_2(0, 1, n, l+1, r-1, b[i]);
        
        
        //cout<<i<<" "<<l<<" "<<r<<" "<<x<<endl;
        
        res*=(x+1);
        res%=mod;
    }
    
    cout<<res<<endl;
    
    
    return 0;
}


/*
 9 11
 4 1 8 7 3 2 9 6 5
 */
