#include <bits/stdc++.h>

using namespace std;


void bfs(vector<int> perm, vector< vector<int> >& seen, vector< vector<int> >& g) { // index i at pos perm[i]

    // check if seen
    bool found = false;
    for(int j=0; j<seen.size(); ++j) {
        bool eq = true;
        for(int t=0; t<perm.size(); ++t) {
            if(seen[j][t] != perm[t]) {eq = false; break;}
        }
        if(eq) found = true;
    }

    if(found) return;



    seen.push_back(perm);
    for(int i=0; i<perm.size()-1; ++i) {
        // if perm[i+1] in g[perm[i]]
        bool found = false;
        for(int j=0; j<g[perm[i]].size(); ++j) {
            if(g[perm[i]][j] == perm[i+1]) found = true;
        }
        if(found) {
            // swap perm[i] and perm[i+1]
            int t = perm[i];
            perm[i] = perm[i+1];
            perm[i+1] = t;

            bfs(perm, seen, g);

            // swap perm[i] and perm[i+1]
            t = perm[i];
            perm[i] = perm[i+1];
            perm[i+1] = t;
        }
    }
}

int main() {

    int n, k; cin >> n >> k;
    int arr[n];
    for(int i=0; i<n; ++i) {
        cin >> arr[i];
    }

    vector< vector<int> > g;
    for(int i=0; i<n; ++i) {
        vector<int> x; g.push_back(x);
    }
    for(int i=0; i<n; ++i) {
        for(int j=i+1; j<n; ++j) {
            if(arr[i] + arr[j] <= k && arr[i] != arr[j]) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    vector<int> perm;
    for(int i=0; i<n; ++i) perm.push_back(i);
    vector< vector<int> > seen;
    bfs(perm, seen, g);
    cout << seen.size() << "\n";

    return 0;
}
