#include "ones.h"
#include <cassert>
// #include "Lgrader.cpp"

using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flips(n);
    auto query = [&](vector<int> v) {
        for (int x : v) flips[x] = true;
        int z = flip_bits(flips);
        for (int x : v) flips[x] = false;
        return z;
    };

    vector<int> v{};
    int longest = query(v);
    vector<bool> defo1(n, 0);
    int slrz = 1;
    for (int i = 0; longest < n; i = (i+1)%n) {
        if (!i) {
            assert(slrz);
            slrz = 0;
        }
        if (defo1[i]) continue;
        v.push_back(i);
        int current = query(v);
        v.clear();
        if (current < longest) { // now 0
            v.push_back(i); // flip back to 1 next query
            defo1[i] = true;
            ++slrz;
        } else if (current > longest) { // now 1
            defo1[i] = true;
            ++slrz;
        }
        longest = query(v);
        v.clear();
    }
    return {0, n-1};
}

