#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define sz(c) (int)c.size()
#define all(c) c.begin(),c.end()
#define f first
#define s second

// Something to do with dp as there is a mod
// identify a swapping region for each element?
// there will be some pairs that won't be able to swap
// then some factorial/choose function thing?
// get the ones that aren't able to pass each other and do the 
// choose function to find the combinations
// after separating into groups then you can combine them kinda?
// for the first one, lets iterate over all n! ways and then
// check if they are obtainable
// just need to save some inequalities

const ll MOD = 1e9+7, mxN = 7;
vector<ll> a(mxN);
vector<pair<ll,ll> > ineq;
ll n, k, out = 0;

vector<ll> st;

// This checks if the current stack arrangement is possible
// this may be quite inefficient
ll possible() {
	map<ll,ll> m;
	for (ll i = 0; i < sz(st); i++)
		m[st[i]] = i;

	for (ll i = 0; i < sz(ineq); i++)
		if (m[ineq[i].f] > m[ineq[i].s])
			return 0;
	return 1;
}

void dfs(ll seen) {
	if (seen == (1<<n)-1) {
		out += possible();
		return;
	}
	for (ll i = 0; i < n; i++) {
		if (!(seen&(1<<i))) {
			st.push_back(a[i]);
			dfs(seen|(1<<i));
			st.pop_back();
		}
	}
}

void solve() {
	cin >> n >> k;
	for (ll i = 0; i < n; i++)
		cin >> a[i];

	for (ll i = 0; i < n; i++)
		for (ll j = i+1; j < n; j++)
			if (a[i] + a[j] > k)
				ineq.push_back({a[i],a[j]});

	dfs(0);

	cout << out << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}
