#include<bits/stdc++.h>
#define MAXN 300007
using namespace std;

const long long mod=1e9+7;

int n,k;
int a[MAXN];
long long fact[MAXN];

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (a*power(power(a,b/2),2))%mod;
}

long long solve(int l,int r,int mins){
    if(l>=r)return 1;

    int maxpos=0;
    for(int i=l;i<=r;i++){
        if(a[i]>a[maxpos] and a[i]>mins)maxpos=i;
    }
    if(maxpos==0)return 1;

    int cnt=0;
    for(int i=l;i<maxpos;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins)cnt++;
    }
    for(int i=maxpos+1;i<=r;i++){
        if(a[i]+a[maxpos]<=k and a[i]>mins)cnt++;
    }

    long long lt=solve(l,maxpos-1,max(k-a[maxpos],0));
    long long rt=solve(maxpos+1,r,max(k-a[maxpos],0));

    return (((lt*rt)%mod)*((fact[r-l+1]*power(fact[r-l+1-cnt],mod-2))%mod))%mod;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    fact[0]=1;
    for(long long i=1;i<=n;i++){
        fact[i]=(fact[i-1]*i)%mod;
    }

    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    cout<<solve(1,n,0)<<"\n";

    return 0;
}
