#include <bits/stdc++.h>
#include "ones.h"
#define endl "\n"
using namespace std;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; } 
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; } 
typedef long long ll;
const ll mod = 1e9 + 7;

int randomize(int n) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(rand() % 2);
	}
	return flip_bits(flips);
}

int only_one(int n, int who) {
	vector<bool> flips = {};
	for(int i = 0; i < n; i ++) {
		flips.push_back(i == who);
	}
	return flip_bits(flips);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
	int what;
	while((what = randomize(n)) < n / 2) {}

	int where;
	while(only_one(n, where = rand() % n) == what) {}
	only_one(n, where);

	pair<int, int> ret;

	{
		if(where == 0) {
			ret.first = where;
		} else {
			int l = 0, r = where;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				
				if(now < what) {
					only_one(n, m);
					r = m;
				} else {
					l = m;
				}
			}
			
			if(l == 0) {
				if(only_one(n, l) != what) {
					r --;
					only_one(n, l);
				}
			}
			ret.first = r;
		}
	}

	{
		if(where == n - 1) {
			ret.second = where;
		} else {
			int l = where, r = n - 1;
			while(l < r - 1) {
				int m = (l + r) / 2ll;
				int now = only_one(n, m);
				
				if(now < what) {
					only_one(n, m);
					l = m;
				} else {
					r = m;
				}
			}
			if(r == n - 1) {
				if(only_one(n, r) != what) {
					l ++;
					only_one(n, r);
				}
			}
			ret.second = l;
		}
	}

	return ret;
}
