// I taka produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kiucheka konq vihur 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include "ones.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
std::vector <bool> flips, curr;
int askQuery()
{
	for (int i = 0 ; i < flips.size() ; ++i)
	{
		flips[i] = flips[i] ^ curr[i];
	}

	int res = flip_bits(flips);
	for (int i = 0 ; i < flips.size() ; ++i)
	{
		flips[i] = curr[i];
	}

	return res;
}

void askFinalQuery()
{
	flip_bits(flips);
}

std::pair <int,int> find_longest_subarray_of_ones(int N)
{
	n = N;
	curr.resize(n);
	flips.resize(n);
	std::fill(curr.begin(), curr.end(), false);
	std::fill(flips.begin(), flips.end(), false);
	
	int begin = askQuery();
	if (begin == n) return {0, n - 1};
	for (int i = 0 ; i < n ; ++i)
	{
		int res;
		curr[i] = 1;
		if (i != 0) curr[i-1] = 0;
		if (i == n-1) res = INF;
		else res = askQuery();
		if (res < begin) 
		{
			askFinalQuery();
			return {i, i + begin - 1};
		}

		if (res > begin)
		{
			askFinalQuery();
			return {i + 1, i + begin};
		}
	}

	std::cout << "wtf\n";
	return {-1, -1};
}