#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

const int maxn = 3e5 + 10;
const ll mod = 1e9 + 7;

int n;
ll k, a[maxn], f[maxn], pos[maxn], t[maxn];

ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2 == 1)
            ans = (ans * base) % mod;
        st /= 2;
        base = (base * base) % mod;
    }
    return ans;
}

map < ll, ll > mp;
ll fac[maxn], rev_fac[maxn];

struct node
{
    ll mx, cnt;

    node(ll _mx = 0, ll _cnt = 0)
    {
        mx = _mx;
        cnt = _cnt;
    }
};

node merge_node(node nd1, node nd2)
{
    node nd;
    nd.mx = max(nd1.mx, nd2.mx);
    nd.cnt = nd1.cnt + nd2.cnt;
    return nd;
}

int fen[maxn];
void update(int v)
{
    for (int i = v; i < maxn; i += (i & (-i)))
        fen[i] ++;
}

int get(int v)
{
    int s = 0;
    for (int i = v; i > 0; i -= (i & (-i)))
        s += fen[i];
    return s;
}

ll sum(int left, int right)
{
    return get(right) - get(left - 1);
}
unordered_map < ll, vector < int > > to_get;
vector < int > to_rem[maxn];

const int maxlog = 21;

int dp[maxlog][maxn], lg[maxn];

void build_sparse_table()
{
    for (int i = 1; i <= n; i ++)
    {
        lg[i] = lg[i / 2] + 1;
        dp[0][i] = a[i];
    }

    for (int j = 1; j < lg[n]; j ++)
    {
        for (int i = 1; i <= n; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (dp[j - 1][i + (1 << (j - 1))] > dp[j][i])
            {
                dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
            }
        }
    }
}

int rmq(int left, int right)
{
    int len = lg[right - left + 1] - 1;
    return max(dp[len][left], dp[len][right - (1 << len) + 1]);
}

void solve()
{
    cin >> n >> k;
    vector < pair < ll, int > > v;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        to_get[a[i]].push_back(i);
        v.push_back({a[i], i});
    }
    build_sparse_table();
    ///cout << rmq(1, 3) << endl;
    sort(v.begin(), v.end());
    for (int i = 0; i < n; i ++)
    {
        pos[i + 1] = v[i].second;
        ///mp[v[i]] = i + 1;
    }

    /**for (int i = 1; i <= n; i ++)
    {
        f[i] = mp[a[i]];
        pos[f[i]] = i;
    }*/

    ll ans = 1;
    set < int > my_set;
    my_set.insert(0);
    my_set.insert(n + 1);
    stack < int > q;
    for (int i = n; i > 0; i --)
    {
        while(!q.empty())
        {
            int cur = q.top();
            if (a[pos[i]] + a[cur] <= k)
            {
                q.pop();
                my_set.erase(cur);
            }
            else
            {
                break;
            }
        }

        my_set.insert(pos[i]);
        /**q.push(pos[i]);
        set < int > :: iterator it = my_set.find(pos[i]);
        int lf = *prev(it);
        int rf = *next(it);

        update(pos[i]);
        ll cnt = sum(lf + 1, rf - 1);
        ans = (ans * cnt) % mod;*/


    }
    ///cout << ans << endl;
    fac[0] = 1;
    rev_fac[0] = power(fac[0], mod - 2);
    for (int i = 1; i <= n; i ++)
    {
        fac[i] = (fac[i - 1] * (ll)(i)) % mod;
        rev_fac[i] = power(fac[i], mod - 2);
    }

    for (int i = 0; i < n; i ++)
    {
        if (i != 0 && v[i].first == v[i - 1].first)
            continue;
            int cnt = 1;
            vector < int > cur = to_get[v[i].first];
            for (int j = 1; j < cur.size(); j ++)
            {
                int bef = cur[j - 1], nw = cur[j];
                int num = rmq(bef, nw);
                ///cout << bef << " " << nw << " " << num << endl;
                if (num + v[i].first > k)
                {
                    ans = (ans * rev_fac[cnt]) % mod;
                    ///cout << cnt << endl;
                    cnt = 0;
                }
                cnt ++;
            }
            /**for (int j = 1; j <= n; j ++)
            {
                if (a[j] + v[i].first > k)
                {
                    ans = (ans * rev_fac[cnt]) % mod;
                    ///cout << cnt << endl;
                    cnt = 0;
                }
                if (a[j] == v[i].first)
                    cnt ++;
            }*/

            ans = (ans * rev_fac[cnt]) % mod;
    }
    cout << ans << endl;


}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
5 7
4 3 1 5 2

5 4
4 3 1 5 2

5 3
1 1 3 1 1
*/
