#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll mod=1e9+7;
const int MAXN=3e5+6;
int w[MAXN];
vector<pair<int,int> >v;
int w1[MAXN],n,k;
ll ans=1;
struct node
{
	int cnt=0;
	int max_val=0;
};
struct segment_tree
{
	node tree[3*MAXN];
	void update(int l,int r,int idx,int qidx,int val)
	{
		if(l>qidx)return;
		if(r<qidx)return;
		if(l==r)
		{
			tree[idx].cnt=1;
			tree[idx].max_val=val;
			return;
		}
		int mid=(l+r)/2;
		update(l,mid,idx*2,qidx,val);
		update(mid+1,r,idx*2+1,qidx,val);
		tree[idx].cnt=tree[idx*2].cnt+tree[idx*2+1].cnt;
		tree[idx].max_val=max(tree[idx*2].max_val,tree[idx*2+1].max_val);
	}
	pair<int,int> query1(int l,int r,int idx,int ql,int qr,int val)
	{
		if(l>qr)return {0,0};
		if(r<ql)return {0,0};
		if(l>r)return {0,0};
		if(ql>qr)return {0,0};
		if(l>=ql&&r<=qr)
		{
			if(tree[idx].max_val<=val)return {tree[idx].cnt,tree[idx].max_val};
			if(l==r)return {0,tree[idx].max_val};
			int mid=(l+r)/2;
			if(tree[idx*2].max_val>val)
			{
				return {query1(l,mid,idx*2,ql,qr,val).first,tree[idx*2].max_val};
			}
			else 
			{
				return {query1(l,mid,idx*2,ql,qr,val).first+query1(mid+1,r,idx*2+1,ql,qr,val).first,tree[idx*2+1].max_val};
			}
		}
		int mid=(l+r)/2;
		pair<int,int>qleft=query1(l,mid,idx*2,ql,qr,val);
		if(qleft.second>val)return qleft;
		pair<int,int>qright=query1(mid+1,r,idx*2+1,ql,qr,val);
		return {qleft.first+qright.first,max(qleft.second,qright.second)};
	}
	pair<int,int>query2(int l,int r,int idx,int ql,int qr,int val)
	{
		if(l>qr)return {0,0};
		if(r<ql)return {0,0};
		if(l>r)return {0,0};
		if(ql>qr)return {0,0};
		if(l>=ql&&r<=qr)
		{
			if(tree[idx].max_val<=val)return {tree[idx].cnt,tree[idx].max_val};
			if(l==r)return {0,tree[idx].max_val};
			int mid=(l+r)/2;
			if(tree[idx*2+1].max_val>val)
			{
				return {query2(mid+1,r,idx*2+1,ql,qr,val).first,tree[idx*2+1].max_val};
			}
			else 
			{
				return {query2(l,mid,idx*2,ql,qr,val).first+query2(mid+1,r,idx*2+1,ql,qr,val).first,tree[idx*2].max_val};
			}
		}
		int mid=(l+r)/2;
		pair<int,int>qright=query2(mid+1,r,idx*2+1,ql,qr,val);
		if(qright.second>val)return qright;
		pair<int,int>qleft=query2(l,mid,idx*2,ql,qr,val);
		return {qleft.first+qright.first,max(qleft.second,qright.second)};
	}
}ogi;
int main()
{
	cin>>n>>k;
	for(int i=1;i<=n;i++)
	{
		cin>>w[i];
		v.push_back({w[i],i});
	}
	sort(v.rbegin(),v.rend());
	for(int i=0;i<v.size();i++)
	{
		int idx=v[i].second;
		ll cnt=0;
		//cout<<i<<endl;
		cnt+=ogi.query1(1,n,1,idx+1,n,k-w[idx]).first;
		//cout<<"*\n";
		cnt+=ogi.query2(1,n,1,1,idx-1,k-w[idx]).first;
		//cout<<"?\n";
		ans*=(cnt+1ll);
		ans%=mod;
		
		
		ogi.update(1,n,1,idx,w[idx]);
	}
	cout<<ans<<endl;
return 0;
}
