#include "ones.h"
#include <bits/stdc++.h>
using namespace std;

std::pair<int,int> find_longest_subarray_of_ones(int n)
{
    vector <bool> v(n, 0);

    int len = flip_bits(v);

    int ind = -1;

    for (int i = 0; i < n; i++)
    {
        v[i] = 1;

        int p = flip_bits(v);

        if (p > len)
        {
            v[i] = 0;
            len = p;
            ind = i;
            break;
        }
        else if (p < len)
        {
            v[i] = 0;
            ind = i;
            flip_bits(v);
            break;
        }

        flip_bits(v);
        v[i] = 0;
    }

    cerr << "ind = " << ind << endl;

    if (ind == -1)
    {
        exit(1);
    }

    int L = ind, R = ind;

    for (int i = ind; i >= 0; i--)
    {
        v[i] = 1;

        int p = flip_bits(v);
        flip_bits(v);

        v[i] = 0;

        if (p >= len) break;

        L = i;
    }

    for (int i = ind; i <= n; i++)
    {
        v[i] = 1;

        int p = flip_bits(v);
        flip_bits(v);

        v[i] = 0;

        if (p >= len) break;

        R = i;
    }


    return {L, R};
}

/**

1 0 1 0 1 0

*/
