#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 300000;
const long long MOD = 1000000007;

int a[MAXN + 5];
bool used[MAXN + 5];


long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    cin >> n >> k;

    a[0] = a[n + 1] = k;
    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        v.push_back({a[i], i});
    }
    sort(v.begin(), v.end());

    long long ans = 1;
    for (int i = 0; i < n; ++ i)
    {
        int cnt = 1, cnt1 = 1;
        int p = v[i].second;
        int j = p - 1;
        while (a[j] + a[p] <= k)
        {
            if (a[j] > a[p]) cnt++;
            if (a[j] == a[p]) cnt1++;
            j--;
        }
        j = p + 1;
        while (a[j] + a[p] <= k)
        {
            if (a[j] >= a[p]) cnt++;
            j++;
        }
        ans = (ans * cnt) % MOD;
        ans = (ans * modpow(cnt1, MOD - 2)) % MOD;
    }
    cout << ans << endl;

    return 0;
}
