///#include "Lgrader.cpp"
#include "ones.h"
#include <iostream>
#include <random>
#include <vector>
using namespace std;

mt19937 rg(44109349);

int flip_bits(const vector<bool> &flips);

pair<int, int> find_longest_subarray_of_ones(int n)
{
    vector<bool> v(n, false);
    int curr = flip_bits(v);

    while (curr < n)
    {
        int temp;
        while (true)
        {
            int pos = rg() % n;
            v[pos] = 1;
            temp = flip_bits(v);
            if (temp > curr)
            {
                v[pos] = 0;
                break;
            }
            flip_bits(v);
            v[pos] = 0;
        }
        curr = temp;
    }

    return {0, n - 1};
}
