#include "ones.h"
#include <iostream>
#include <vector>
using namespace std;

int flip_bits(const vector<bool> &flips);

pair<int, int> find_longest_subarray_of_ones(int n)
{
    vector<bool> v(n, false);
    int curr = flip_bits(v);

    if (curr == n) return {0, n - 1};
    if (curr == 0) return {0, -1};

    int pos;
    for (int i = 0; i < n; ++ i)
    {
        v[i] = true;
        int temp = flip_bits(v);
        if (temp > curr)
        {
            pos = i;
            curr = temp;
            v[i] = false;
            break;
        }
        flip_bits(v);
        v[i] = false;
    }

    int l = 0;
    for (int j = pos - 1; j >= 0; -- j)
    {
        v[j] = true;
        int temp = flip_bits(v);
        flip_bits(v);
        v[j] = false;
        if (temp > curr)
        {
            l = j + 1;
            break;
        }
    }

    int r = l + curr - 1;

    return {l, r};
}
