#include <bits/stdc++.h>
#include "ones.h"
using namespace std;

int answer;
int flip(int index, vector<bool>& bits)
{
    bits[index] = 1;
    answer = flip_bits(bits);
    bits[index] = 0;
    return answer;
}

pair<int,int> find_longest_subarray_of_ones(int n)
{
    vector<bool> bits(n, 0);
    int initial = flip_bits(bits);

    if(initial == 0)
    {
        flip(0, bits);
        return {0, 0};
    }

    if(flip(0, bits) < initial) return {1, initial-1};
    flip(0, bits);

    for(int i = 0; i < n; i++)
    {
        int flipped = flip(i, bits);
        if(flipped > initial+1)
        {
            flipped = flip(i-1, bits);
            if(flipped == initial+1)
                return { i-(flipped-initial-1), i+initial};
        }
        else if(flipped == initial+1)
            return { i-(flipped-initial-1), i+initial};
        flip(i, bits);
    }
}
