#include <iostream>
#include "ones.h"

#include <vector>
using namespace std;

pair<int,int> find_longest_subarray_of_ones(int n)
{
    vector <bool> flips;
    flips.resize(n);
    for(int i=0; i<n; i++)
    {
        flips[i]=false;
    }
    int longests=flip_bits(flips);
    if(longests==n)
    {
        return {0, n-1};
    }
    int i=0;
    int curr;
    flips[i]=true;
    bool increase=false;
    int first, last;
    for(i=0; i<n; i++)
    {
        flips[i]=true;
        curr=flip_bits(flips);
        flips[i]=false;
        if(curr>longests)
        {
            increase=true;
            break;
        }
        else if(curr<longests)
        {
            increase=false;
            break;
        }
    }
    if(increase && curr==n)
    {
        first=0;
        last=n-1;
    }
    else if(increase)
    {
        //cout << i << endl;
        longests=curr;
        int j;
        for(j=i-1; j>=max(0, i-longests+1); j--)
        {
            flips[j]=true;
            curr=flip_bits(flips);
            if(curr>longests)
            {
                curr=flip_bits(flips);
                flips[j]=false;
                break;
            }
            else
            {
                curr=flip_bits(flips);
            }
            flips[j]=false;
        }
        first=j+1;
        //cout << first << endl;
        for(j=i+1; j<=min(n-1, i+longests-1); j++)
        {
            flips[j]=true;
            curr=flip_bits(flips);
            if(curr>longests)
            {
                curr=flip_bits(flips);
                flips[j]=false;
                break;
            }
            else
            {
                curr=flip_bits(flips);
            }
            flips[j]=false;
        }
        last=j-1;
    }
    else
    {
        i++;
        //cout << i << endl;
        first=i;
        longests=curr;
        int j;
        for(j=i+1; j<=min(n-1, i+longests-1); j++)
        {
            flips[j]=true;
            curr=flip_bits(flips);
            if(curr>longests)
            {
                curr=flip_bits(flips);
                flips[j]=false;
                break;
            }
            else
            {
                curr=flip_bits(flips);
            }
            flips[j]=false;
        }
        last=j-1;
    }
    return {first, last};
}
