#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr); cout.tie(nullptr);
}

int flip_bits(const std::vector<bool> &flips);

std::pair<int, int> find_longest_subarray_of_ones(int n) {
  vector<bool> all_false(n, false);
  vector<bool> all_true(n, true);

  int maxim2 = flip_bits(all_false);
  if(maxim2 == n) {
    return {0, n - 1};
  }

  if(maxim2 == 0) {
    flip_bits(all_true);
    return {0, n - 1};
  }

  int maxim1 = flip_bits(all_true);
  if(maxim1 < maxim2) {
    flip_bits(all_true);
  } else [
    maxim2 = maxim1;
  ]

  for(int i = 0; i < n; i++) {
    vector<bool> ask(n, false);
    ask[i] = true;
    int ansi = flip_bits(ask);
    if(ansi > maxim2) {
      int l = i + 1, r = n - 1, patasxan_right = i;
      while(l <= r) {
        int m = (l + r) / 2;
        vector<bool> new_ask(n, false);
        new_ask[m] = 1;
        int pt = flip_bits(new_ask);
        if(pt < ansi) {
          patasxan_right = m;
          l = m + 1;
        } else {
          r = m - 1;
        }
        pt = flip_bits(new_ask);
      }
      return make_pair(patasxan_right - ansi + 1, patasxan_right);
    }
    flip_bits(ask);
  }

  return {0, 0};
}

/*
int main() {
  long long p, q, n; cin >> p >> q >> n;

  long long answ = 0;
  for(long long i = 1; i <= min(n, (p * q) / 4); i++) {
    for(long long j = 1; j <= p; j++) {
      long long xd = i * j, xd_ = (j - i);
      if(xd > 0 && xd_ > 0 && xd % xd_ == 0 && xd / xd_ <= q) {
        answ++;
      }
    }
  }

  cout << answ << endl;
  return 0;
}\
*/