#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define pii pair<int, int>

const int N = 3e5 + 10, mod = 1e9 + 7;

int n, k;
int a[N];
ll fact[N];

void precalc() {
	fact[0] = 1;
	for (int i = 1; i <= n + 2; i++) {
		fact[i] = fact[i - 1] * i;
		fact[i] %= mod;
	}
}

ll solve(vector<int> v) {
	int n = v.size();
	if (n == 0)
		return 1;
	int mn = mod;
	for (int i = 0; i < n; i++) {
		mn = min(mn, v[i]);
	}
	vector<int> barier;
	for (int i = 0; i < n; i++) {
		if (mn + v[i] > k) {
			barier.push_back(i);
		}
	}
	if (barier.size() == 0)
		return fact[n];
	ll ans = 1;
	barier.push_back(n);
	int cnt = 0;
	vector<int> cur;
	int i = 0;
	for (int r : barier) {
		while(i < r) {
			if (v[i] == mn) 
				cnt++;
			else 
				cur.push_back(v[i]);
			i++;
		}
		i++;
		if (cnt == 1) {
			ll wtf = solve(cur) * ((ll)cur.size() + 1);
			wtf %= mod;
			ans *= wtf;
		}
		else {
			ans *= solve(cur);
		}
		ans %= mod;
		cnt = 0;
		cur.clear();
	}
	return ans;
}

int main() {
	cin >> n >> k;
	precalc();
	vector<int> v;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		v.push_back(a[i]);
	}
	cout << solve(v) % mod << endl;
}