#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define pii pair<ll, ll>

const ll N = 3e5 + 10, mod = 1000000007;

ll n, k;
ll a[N];
ll fact[N];

void precalc() {
	fact[0] = 1;
	for (ll i = 1; i <= n + 2; i++) {
		fact[i] = fact[i - 1] * i;
		fact[i] %= mod;
	}
}

ll solve(vector<ll> v) {
	ll n = v.size();
	if (n == 0)
		return 1;
	ll mn = mod;
	for (ll i = 0; i < n; i++) {
		mn = min(mn, v[i]);
	}
	vector<ll> barier;
	for (ll i = 0; i < n; i++) {
		if (mn + v[i] > k) {
			barier.push_back(i);
		}
	}
	if (barier.size() == 0)
		return fact[n];
	ll ans = 1;
	barier.push_back(n);
	ll cnt = 0;
	vector<ll> cur;
	ll i = 0;
	for (ll r : barier) {
		while(i < r) {
			if (v[i] == mn) 
				cnt++;
			else 
				cur.push_back(v[i]);
			i++;
		}
		i++;
		if (cnt == 1) {
			ll wtf = solve(cur) * ((ll)cur.size() + 1);
			wtf %= mod;
			ans *= wtf;
		}
		else {
			ans *= solve(cur);
		}
		ans %= mod;
		cnt = 0;
		cur.clear();
	}
	return ans;
}

ll main() {
	cin >> n >> k;
	precalc();
	vector<ll> v;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		v.push_back(a[i]);
	}
	cout << solve(v) % mod << endl;
}