#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define pii pair<int, int>

const int N = 3e5 + 2, mod = 1e9 + 7;

int n, k;
vector<int> v(n);
ll fact[N];

void precalc() {
    fact[0] = 1;
    for (int i = 1; i <= n + 1; i++) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
}

ll solve(vector<int> v) {
    int n = v.size();
    if (n == 0)
        return 1;
    int mn = mod;
    for (int i = 0; i < n; i++) {
        mn = min(mn, v[i]);
    }
    vector<int> barier;
    for (int i = 0; i < n; i++) {
        if (mn + v[i] > k) {
            barier.push_back(i);
        }
    }
    if (barier.size() == 0)
        return fact[n];
    ll ans = 1;
    barier.push_back(n);
    int cnt = 0;
    vector<int> cur;
    int i = 0;
    for (int r : barier) {
        cnt = 0;
        cur.clear();
        while (i < r) {
            if (v[i] == mn)
                cnt++;
            else
                cur.push_back(v[i]);
            i++;
        }
        i++;
        ans *= solve(cur);
        ans %= mod;
        if (cnt == 1) {
            ans *= (cur.size() + 1);
            ans %= mod;
        }
    }
    return ans;
}

int main() {
    cin >> n >> k;
    precalc();
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    cout << solve(v) << endl;
}