#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define pii pair<int, int>


ll n, p, q;

ll gcd(ll a, ll b) {
	return a == 0 ? b : gcd(b % a, a);
}

ll cnt(ll a, ll b) {
	return min(min(
		p / (a * (a + b)),
		q / (b * (a + b))),
		n / (a * b));
}

int main() {
	cin >> p >> q >> n;
	ll ans = cnt(1, 1);
	ll maxB = sqrt(q) + 1;
	for (ll b = 2; b <= maxB; b++) {
		for (ll a = 1; a < b; a++) {
			if (gcd(a, b) == 1) {
				ll x = cnt(a, b);
				//cout << a << " " << b << " " << x << endl;
				ans += x;
				if (x == 0)
					break;
			}
		}
	}
	swap(p, q); 
	maxB = sqrt(q) + 1;
	for (ll b = 2; b <= maxB; b++) {
		for (ll a = 1; a < b; a++) {
			if (gcd(a, b) == 1) {
				ll x = cnt(a, b);
				//cout << a << " " << b << " " << x << endl;
				ans += x;
				if (x == 0)
					break;
			}
		}
	}
	cout << ans << endl;
}