#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 1000000007;

const int maxn = 300500;
int fac[maxn];
int ifac[maxn];

int bpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = res * a % mod;
        }
        a = a * a % mod;
        b >>= 1;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    fac[0] = 1;
    for (int i = 1; i < maxn; i++) {
        fac[i] = fac[i - 1] * i % mod;
    }
    ifac[maxn - 1] = bpow(fac[maxn - 1], mod - 2);
    for (int i = maxn - 2; i >= 0; i--) {
        ifac[i] = ifac[i + 1] * (i + 1) % mod;
    }
    int n, k; cin >> n >> k;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<int> q = {1};
    vector<int> dp(n + 1);
    dp[0] = 1;
    for (int i = 1; i <= n; i++) {
        set<int, greater<int>> B;
        B.insert(w[i - 1]);
        for (int j = i - 2; j >= 0 && *B.begin() + w[j] <= k; j--) {
            B.insert(w[j]);
        }
        int len = (int)B.size();
        dp[i] = dp[i - len] * fac[len] % mod;
    }
    cout << dp[n];
    return 0;
}