#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
const int M = 1e9 + 7;

int add(int a, int b) {
	return a + b < M ? a + b : a + b - M;
}

int mul(int a, int b) {
	return a * 1ll * b % M;
}

int pw(int a, int n) {
	int ret = 1;
	for (; n > 0; n >>= 1, a = mul(a, a)) {
		if (n & 1) {
			ret = mul(ret, a);
		}
	}
	return ret;
}

int f[N], rf[N];

int c(int n, int k) {
	return mul(f[n], mul(rf[k], rf[n - k]));
}

int n, k;
int w[N];
int ans = 1;
int kek = 1;
int kekcnt[N];
vector<int> lol;

int findmin(int l, int r) {
	int ind = -1;
	for (int i = l; i < r; ++i) {
		if (w[i] != -1 && (ind == -1 || w[i] < w[ind])) {
			ind = i;
		}
	}
	return ind;
}

int findmax(int l, int r) {
	int ind = -1;
	for (int i = l; i < r; ++i) {
		if (w[i] != -1 && (ind == -1 || w[i] > w[ind])) {
			ind = i;
		}
	}
	return ind;
}

int findcnt(int l, int r) {
	int cnt = 0;
	for (int i = l; i < r; ++i) {
		if (w[i] != -1) {
			++cnt;
		}
	}
	return cnt;
}

void solve(int l, int r) {
	if (l >= r) {
		return;
	}
	int mx = findmax(l, r);
	if (mx == -1) {
		return;
	}
	int cnt = 0;
	kek = 1;
	lol.clear();
	while (true) {
		int mn = findmin(l, mx);
		if (mn == -1) {
			break;
		}
		if (w[mn] + w[mx] > k) {
			break;
		}
		++cnt;
		kek = mul(kek, f[kekcnt[w[mn]]]);
		++kekcnt[w[mn]];
		kek = mul(kek, rf[kekcnt[w[mn]]]);
		lol.push_back(w[mn]);
		w[mn] = -1;
	}
	while (true) {
		int mn = findmin(mx + 1, r);
		if (mn == -1) {
			break;
		}
		if (w[mn] + w[mx] > k) {
			break;
		}
		++cnt;
		kek = mul(kek, f[kekcnt[w[mn]]]);
		++kekcnt[w[mn]];
		kek = mul(kek, rf[kekcnt[w[mn]]]);
		lol.push_back(w[mn]);
		w[mn] = -1;
	}
	if (2 * w[mx] <= k) {
		kek = mul(kek, f[kekcnt[w[mx]]]);
		++kekcnt[w[mx]];
		kek = mul(kek, rf[kekcnt[w[mx]]]);
		ans = mul(ans, mul(f[cnt + 1], kek));
	} else {
		ans = mul(ans, mul(f[cnt], kek));
		ans = mul(ans, c(cnt + findcnt(l, r), cnt));
		w[mx] = -1;
	}
	for (int rofl : lol) {
		kekcnt[rofl] = 0;
	}
	solve(l, mx);
	solve(mx + 1, r);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	f[0] = 1;
	for (int i = 1; i < N; ++i) {
		f[i] = mul(f[i - 1], i);
	}
	rf[N - 1] = pw(f[N - 1], M - 2);
	for (int i = N - 2; i >= 0; --i) {
		rf[i] = mul(rf[i + 1], i + 1);
	}
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	solve(0, n);
	cout << ans << endl;
	return 0;
}
