#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(331);

pair<int, int> find_longest_subarray_of_ones(int n) {
	vector<bool> flips(n, false);
	for (int i = 0; i < n; ++i) {
		if (rnd() & 1) {
			flips[i] = true;
		} else {
			flips[i] = false;
		}
	}
	int len = flip_bits(flips);
	fill(flips.begin(), flips.end(), false);
	if (len == 0) {
		flips[0] = true;
		flip_bits(flips);
		return {0, 0};
	}
	if (len == n) {
		return {0, n - 1};
	}
	int ind = -1;
	for (int i = 0; i < len + 1; ++i) {
		vector<int> ord;
		for (int j = i; j < n; j += len + 1) {
			ord.push_back(j);
		}
		for (int j : ord) {
			flips[j] = true;
		}
		int nlen = flip_bits(flips);
		if (nlen > len) {
			flip_bits(flips);
			for (int j : ord) {
				flips[j] = false;
			}
			int l = 0, r = ord.size();
			while (r - l > 1) {
				int mid = (l + r) / 2;
				for (int j = 0; j < mid; ++j) {
					flips[ord[j]] = true;
				}
				int nlen = flip_bits(flips);
				if (nlen > len) {
					r = mid;
				} else {
					l = mid;
				}
				flip_bits(flips);
				for (int j = 0; j < mid; ++j) {
					flips[ord[j]] = false;
				}
			}
			for (int j = 0; j < r; ++j) {
				flips[ord[j]] = true;
			}
			len = flip_bits(flips);
			ind = ord[l];
			for (int j = 0; j < r; ++j) {
				flips[ord[j]] = false;
			}
			break;
		}
		flip_bits(flips);
		for (int j : ord) {
			flips[j] = false;
		}
	}
	int l = ind, r = n;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			r = mid;
		} else {
			l = mid;
		}
		flip_bits(flips);
		flips[mid] = false;
	}
	int R = l;
	l = -1, r = ind;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			l = mid;
		} else {
			r = mid;
		}	
		flip_bits(flips);
		flips[mid] = false;
	}
	int L = r;
	return {L, R};
}	
