#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd('V' + 'A' + 'L' + 'E' + 'R' + 'I' + 'K' + 'K');

pair<int, int> find_longest_subarray_of_ones(int n) {
	vector<bool> best_flips(n, false);
	vector<bool> cur_flips(n, false);
	int best_len = flip_bits(best_flips);
	for (int it = 0; it < 8; ++it) {
		vector<bool> flips(n, false);
		for (int i = 0; i < n; ++i) {
			if (rnd() & 1) {
				flips[i] = true;
			} else {
				flips[i] = false;
			}
			cur_flips[i] = cur_flips[i] ^ flips[i];
		}
		int len = flip_bits(flips);
		if (len < best_len) {
			best_flips = cur_flips;
			best_len = len;
		}
	}
	flip_bits(cur_flips);
	int len = flip_bits(best_flips);
	vector<bool> flips(n, false);
	if (len == 0) {
		flips[0] = true;
		flip_bits(flips);
		return {0, 0};
	}
	if (len == n) {
		return {0, n - 1};
	}
	int ind = -1;
	vector<int> kek(len + 1);
	for (int i = 0; i < len + 1; ++i) {
		kek[i] = i;
	}
	shuffle(kek.begin(), kek.end(), rnd);
	for (int i : kek) {
		vector<int> ord;
		for (int j = i; j < n; j += len + 1) {
			ord.push_back(j);
		}
		for (int j : ord) {
			flips[j] = true;
		}
		int nlen = flip_bits(flips);
		if (nlen > len) {
			flip_bits(flips);
			for (int j : ord) {
				flips[j] = false;
			}
			int l = 0, r = ord.size();
			while (r - l > 1) {
				int mid = (l + r) / 2;
				for (int j = 0; j < mid; ++j) {
					flips[ord[j]] = true;
				}
				int nlen = flip_bits(flips);
				if (nlen > len) {
					flip_bits(flips);
					r = mid;
				} else {
					l = mid;
				}
				for (int j = 0; j < mid; ++j) {
					flips[ord[j]] = false;
				}
			}
			for (int j = 0; j < r; ++j) {
				flips[ord[j]] = true;
			}
			len = flip_bits(flips);
			ind = ord[l];
			for (int j = 0; j < r; ++j) {
				flips[ord[j]] = false;
			}
			break;
		}
		flip_bits(flips);
		for (int j : ord) {
			flips[j] = false;
		}
	}
	int l = ind, r = min(n, ind + len);
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			r = mid;
		} else {
			l = mid;
		}
		flip_bits(flips);
		flips[mid] = false;
	}
	int R = l;
	l = max(-1, ind - len), r = ind;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		flips[mid] = true;
		int nlen = flip_bits(flips);
		if (nlen >= len) {
			l = mid;
		} else {
			r = mid;
		}
		flip_bits(flips);
		flips[mid] = false;
	}
	int L = r;
	return {L, R};
}	
