

#include "ones.h"

#include <bits/stdc++.h>



using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(1123123);
const ll inf = 1e18;


pair<int, int> solve_slow(int n, const int mx_bgans = 10){
    vector<bool> swp(n);
    for(int i = 0; i < n; i += 1){
        swp[i] = rnd() % 2;
    }
    ll bgans = flip_bits(swp);
    if(bgans == 0){
        return make_pair(0, -1);
    }
    while(bgans > mx_bgans){
        for(int i = 0; i < n; i += 1){
            swp[i] = rnd() % 2;
        }
        bgans = flip_bits(swp);
    }
    if(bgans == 0){
        return make_pair(0, -1);
    }
    if(bgans == n){
        return make_pair(0, n - 1);
    }
    int lst_msk = 0;
    int bst_msk = 0;
    int bst_msk_ans = bgans;
    swp.assign(n, 0);
    for(int msk = 0; msk < (1 << (bgans + 1)); msk += 1){
        for(int i = 0; i <= bgans; i += 1){
            swp[i] = (((lst_msk >> i) & 1) ^ ((msk >> i) & 1));
        }
        int mans = flip_bits(swp);
        if(mans > bst_msk_ans){
            bst_msk_ans = mans;
            bst_msk = msk;
        }
        lst_msk = msk;
    }
    for(int i = 0; i <= bgans; i += 1){
        swp[i] = (((lst_msk >> i) & 1) ^ ((bst_msk >> i) & 1));
    }
    ll d = flip_bits(swp);
    return make_pair(0, d - 1);
}


pair<int, int> solve(int n, const int qrs = 6){
    rnd = mt19937(51251253);
    if(n <= 5){
        return solve_slow(n, 2);
    }
    vector<bool> swp(n);
    vector<bool> msk(n);
    vector<bool> lst_msk(n, 0);
    vector<bool> bst_msk(n);
    ll bgans = n;
    for(int itr = 0; itr < qrs || bgans * 2 + 2 > n; itr += 1){
        for(int i = 0; i < n; i += 1){
            msk[i] = rnd() % 2;
            swp[i] = (lst_msk[i] ^ msk[i]);
            lst_msk[i] = msk[i];
        }
        int ans = flip_bits(swp);
        if(ans < bgans){
            bgans = ans;
            bst_msk = msk;
        }
    }
    for(int i = 0; i < n; i += 1){
        swp[i] = (bst_msk[i] ^ lst_msk[i]);
    }
    bgans = flip_bits(swp);
    if(bgans == 0){
        return make_pair(0, -1);
    }
    if(bgans == n){
        return make_pair(0, n - 1);
    }
    ll t = bgans + 1;
    int bsz = t * 2;
    int m = n / bsz;
    vector<int> masks(m, 0);
    vector<int> lst_masks(m, 0);
    swp.assign(n, false);
    int mans;
    while(1){
        for(int i = 0; i < m; i += 1){
            masks[i] = rnd() % (1 << t);
            for(int j = 0; j < t; j += 1){
                swp[i * bsz + j] = (((masks[i] >> j) & 1) ^ ((lst_masks[i] >> j) & 1));
            }
        }
        mans = flip_bits(swp);
        for(int i = 0; i < m; i += 1){
            lst_masks[i] = masks[i];
        }
        if(mans > bgans){
            break;
        }
    }
    if(mans == n){
        return make_pair(0, n - 1);
    }
    auto gd_masks = masks;
    int tl = -1;
    int tr = m - 1;
    while(tl + 1 < tr){
        int tm = (tl + tr) / 2;
        for(int i = 0; i < m; i += 1){
            if(i <= tm){
                masks[i] = gd_masks[i];
            } else{
                masks[i] = 0;
            }
            for(int j = 0; j < t; j += 1){
                swp[i * bsz + j] = (((masks[i] >> j) & 1) ^ ((lst_masks[i] >> j) & 1));
            }
        }
        int ans = flip_bits(swp);
        for(int i = 0; i < m; i += 1){
            lst_masks[i] = masks[i];
        }
        if(ans == mans){
            tr = tm;
        } else{
            tl = tm;
        }
    }
    for(int i = 0; i < m; i += 1){
        masks[i] = 0;
        if(tr == i){
            masks[i] = gd_masks[i];
        }
        for(int j = 0; j < t; j += 1){
            swp[i * bsz + j] = (((masks[i] >> j) & 1) ^ ((lst_masks[i] >> j) & 1));
        }
    }
    mans = flip_bits(swp);
    bool bg = true;
    for(int i = max((ll)(0), bsz * tl - bgans); ; i += 1){
        swp.assign(n, false);
        if(!bg){
            swp[i - 1] = true;
        }
        swp[i] = true;
        bg = false;
        ll ans = flip_bits(swp);
        if(ans < mans){
            swp.assign(n, false);
            swp[i] = true;
            flip_bits(swp);
            return make_pair(i, i + mans - 1);
        }
    }
}

pair<int, int> find_longest_subarray_of_ones(int n){
    return solve(n);
}
/*
1
10
1 1 0 0 1 0 0 0 1 1
*/