#include "ones.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;

int gtemp(int n)
{
	vector <bool> zer(n);
	return flip_bits(zer);
}

int gtinv(int n, int i)
{
	vector <bool> zer(n);
	zer[i] = true;
	return flip_bits(zer);
}

pair<int, int> find_longest_subarray_of_ones(int n)
{
	int was = gtemp(n);

	for (int i = 0; i < n; ++i)
	{
		int nw = gtinv(n, i);
		if (nw <= was)
		{
			was = nw;
			continue;
		}

		int l = i;
		while (l > 0)
		{
			int gt = gtinv(n, l - 1);
			gtinv(n, l - 1);
			if (gt < nw)
			{
				--l;
				continue;
			}
			break;
		}
		int r = i; 
		while (r + 1 < n)
		{
			int gt = gtinv(n, r + 1);
			gtinv(n, r + 1);
			if (gt < nw)
			{
				++r;
				continue;
			}
			break;
		}
		return { l, r };
	}
	return { 0, -1 };
}