#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <iomanip>

using namespace std;
typedef long long ll;
#define int long long

int gcd(int a, int b)
{
	while (a)
	{
		b %= a;
		swap(a, b);
	}
	return b;
}

int p, q, n;
ll ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> p >> q >> n;

	ans += min({ p / 2, q / 2, n });

	for (int i = 1; i <= p; ++i)
	{
		for (int j = i + 1; j <= q; ++j)
		{
			if ((i + j) * i > p || (i + j) * j > q || i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ p / ((i + j) * i), q / ((i + j) * j), n / (i, j) });
		}
	}

	for (int i = 1; i <= q; ++i)
	{
		for (int j = i + 1; j <= p; ++j)
		{
			if ((i + j) * i > q || (i + j) * j > p || i * j > n) break;
			if (gcd(i, j) > 1) continue;
			ans += min({ q / ((i + j) * i), p / ((i + j) * j), n / (i, j) });
		}
	}

	cout << ans;

	return 0;
}
