#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<long long> facts(300001);
const long long mod = 1e9 + 7;
int n, k;
vector<int> a;
long long ans = 0;

long long binpow(long long a, long long d) {
	if (d == 0) {
		return 1;
	}
	if (d == 1) {
		return a;
	}
	if (d % 2 == 1) {
		return (a * binpow(a, d - 1)) % mod;
	}
	long long v = binpow(a, d / 2);
	return (v * v) % mod;
}
long long rev(long long a) {
	return binpow(a, mod - 2);
}


void rec(int l, int r) {
	if (l >= r) {
		return;
	}
	int mxm = 0;
	for (int i = l; i <= r; i++) {
		mxm = max(mxm, a[i]);
	}
	if (2 * mxm <= k) {
		return;
	}
	int globalsz = 0;

	long long multiply = 1;

	int cursz = 0;
	for (int i = l; i <=r; i++) {
		if (a[i] == mxm) {
			multiply *= facts[cursz];
			multiply %= mod;
			globalsz++;
			cursz = 0;
		}
		else if (a[i] + mxm > k) {
			cursz++;
			globalsz++;
		}
	}
	multiply *= facts[cursz];
	multiply %= mod;
	ans *= rev(facts[globalsz]);
	ans %= mod;
	ans *= multiply;
	ans %= mod;
	int prev = l;
	for (int i = l; i <= r; i++) {
		if (a[i] == mxm) {
			rec(prev, i - 1);
			prev = i + 1;
		}
	}
	rec(prev, r);
}

int main() {
	facts[0] = 1;
	for (int i = 1; i <= 300000; i++) {
		facts[i] = facts[i - 1] * i;
		facts[i] %= mod;
	}
	cin >> n >> k;
	ans = facts[n];
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	rec(0, n - 1);
	cout << ans;
}