#include "ones.h"
#include <time.h>
#include <stdlib.h>
#include <algorithm>
using namespace std;

int flip(int pos, int n) {
	vector<bool> req(n);
	req[pos] = 1;
	return flip_bits(req);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
	srand(827131);
	int cur = 0;
	
	while (true) {
		vector<bool> rq(n);
		for (int i = 0; i < n; i++) {
			rq[i] = rand() % 2;
		}
		cur = flip_bits(rq);
		if (cur < 10) {
			break;
		}
	}
	vector<int> rn(n);
	for (int i = 0; i < n; i++) {
		rn[i] = i;
	}
	random_shuffle(rn.begin(), rn.end());
	int i = 0;
	while (true) {
		


		int pos =rn[i++];
		int nw = flip(pos, n);
		
		if (nw>cur) {
			if (nw == 1) {
				return { pos,pos };
			}
			else if (pos == 0) {
				return { 0,nw - 1 };
			}
			else if (pos == n-1) {
				return { n - nw,n - 1 };
			}

			else {
				int L = pos;
				int R = n;
				while (R - L > 1) {
					int med = (L + R) / 2;
					int tt = flip(med,n);
					flip(med, n);
					if (tt < nw) {
						L = med;
					}
					else {
						R = med;
					}
				}
				int rpos = L;

				L = -1;
				R = pos;
				while (R - L > 1) {
					int med = (L + R) / 2;
					int tt = flip(med, n);
					flip(med, n);
					if (tt < nw) {
						R = med;
					}
					else {
						L = med;
					}
				}
				int lpos = R;
				return { lpos,rpos };
			}
		}
	}

	
}