#include "ones.h"
#include <time.h>
#include <stdlib.h>
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;


int flip(int pos, int n) {
	vector<bool> req(n);
	req[pos] = 1;
	return flip_bits(req);
}

int flipsub(int l,int r, int n) {
	vector<bool> req(n);
	for (int i = l; i<=r; i++) {
		req[i] = 1;
	}
	return flip_bits(req);
}



pair<int, int> find_longest_subarray_of_ones(int n) {
	srand(time(NULL));
	int cur = 0;
	vector<bool> rq(n);
	cur = flip_bits(rq);

	for (int i = 0; i < n; i++) {
		rq[i] = (rand()) % 2;
	}
	cur = flip_bits(rq);

	
	
	int l = 0;
	int r = n - 1;
	int ctr = 0;
	while (r - l > 100||ctr>200) {
		int sz = r - l + 1;
		int ll = l + (rand() % sz);
		int rr = l + (rand() % sz);
		if (ll > rr) {
			swap(ll, rr);
		}
		if (flipsub(ll, rr, n) != cur) {
			l = ll;
			r = rr;
			ctr = 0;
		}
		flipsub(ll, rr, n);
	}
	vector<int> rn;
	for (int i = l; i <= r; i++) {
		rn.push_back(i);
	}
	random_shuffle(rn.begin(), rn.end());
	int i = 0;
	while (true) {

		if (i >= rn.size()) {
			i = 0;
			cur = flipsub(l, r, n);
		}

		int pos = rn[i++];
		int nw = flip(pos, n);

		if (nw > cur) {
			if (nw == 1) {
				return { pos,pos };
			}
			else if (pos == 0) {
				return { 0,nw - 1 };
			}
			else if (pos == n - 1) {
				return { n - nw,n - 1 };
			}

			else {
				int L = pos;
				int R = n;
				while (R - L > 1) {
					int med = (L + R) / 2;
					int tt = flip(med, n);
					flip(med, n);
					if (tt < nw) {
						L = med;
					}
					else {
						R = med;
					}
				}
				int rpos = L;

				L = -1;
				R = pos;
				while (R - L > 1) {
					int med = (L + R) / 2;
					int tt = flip(med, n);
					flip(med, n);
					if (tt < nw) {
						R = med;
					}
					else {
						L = med;
					}
				}
				int lpos = R;
				return { lpos,rpos };
			}
		}
		else if (nw < cur) {
			flip(pos, n);
			swap(nw, cur);
			int L = pos;
			int R = n;
			while (R - L > 1) {
				int med = (L + R) / 2;
				int tt = flip(med, n);
				flip(med, n);
				if (tt < nw) {
					L = med;
				}
				else {
					R = med;
				}
			}
			int rpos = L;

			L = -1;
			R = pos;
			while (R - L > 1) {
				int med = (L + R) / 2;
				int tt = flip(med, n);
				flip(med, n);
				if (tt < nw) {
					R = med;
				}
				else {
					L = med;
				}
			}
			int lpos = R;
			return { lpos,rpos };


		}

		flip(pos, n);
		//cur=flip(pos, n);
	}


}