#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define int long long

mt19937 rnd(51);

bool good(ll a, ll b) {
    return (a * b) % (a + b) == 0;
}

int gcd(int a, int b) {
    while (b != 0) {
        int a1 = a;
        a = b, b = a1 % b;
    }
    return a;
}

int solve(int p, int q, int n) {
    int kol = 0;
    for (int a = 1; a <= p; a++) {
        for (int b = 1; b <= q; b++) {
            if (good(a, b) && a * b / (a + b) <= n) {
                kol++;
            }
        }
    }
    return kol;
}

int solve2(int p, int q, int n) {
    int ans = 0;
    for (int a = 1; a <= p; ++a) {
        for (int b = 1; b <= q; ++b) {
            if (gcd(a, b) == 1) {
                ans += min({p / a, q / b, n * (a + b) / (a * b)}) / (a + b);
            }
        }
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#endif // LOCAL
    ll p, q, n;
    cin >> p >> q >> n;
    cout << solve2(p, q, n) << endl;
    return 0;
}
