#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;

//#define int long long

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int p = 10000, q = 1000000, n = 10000;
    cin >> p >> q >> n;
    long long cnt = 0;
    vector<bool> good(sqrt(q) + 10, 1);
    for (int i = 1; i * i <= p; ++i) {
        vector<int> help;
        int x = i;
        for (int y = 2; y * y <= x; y++) {
            if (x % y == 0)
                help.push_back(y);
            while (x % y == 0)
                x /= y;
        }
        if (x > 1)
            help.push_back(x);
        for (auto u: help) {
            for (int j = u; j * j <= q; j += u)
                good[j] = 0;
        }
        for (int j = 1; j * j <= q; ++j) {
            if (!good[j])
                continue;
            int mnn = min(min(p / i, q / j) / (i + j),  n / (i * j));
            cnt += mnn;
        }

        for (auto u: help) {
            for (int j = u; j * j <= q; j += u)
                good[j] = 1;
        }
    }
    cout << cnt << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--)
        solve();
}