#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>

using namespace std;

//#define int long long

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

const int lenn = 100000;

void solve() {
    int p = 10000, q = 1000000, n = 10000;
    cin >> p >> q >> n;
    long long cnt = 0;
    bitset<lenn> bt;
    for (int i = 0; i < lenn; ++i)
        bt[i] = 1;
    auto fff = bt;
    vector<int> mndel(sqrt(p) + 2, -1);
    vector<int> chng(sqrt(p) + 2);
    vector<bitset<lenn>> syka;
    int now = 0;
    for (int i = 2; i * i <= p; ++i) {
        if (mndel[i] != -1)
            continue;
        for (int j = i * i; j * j <= p; j += i)
            mndel[j] = i;
        chng[i] = now++;
        syka.push_back(bt);
        for (int j = i; j * j <= q; j += i) {
            if(j >= lenn)
                exit(0);
            syka.back()[j] = 0;
        }
    }
    int lst = 1;
    for (; lst * lst <= q; ++lst){}

    for (int i = 1; i * i <= p; ++i) {
        vector<int> help;
        int x = i;
        for (int y = 2; y * y <= x; y++) {
            if (x % y == 0)
                help.push_back(y);
            while (x % y == 0)
                x /= y;
        }
        if (x > 1)
            help.push_back(x);
        for (auto u: help) {
            bt &= syka[chng[u]];
        }
        for (int j = 1; j < lst; ++j) {
            if(j >= lenn)
                exit(0);
            if (bt[j] == 0)
                continue;
            int mnn = min(min(p / i, q / j) / (i + j), n / (i * j));
            cnt += mnn;
        }
        bt = fff;
    }
    cout << cnt << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--)
        solve();
}