#include <iostream>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 3e5 + 123;
set<vector<int>> st;

void dfs(vector<int> a, int k) {
    if (st.find(a) != st.end())
        return;
    st.insert(a);
    int n = a.size();
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i] + a[i + 1] <= k) {
            swap(a[i], a[i + 1]);
            dfs(a, k);
            swap(a[i], a[i + 1]);
        }
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    dfs(a, k);
    cout << st.size() << '\n';
}
