#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

const ll MOD = 1000000007;

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second - a.first < b.second - b.first;
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> is;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k)
            is.push_back(i);
    }
    vector<pair<int, int>> a0;
    int j = -1;
    for (int i = 0; i < n; ++i) {
        if (a[i] * 2 > k) {
            ++j;
            continue;
        }
        int l = j;
        while (l >= 0 && a[i] + a[is[l]] <= k)
            --l;
        int r = j;
        while (r + 1 < n && a[i] + a[is[r + 1]] <= k)
            ++r;
        a0.push_back({l + 1, r + 1});
    }
    vector<int> cnt(is.size() + 1);
    sort(a0.begin(), a0.end(), cmp);
    ll ans = 1;
    for (auto [l, r] : a0) {
        ll vars = r - l + 1;
        for (int i = l; i <= r; ++i)
            vars += cnt[i];
        ans *= vars;
        ans %= MOD;
        ++cnt[l];
    }
    cout << ans << '\n';

}
