#include "ones.h"
#include <iostream>
using namespace std;
pair<int, int> ans_frombest(int n, int i, int ln) {
    vector<bool> flip(n);
    int t = 1;
    while (true) {
        if (i + t >= n)
            break;
        flip[i + 1] = 1;
        int ln0 = flip_bits(flip);
        flip_bits(flip);
        flip[i + 1] = 0;

        if (ln0 >= ln) {
            break;
        }
        i += t;
    }
    return {i - ln + 1, i};
}
pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flip(n);
    int ln = flip_bits(flip);
    if (ln < 7) {
        ++ln;
        int mln = ln;
        int mxm = 0;
        for (int m = 1; m < (1 << ln); ++m) {
            for (int i = 0; i < ln; ++i) {
                flip[i] = ((1 << i) & (m ^ (m - 1)));
            }
            int nln = flip_bits(flip);
            if (nln > mln) {
                mln = nln;
                mxm = m;
            }
        }
        for (int i = 0; i < ln; ++i) {
            flip[i] = ((1 << i) & ((1 << ln) - 1 - mxm));
        }
        ln = flip_bits(flip);
    }
    if (ln == 0) {
        flip[0] = 1;
        flip_bits(flip);
        return {0, 0};
    }
    for (int j = 0; j < ln; ++j) {
        for (int i = j; i < n; i += ln) {
            flip[i] = 1;
            int ln0 = flip_bits(flip);
            if (ln0 != ln) {
                if (ln0 < ln) {
                    flip_bits(flip);
                } else {
                    ln = ln0;
                }
                return ans_frombest(n, i, ln);
            }
            flip[i] = 0;
        }
    }
    return {1, 0};
}

