#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        for (int j = i - 1; j >= 0; --j) {
            if (a[j] + a[i] > k) {
                g[j].push_back(i);
            }
        }
    }

    vector<int> ord(n), inv(n);
    iota(ord.begin(), ord.end(), 0);

    int ans = 0;
    do {
        for (int i = 0; i < n; ++i) {
            inv[ord[i]] = i;
        }
        bool yay = true;
        for (int i = 0; i < n && yay; ++i) {
            for (int to : g[i]) {
                if (inv[i] > inv[to]) {
                    yay = false;
                    break;
                }
            }
        }
        ans += yay;
    } while (next_permutation(ord.begin(), ord.end()));

    cout << ans;


    return 0;
}
