#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int _ = 0; _ < n; ++_) {
        for (int i = 0; i < n - 1; ++i) {
            if (a[i + 1] + a[i] <= k && a[i] > a[i + 1]) {
                swap(a[i], a[i + 1]);
            }
        }
    }

    vector<vector<int>> g(n);
    vector<int> L(n, -1), R(n, n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] + a[j] > k) {
                g[i].push_back(j);
                break;
            }
        }
        for (int j = i - 1; j >= 0; --j) {
            if (a[j] + a[i] > k) {
                g[j].push_back(i);
                L[i] = j;
                break;
            }
        }
    }
    for (int i = 0, j; i < n; i = j) {
        j = i;
        assert(L[i] == i - 1);
        while (j < n && L[j] == L[i]) {
            ++j;
        }
    }

    vector<int> ord(n), inv(n);
    iota(ord.begin(), ord.end(), 0);

    int ans = 0;
    do {
        for (int i = 0; i < n; ++i) {
            inv[ord[i]] = i;
        }
        bool yay = true;
        for (int i = 0; i < n && yay; ++i) {
            for (int to : g[i]) {
                if (inv[i] > inv[to]) {
                    yay = false;
                    break;
                }
            }
        }
        ans += yay;
    } while (next_permutation(ord.begin(), ord.end()));

    cout << ans;


    return 0;
}
