#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int _ = 0; _ < n; ++_) {
        for (int i = 0; i < n - 1; ++i) {
            if (a[i + 1] + a[i] <= k && a[i] > a[i + 1]) {
                swap(a[i], a[i + 1]);
            }
        }
    }

    vector<vector<int>> g(n);
    vector<int> L(n, -1), R(n, n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] + a[j] > k) {
                R[i] = j;
                g[i].push_back(j);
                break;
            }
        }
        for (int j = i - 1; j >= 0; --j) {
            if (a[j] + a[i] > k) {
                g[j].push_back(i);
                L[i] = j;
                break;
            }
        }
    }
    int ans = 1;
    for (int i = 0, j; i < n; i = j) {
        j = i;
        assert(L[i] == i - 1);
        while (j < n && L[j] == L[i]) {
            ++j;
        }
        assert(is_sorted(a.begin() + i, a.begin() + j));
        for (int x = j - 1; x >= i; --x) {
            ans = 1LL * ans * (R[x] - L[x] - 1 - (j - x - 1)) % MOD;
        }
    }

    cout << ans << '\n';

    return 0;
}
