#include "ones.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;


pair<int, int> find_longest_subarray_of_ones(int n) {
    auto flip = [&](int i) -> int {
        vector<bool> a(n);
        a[i] = true;
        return flip_bits(a);
    };

    int init = flip_bits(vector<bool>(n));
    
    if (init == 0) {
        return {0, -1};
    }
    
    for (int i = 0; i < n; ++i) {
        int now = flip(i);
        if (now < init) {
            flip(i);
            return {i, i + init - 1};
        } else if (now > init) {
            int L = 0, R = n - 1;

            {
                int lo = -1, hi = i;
                while (lo + 1 < hi) {
                    int mid = (lo + hi) / 2;
                    int nw = flip(mid);
                    flip(mid);
                    if (nw < now) {
                        hi = mid;
                    } else {
                        lo = mid;
                    }
                }
                L = hi;
            }
            {
                int lo = i, hi = n;
                while (lo + 1 < hi) {
                    int mid = (lo + hi) / 2;
                    int nw = flip(mid);
                    flip(mid);
                    if (nw < now) {
                        lo = mid;
                    } else {
                        hi = mid;
                    }
                }
                R = lo;
            }
            return {L, R};
        }
    }
    return {0, -1};
}
