#include "ones.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;


pair<int, int> find_longest_subarray_of_ones(int n) {
    auto flip_single = [&](int i) -> int {
        vector<bool> a(n);
        a[i] = true;
        return flip_bits(a);
    };

    int init = flip_bits(vector<bool>(n));

    if (init == 0) {
        return {0, -1};
    }
    mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

    auto sure = [&](int i, int now = -1) {
        if (now == -1) {
            now = flip_bits(vector<bool>(n));
        }
        int L = 0, R = n - 1;

        {
            int lo = -1, hi = i;
            while (lo + 1 < hi) {
                int mid = (lo + hi) / 2;
                int nw = flip_single(mid);
                flip_single(mid);
                if (nw < now) {
                    hi = mid;
                } else {
                    lo = mid;
                }
            }
            L = hi;
        }
        return pair{L, L + init - 1};
    };


    auto flip = [&](vector<int> a) {
        if (a.empty()) {
            return init;
        }
        vector<bool> res(n);
        for (int x : a) {
            res[x] = true;
        }
        return flip_bits(res);
    };

    vector<int> a(n);
    iota(a.begin(), a.end(), 0);
    while (a.size() > 1) {
        vector<int> L, R;
//        shuffle(a.begin(), a.end(), rnd);
//        L = vector(a.begin(), a.begin() + a.size() / 2);
//        R = vector(a.begin() + a.size() / 2, a.end());
        for (int i = 0; i < a.size(); ++i) {
            if (rnd() & 1) {
                L.push_back(a[i]);
            } else {
                R.push_back(a[i]);
            }
        }
        if (L.empty() || R.empty()) {
            continue;
        }
        if (rnd() & 1) {
            swap(L, R);
        }
        int get = flip(L);
        if (get > init) {
            init = get;
            a = L;
        } else if (get < init) {
            flip(L);
            a = L;
        } else {
            get = flip(R);
            if (get > init) {
                init = get;
                a = R;
            } else if (get < init) {
                flip(R);
                a = R;
            }
        }
    }
    return sure(a[0], init);
}
