#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 20000;

bitset<N> B[N];

int mind[N];

vector<int> sieve() {
    vector<int> primes;
    for (int i = 2; i < N; ++i) {
        if (mind[i] == 0) {
            primes.push_back(i);
            mind[i] = i;
        }
        for (int x: primes) {
            if (x > mind[i] || x * i > N) {
                break;
            }
            mind[x * i] = x;
        }
    }
    return primes;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll p, q, n;
    cin >> p >> q >> n;

    ll ans = 0;
    ll lima = sqrt(p);
    ll limb = sqrt(q);

    for (ll a = 1; a <= lima; ++a) {
        ll fi = p / a;
        ll prod = -a, sum = a - 1;
        int g = a % 3;
        if (a % 2 == 0) {
            for (ll b = 1; b <= limb; b += 2) {
                prod += a * 2;
                sum += 2;
                if ((g || b % 3 != 0) && gcd(a, b) == 1) {
                    if (fi * b > q) {
                        fi = q / b;
                    }
                    if (fi * prod > sum * n) {
                        ans += n / prod;
                    } else {
                        ans += fi / sum;
                    }
                }
            }
        } else {
            prod = 0;
            sum = a;
            for (ll b = 1; b <= limb; ++b) {
                prod += a;
                sum += 1;
                if ((g || b % 3 != 0) && gcd(a, b) == 1) {
                    if (fi * b > q) {
                        fi = q / b;
                    }
                    if (fi * prod > sum * n) {
                        ans += n / prod;
                    } else {
                        ans += fi / sum;
                    }
                }
            }
        }
    }
    cout << ans << '\n';


    return 0;
}
