﻿#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 1e9 + 7;

int bin_pow(int x, int s) {
    if (s == 0)
        return 1;
    int y = bin_pow(x, s >> 1);
    y = (ll)y * y % MOD;
    if (s & 1)
        y = (ll)y * x % MOD;
    return y;
}

vi f, bf;

int C(int n, int k) {
    return (ll)f[n] * bf[n - k] % MOD * bf[k] % MOD;
}

int main() {
    fast;
    int n, k;
    cin >> n >> k;
    f.resize(n + 1);
    bf.resize(n + 1);
    f[0] = 1;
    for (int i = 1; i <= n; ++i)
        f[i] = (ll)f[i - 1] * i % MOD;
    bf[n] = bin_pow(f[n], MOD - 2);
    for (int i = n - 1; i >= 0; --i)
        bf[i] = (ll)bf[i + 1] * (i + 1) % MOD;
    vi w(n), a(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        a[i] = w[i];
    }
    sort(all(a));
    int ans = 1, i = 0, l = 0, jj = 0;
    vector<pii> r(n + 1, {-1, -1});
    while (i < n) {
        int j;
        while (l < (int)w.size()) {
            if (w[l] == a[i]) {
                j = l;
                break;
            }
            ++l;
        }
        ++l;
        int ll = -1;
        for (int ii = j - 1; ii >= 0; --ii) {
            if (w[j] + w[ii] > k) {
                ll = ii;
                break;
            }
        }
        if (r[ll + 1].first != -1)
            ++r[ll + 1].second;
        else {
            r[ll + 1] = {(int)w.size(), 1};
            for (int ii = j + 1; ii < (int)w.size(); ++ii) {
                if (w[j] + w[ii] > k) {
                    r[ll + 1].first = ii;
                    break;
                }
            }
        }
        if (i == n - 1 || a[i] != a[i + 1]) {
            for (int ii = -1; ii < (int)w.size(); ++ii) {
                if (r[ii + 1].first != -1)
                    ans = (long long)ans * C(r[ii + 1].first - ii - 1, r[ii + 1].second) % MOD;
            }
            for (int kk = jj; kk <= i; ++kk) {
                for (int u = 0; u < (int)w.size(); ++u) {
                    if (w[u] == a[i]) {
                        w.erase(w.begin() + u);
                        break;
                    }
                }
            }
            jj = i + 1;
            r.assign(w.size() + 1, {-1, -1});
            l = 0;
        }
        ++i;
    }
    cout << ans << '\n';
}
