﻿#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int GCD(int x, int y) {
    while (y > 0) {
        int z = x;
        x = y;
        y = z % y;
    }
    return x;
}

int main() {
    fast;
    ll p, q, n;
    cin >> p >> q >> n;
    ll ans = 0;
    for (ll x = 1; x * x <= p; ++x) {
        ll mx = min(n, p) / x;
        vector<bool> b(mx + 1, true);
        for (ll y = 1; y * (x + y) <= q && y <= mx; ++y) {
            if (!b[y])
                continue;
            if (GCD(x, y) == 1)
                ans += min({n / x / y, p / x / (x + y), q / y / (x + y)});
            else {
                for (ll z = y; z <= mx; z += y)
                    b[z] = false;
            }
        }
    }
    cout << ans << '\n';
}
