#include <iostream>
#include <vector>

#define int long long

using namespace std;

typedef vector<int> vi;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

const int MOD = 1e9 + 7;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, k;
	cin >> n >> k;
	vi a(n + 1);
	input(a, 1);
	int ans = 1;
	for (int i = 1; i <= n; ++i) {
		int l, r;
		for (r = i + 1; r <= n; ++r) {
			if (a[r] <= a[i] || a[r] + a[i] > k)
				break;
		}
		for (l = i - 1; l >= 1; --l) {
			if (a[l] <= a[i] || a[l] + a[i] > k)
				break;
		}
		ans *= (r - l - 1);
		ans %= MOD;
	}
	cout << ans;
	return 0;
}