#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr int MOD = 1000000007;

ll binpow(int n, int k) {
    if (k == 0) return 1;
    if (k % 2 == 0) {
        ll t = binpow(n, k / 2);
        return t * t % MOD;
    }
    return n * binpow(n, k - 1) % MOD;
}

ll invert(int n) {
    return binpow(n, MOD - 2);
}
vector<ll> fact;

ll cnk(int n, int k) {
    return fact[n] * invert(fact[k]) % MOD * invert(fact[n - k]) % MOD;
}

int gcd(int a, int b) {
    if (b % a == 0) return a;
    if (a % 2 == 0 && b % 2 == 0) return 2;
    return __gcd(a, b);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    ll p, q, n;
    cin >> p >> q >> n;
    if (p > q) swap(p, q);
    ll ans = 0;
    for (ll a = 1; a <= p; ++a) {
        if (a * 1ll * a > n) break;
        ll upper_bound = min(q, n / a);
//        ll kek = min({q, (q * a) / p, (p == n ? LLONG_MAX : n * a / (p - n))});
//        ll kek2 = min(kek, p);
//        ans += 2 * kek2 * p / a;
//        for (ll b = a; b <= kek2; ++b) {
//            if (__gcd(a, b) != 1) continue;
//            ans += 2 * ((p / a) / (a + b));
//        }
//        for (ll b = kek2 + 1; b <= kek; ++b) {
//            if (__gcd(a, b) != 1) continue;
//            ans += ((p / a) / (a + b));
//        }
        for (ll b = a; b <= upper_bound; ++b) {
            if (__gcd(a, b) != 1) continue;
            ll max_d = min({p / a, q / b, n * 1ll * (a + b) / (a * 1ll * b)});
            ll buff = max_d / (a + b);
            ans += buff;
            if (b <= p) ans += buff;
        }
    }
    cout << ans;
    return 0;
}