#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

ll k;
vector<ll> a;

int biggest_one(int l, int r) {
    int ans = l;
    for (int i = l; i <= r; ++i) {
        if (a[i] > a[ans]) {
            ans = i;
        }
    }
    return ans;
}

int cnt_sm(int l, int r, ll st) {
    int ans = 0;
    for (int i = l; i <= r; ++i) {
        if (a[i] <= st) {
            ++ans;
        }
    }
    return ans;
}

ll solve(int l, int r, ll st) {
    if (r < l) {
        return 1;
    }
    int bg = biggest_one(l, r);
    if (a[bg] <= st) {
        return 1;
    }
    ll ans = 1;
    if (st > k - a[bg]) {
        while (true) {

        }
    }
    int cnt1 = cnt_sm(l, r, st);
    int cnt2 = cnt_sm(l, r, k - a[bg]) - cnt1;
    int sz = r - l + 1 - cnt_sm(l, r, st);
    for (int i = 0; i < cnt2; ++i) {
        ans = ans * (ll)(sz - i) % MOD;
    }
    return ans * solve(l, bg - 1, k - a[bg]) % MOD * solve(bg + 1, r, k - a[bg]) % MOD;
}

inline void solve(void) {
    int n; cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cout << solve(0, n - 1, -MOD);
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
