#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

inline void solve(void) {
    ll p, q, n;
    cin >> p >> q >> n;
    int ans = 0;
    for (ll ab = 1; ab <= n; ++ab) {
        for (ll a = 1; a * a <= ab; ++a) {
            if (ab % a == 0) {
                ll b = ab / a;
                if (gcd(a, b) == 1) {
                    ans += min(min(p / (a * (a + b)), q / (b * (a + b))), n / ab);
                    if (a != b) {
                        ans += min(min(q / (a * (a + b)), p / (b * (a + b))), n / ab);
                    }
                }
            }
        }
    }
    cout << ans << '\n';
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
