#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()
const int mod = 1e9 + 7;

int binpow(int a, int b) {
    int p = 1;
    while (b)
        if (b & 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b >>= 1;
    return p;
}

int n, k;
vector<int> a;
vector<int> fact(1e5 + 1, 1), inv_fact(1e5 + 1, 1);
int ans = 1;

void rec(int l, int r) {
    if (l + 1 >= r)
        return;
    map<int, vector<int>> mp;
    for (int i = l; i < r; ++i)
        mp[a[i]].push_back(i);
    int cnt = sz(mp.rbegin()->second);
    mp.rbegin()->second.push_back(r);
    int prev = l - 1;
    for (auto x:mp.rbegin()->second) {
        int count = 0;
        for (int i = prev + 1; i < x; ++i)
            if (a[i] + mp.rbegin()->first > k)
                count++, cnt++;
        rec(prev + 1, x);
        prev = x;
        (ans *= fact[count]) %= mod;
    }
    (ans *= inv_fact[cnt]) %= mod;
}

void solve() {
    for (int i = 2; i < 1e5 + 1; ++i) {
        (fact[i] = fact[i - 1] * i) %= mod;
        inv_fact[i] = binpow(fact[i], mod - 2);
    }
    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    ans = fact[n];
//    cout << ans << "\n";
    rec(0, n);
    map<int, int> CNT;
    for (int i = 0; i < n; ++i)
        CNT[a[i]]++;
    for (auto[x, y]:CNT)
        (ans *= inv_fact[y]) %= mod;
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
