#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a)a.begin(),a.end()
#define sz(a)(int)a.size()
const int mod = 1e9 + 7;
const int R = 1 << 17;

int binpow(int a, int b) {
    int p = 1;
    while (b)
        if (b & 1)
            (p *= a) %= mod, b--;
        else
            (a *= a) %= mod, b >>= 1;
    return p;
}

int n, k;
vector<int> a;
vector<int> fact(2e5 + 1, 1), inv_fact(2e5 + 1, 1);
int ans = 1;
vector<pair<int, int>> sg(2 * R);
vector<vector<int>> mx(2 * R);

void rec(int l, int r) {
    if (l + 1 >= r)
        return;
    map<int, vector<int>> mp;
    for (int i = l; i < r; ++i)
        if (sz(mp[a[i]]) == 0)
            mp[a[i]].push_back(i);
    int cnt = sz(mp.rbegin()->second);
    mp.rbegin()->second.push_back(r);
    int prev = l - 1;
    map<int, int> cur;
    cur[mp.rbegin()->first] = 1;
    for (auto x:mp.rbegin()->second) {
        int count = 0;
        map<int, int> ee;
        for (int i = prev + 1; i < x; ++i)
            if (a[i] + mp.rbegin()->first > k) {
                count++, cnt++;
                ee[a[i]]++;
                cur[a[i]]++;
            }
        rec(prev + 1, x);
        prev = x;
        (ans *= fact[count]) %= mod;
        for (auto[x, y]:ee)
            (ans *= inv_fact[y]) %= mod;
    }
    (ans *= inv_fact[cnt]) %= mod;
    for (auto[x, y]:cur)
        (ans *= fact[y]) %= mod;
}


pair<int, int> get(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return {-1e18, -1};
    if (ql <= xl && xr <= qr)
        return sg[x];
    int mid = (xl + xr) >> 1;
    return max(get(x * 2, xl, mid, ql, qr), get(x * 2 + 1, mid, xr, ql, qr));
}

int getc(int x, int xl, int xr, int ql, int qr, int d) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return sz(mx[x]) - (upper_bound(all(mx[x]), d) - mx[x].begin());
    int mid = (xl + xr) >> 1;
    return getc(x * 2, xl, mid, ql, qr, d) + getc(x * 2 + 1, mid, xr, ql, qr, d);
}

void rec2(int l, int r) {
    if (l + 1 >= r)
        return;
    int ind = get(1, 0, R, l, r).second;
    int tl = getc(1, 0, R, l, ind, k - a[ind]);
    int tr = getc(1, 0, R, ind + 1, r, k - a[ind]);
    (ans *= fact[tl]) %= mod;
    (ans *= fact[tr]) %= mod;
    (ans *= inv_fact[tl + tr + 1]) %= mod;
    rec2(l, ind);
    rec2(ind + 1, r);
}

void solve() {
    for (int i = 2; i < 2e5 + 1; ++i) {
        (fact[i] = fact[i - 1] * i) %= mod;
        inv_fact[i] = binpow(fact[i], mod - 2);
    }
    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sg[i + R] = {a[i], i};
        mx[i + R].push_back(a[i]);
    }
    for (int i = R - 1; i > 0; --i) {
        sg[i] = max(sg[i * 2], sg[i * 2 + 1]);
        mx[i].resize(sz(mx[i * 2]) + sz(mx[i * 2 + 1]));
        merge(mx[i * 2].begin(), mx[i * 2].end(), mx[i * 2 + 1].begin(), mx[i * 2 + 1].end(), mx[i].begin());
//        for (auto x:mx[i])
//            cout << x << " ";
//        cout << endl;
//        merge(mx[i*2],mx[i*2+1],mx[i]);
    }
    ans = fact[n];
    unordered_map<int, int> cnt, sizes;
    for (int i = 0; i < n; ++i)
        cnt[a[i]]++;
    for (auto[x, y]:cnt)
        (ans *= inv_fact[y]) %= mod;
    if (sz(cnt) != n) {
        rec(0, n);
    } else {
        rec2(0, n);
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
