/**
⣿⡟⠙⠛⠋⠩⠭⣉⡛⢛⠫⠭⠄⠒⠄⠄⠄⠈⠉⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⡇⠄⠄⠄⠄⣠⠖⠋⣀⡤⠄⠒⠄⠄⠄⠄⠄⠄⠄⠄⠄⣈⡭⠭⠄⠄⠄⠉⠙
⣿⡇⠄⠄⢀⣞⣡⠴⠚⠁⠄⠄⢀⠠⠄⠄⠄⠄⠄⠄⠄⠉⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⠄⡴⠁⡜⣵⢗⢀⠄⢠⡔⠁⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⡜⠄⡜⠄⠄⠄⠉⣠⠋⠠⠄⢀⡄⠄⠄⣠⣆⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⢸
⣿⠸⠄⡼⠄⠄⠄⠄⢰⠁⠄⠄⠄⠈⣀⣠⣬⣭⣛⠄⠁⠄⡄⠄⠄⠄⠄⠄⢀⣿
⣏⠄⢀⠁⠄⠄⠄⠄⠇⢀⣠⣴⣶⣿⣿⣿⣿⣿⣿⡇⠄⠄⡇⠄⠄⠄⠄⢀⣾⣿
⣿⣸⠈⠄⠄⠰⠾⠴⢾⣻⣿⣿⣿⣿⣿⣿⣿⣿⣿⢁⣾⢀⠁⠄⠄⠄⢠⢸⣿⣿
⣿⣿⣆⠄⠆⠄⣦⣶⣦⣌⣿⣿⣿⣿⣷⣋⣀⣈⠙⠛⡛⠌⠄⠄⠄⠄⢸⢸⣿⣿
⣿⣿⣿⠄⠄⠄⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠇⠈⠄⠄⠄⠄⠄⠈⢸⣿⣿
⣿⣿⣿⠄⠄⠄⠘⣿⣿⣿⡆⢀⣈⣉⢉⣿⣿⣯⣄⡄⠄⠄⠄⠄⠄⠄⠄⠈⣿⣿
⣿⣿⡟⡜⠄⠄⠄⠄⠙⠿⣿⣧⣽⣍⣾⣿⠿⠛⠁⠄⠄⠄⠄⠄⠄⠄⠄⠃⢿⣿
⣿⡿⠰⠄⠄⠄⠄⠄⠄⠄⠄⠈⠉⠩⠔⠒⠉⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠐⠘⣿
⣿⠃⠃⠄⠄⠄⠄⠄⠄⣀⢀⠄⠄⡀⡀⢀⣤⣴⣤⣤⣀⣀⠄⠄⠄⠄⠄⠄⠁⢹
*/
#ifdef LOCAL
    //#define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
//#include "ones.h"
using namespace std;
mt19937 rnd(101);

#define int long long
#define f first
#define s second
//#define endl '\n'
//#define double long double

const int mod=1000000007;

vector <int> fac,fac_inv;

int step(int a, int n)
{
    if (n==0)return 1;
    if (n==1)return a;
    int b=step(a,n/2);
    return b*b%mod*step(a,n%2)%mod;
}

int c(int n, int k)
{
    if (k<0)return 0;
    if (k>n)return 0;
    return fac[n]*fac_inv[k]%mod*fac_inv[n-k]%mod;
}


vector <int> t;
vector <int> add;

void push(int v, int l, int r)
{
    if (add[v]==0)return;
    t[v]+=add[v];
    if (l!=r){
        add[v*2]+=add[v];
        add[v*2+1]+=add[v];
    }
    add[v]=0;
}
vector <int> a;
void build(int v, int l, int r)
{
    if (l==r){
        t[v]=a[l];
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v]=max(t[v*2],t[v*2+1]);
}
void update(int v, int l, int r, int A, int B, int x)
{
    push(v,l,r);
    if (B<l || r<A)return;
    if (A<=l && r<=B){
        add[v]+=x;
        push(v,l,r);
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,A,B,x);
    update(v*2+1,m+1,r,A,B,x);
    t[v]=max(t[v*2],t[v*2+1]);
}
int get(int v, int l, int r, int x, bool R, int pos)
{
    //push(v,l,r);
    if (R==0 && pos<=l)return -1;
    if (R==1 && pos>=r)return -1;
    if (t[v]<x)return -1;
    //cout << "v: " << v << " " << " " << l << " " << r << " " << t[v] << "  ; " << x << " " << R << " " << pos << endl;
    if (l==r){
        return l;
    }

    int m=(l+r)>>1;
    //push(v*2,l,m);
    //push(v*2+1,m+1,r);
    if (R){
        int y=get(v*2,l,m,x,R,pos);
        if (y==-1)return get(v*2+1,m+1,r,x,R,pos);
        else return y;

        //if (t[v*2]>=x)return get(v*2,l,m,x,R,pos);
        //else return get(v*2+1,m+1,r,x,R);
    }
    else {
        int y=get(v*2+1,m+1,r,x,R,pos);
        if (y==-1)return get(v*2,l,m,x,R,pos);
        else return y;

        //if (t[v*2+1]>=x)return get(v*2+1,m+1,r,x,R);
        //else return get(v*2,l,m,x,R);
    }
}

int n;
int get_r(int i, int x)
{
    //cout << "? r " << i << endl;
    //update(1,0,n-1,0,i,-1000000000);
    return get(1,0,n-1,x,1,i);
    //update(1,0,n-1,0,i,1000000000);
}
int get_l(int i, int x)
{
    //cout << "? l " << i << endl;
    //update(1,0,n-1,i,n-1,-1000000000);
    return get(1,0,n-1,x,0,i);
    //update(1,0,n-1,i,n-1,1000000000);
}

vector <int> now;
vector <int> w;
void upd(int v, int l, int r, int pos, int x)
{
    if (r<pos || pos<l)return;
    if (l==r){
        w[v]=x;
        now[l]=x;
        return;
    }
    int m=(l+r)>>1;
    upd(v*2,l,m,pos,x);
    upd(v*2+1,m+1,r,pos,x);
    w[v]=w[v*2]+w[v*2+1];
}
int sum(int v, int l, int r, int A, int B)
{
    if (B<l || r<A)return 0;
    if (A<=l && r<=B)return w[v];
    int m=(l+r)>>1;
    return sum(v*2,l,m,A,B)+sum(v*2+1,m+1,r,A,B);
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL
    fac.resize(300001,1);
    fac_inv.resize(300001,1);
    for (int i=1; i<=300000; i++){
        fac[i]=fac[i-1]*i%mod;
        fac_inv[i]=step(fac[i],mod-2);
    }

    int k;
    cin >> n >> k;
    int ans=1;
    a.resize(n);
    for (int i=0; i<n; i++){
        cin >> a[i];
    }
    int noww=1;
    map <int,int> z,re_z;
    for (int i=0; i<n; i++){
        if (z[a[i]]==0){
            z[a[i]]=noww;
            re_z[noww++]=a[i];
        }
    }
    vector <vector <int> > pos(noww);
    for (int i=0; i<n; i++){
        pos[z[a[i]]].push_back(i);
    }

    vector <pair <int,int> > b(n);
    for (int i=0; i<n; i++){
        b[i]={a[i],i};
    }
    sort(b.begin(),b.end());
    now.resize(n,0);
    w.resize(4*n+5,0);
    for (int i=0; i<n; i++){
        upd(1,0,n-1,i,1);
    }

    t.resize(4*n+5,0);
    add.resize(4*n+5,0);
    build(1,0,n-1);

    for (int tt=0; tt<n; tt++){
        int i=b[tt].s;
        if (now[i]==0)continue;

        int q=1;
        int l=i,r=i;
        int cnt=1;
        /*now[i]=0;
        while (l-1>=0 && k>=a[i]+a[l-1]){
            l--;
            if (a[l]==a[i]){
                q++;
                now[l]=0;
            }
            cnt+=now[l];
        }
        while (r+1<n && k>=a[i]+a[r+1]){
            r++;
            if (a[r]==a[i]){
                q++;
                now[r]=0;
            }
            cnt+=now[r];
        }*/
        upd(1,0,n-1,i,0);
        int need_more=k+1-a[i];
        //cout << "? " << i << " " << a[i] << " " << need_more << endl;
        if (need_more<=a[i]){
            break;
        }
        l=get_l(i,need_more)+1;
        r=get_r(i,need_more);
        if (r==-1){
            r=n-1;
        }
        else {
            r--;
        }
        vector <int> p;
        int ai=z[a[i]];
        {
            int l1=-1;
            int r1=(int)pos[ai].size()-1;
            while (l1+1<r1){
                int m=(l1+r1)>>1;
                if (pos[ai][m]<l)l1=m;
                else r1=m;
            }
            int l2=-1;
            int r2=(int)pos[ai].size()-1;
            while (l2+1<r2){
                int m=(l2+r2)>>1;
                if (pos[ai][m]<r)l2=m;
                else r2=m;
            }

            for (int i=r1; i<=r2; i++){
                p.push_back(pos[ai][i]);
            }
        }
        for (int i:p){
            upd(1,0,n-1,i,0);
        }
        q=p.size();
        cnt=sum(1,0,n-1,l,r)+1;
        /*cout << "! " << endl;
        cout << l << " " << r << endl;
        cout << "p: ";
        for (int i:p)cout << i << " ";
        cout << endl;*/
        //cout << q << " " << cnt << endl;
        //cout << "? " << q << " " << cnt << " " << c(q+cnt-1,cnt-1) << endl;
        ans*=c(q+cnt-1,cnt-1);
        ans%=mod;
    }
    cout << ans << endl;
}
