/**
⣿⡟⠙⠛⠋⠩⠭⣉⡛⢛⠫⠭⠄⠒⠄⠄⠄⠈⠉⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⡇⠄⠄⠄⠄⣠⠖⠋⣀⡤⠄⠒⠄⠄⠄⠄⠄⠄⠄⠄⠄⣈⡭⠭⠄⠄⠄⠉⠙
⣿⡇⠄⠄⢀⣞⣡⠴⠚⠁⠄⠄⢀⠠⠄⠄⠄⠄⠄⠄⠄⠉⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⠄⡴⠁⡜⣵⢗⢀⠄⢠⡔⠁⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄
⣿⡇⡜⠄⡜⠄⠄⠄⠉⣠⠋⠠⠄⢀⡄⠄⠄⣠⣆⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⢸
⣿⠸⠄⡼⠄⠄⠄⠄⢰⠁⠄⠄⠄⠈⣀⣠⣬⣭⣛⠄⠁⠄⡄⠄⠄⠄⠄⠄⢀⣿
⣏⠄⢀⠁⠄⠄⠄⠄⠇⢀⣠⣴⣶⣿⣿⣿⣿⣿⣿⡇⠄⠄⡇⠄⠄⠄⠄⢀⣾⣿
⣿⣸⠈⠄⠄⠰⠾⠴⢾⣻⣿⣿⣿⣿⣿⣿⣿⣿⣿⢁⣾⢀⠁⠄⠄⠄⢠⢸⣿⣿
⣿⣿⣆⠄⠆⠄⣦⣶⣦⣌⣿⣿⣿⣿⣷⣋⣀⣈⠙⠛⡛⠌⠄⠄⠄⠄⢸⢸⣿⣿
⣿⣿⣿⠄⠄⠄⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠇⠈⠄⠄⠄⠄⠄⠈⢸⣿⣿
⣿⣿⣿⠄⠄⠄⠘⣿⣿⣿⡆⢀⣈⣉⢉⣿⣿⣯⣄⡄⠄⠄⠄⠄⠄⠄⠄⠈⣿⣿
⣿⣿⡟⡜⠄⠄⠄⠄⠙⠿⣿⣧⣽⣍⣾⣿⠿⠛⠁⠄⠄⠄⠄⠄⠄⠄⠄⠃⢿⣿
⣿⡿⠰⠄⠄⠄⠄⠄⠄⠄⠄⠈⠉⠩⠔⠒⠉⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠐⠘⣿
⣿⠃⠃⠄⠄⠄⠄⠄⠄⣀⢀⠄⠄⡀⡀⢀⣤⣴⣤⣤⣀⣀⠄⠄⠄⠄⠄⠄⠁⢹
*/
#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL
#include "ones.h"
#include <bits/stdc++.h>
mt19937 rnd(101);

using namespace std;

//#define int long long
#define f first
#define s second
//#define endl '\n'
//#define double long double

pair <int,int> find_longest_subarray_of_ones(int n)
{
    vector <bool> c(n,0);

    int k=flip_bits(c);
    vector <bool> maxi=c;
    for (int i=0; i<10; i++){
        vector <bool> d(n,0);
        for (int i=0; i<n; i++){
            d[i]=rnd()%2;
        }
        int k1=flip_bits(d);
        if (k1>k){
            k=k1;
            maxi=c;
        }
        else {
            for (int i=0; i<n; i++){
                if (d[i] && maxi[i])maxi[i]=0;
                else if (d[i])maxi[i]=1;
            }
        }
    }
    int kk=flip_bits(maxi);
    if (kk!=k)assert(0);

    int pos=-1;
    for (int i=k-1; i<n; i+=k){
        if (c[i])c[i]=0;
        else c[i]=1;

        int x=flip_bits(c);

        if (pos!=-1){
            if (c[pos])c[pos]=0;
            else c[pos]=1;
            pos=-1;
        }

        if (x>=k){
            pos=i;
            continue;
        }

        int l=max(-1,i-k);
        int r=i;
        //c.assign(n,0);
        pos=i;
        while (l+1<r){
            int m=(l+r)>>1;
            if (c[m])c[m]=0;
            else c[m]=1;
            x=flip_bits(c);
            if (pos!=-1){
                if (c[pos])c[pos]=0;
                else c[pos]=1;
                pos=-1;
            }
            pos=m;
            if (x<k){
                r=m;
            }
            else {
                l=m;
            }
        }
        flip_bits(c);
        return {r,r+k-1};
    }
    assert(0);
}


/*signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL

}*/
