#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? (a = b, 1) : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? (a = b, 1) : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 3e5 + 5;
const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

int bpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int n, k;
int a[N];
int L[N], R[N];

//struct Node {
//    int mn, mx, cnt;
//};
//
//Node t[4 * N];
//
//Node combine(Node L, Node R) {
//    Node res;
//    res.mn = min(L.mn, R.mn);
//    res.mx = max(L.mx, R.mx);
//    res.cnt = L.cnt + R.cnt;
//    return res;
//}
//
//void build(int v = 1, int tl = 1, int tr = n) {
//    if (tl == tr) {
//        t[v].mn = t[v].mx = tl;
//        t[v].cnt = 1;
//        return;
//    }
//    int tm = (tl + tr) >> 1;
//    build(v << 1, tl, tm);
//    build(v << 1 | 1, tm + 1, tr);
//    t[v] = combine(t[v << 1], t[v << 1 | 1]);
//}
//
//void del(int v, int tl, int tr, int pos) {
//    if (tl == tr) {
//        t[v].mn = 1e9;
//        t[v].mx = -1e9;
//        t[v].cnt = 0;
//        return;
//    }
//    int tm = (tl + tr) >> 1;
//    if (pos <= tm) {
//        del(v << 1, tl, tm, pos);
//    } else {
//        del(v << 1 | 1, tm + 1, tr, pos);
//    }
//    t[v] = combine(t[v << 1], t[v << 1 | 1]);
//}
//
//void del(int pos) {
//    del(1, 1, n, pos);
//}
//
//int findFirstGreater(int v, int tl, int tr, int l, int r, int x) {
//    if (l > r || t[v] <= x) return -1;
//
//}

int t[N];

ve<pii> u;

void upd(int pos, int x) {
    while (pos <= n) {
        t[pos] += x;
        pos = pos | (pos + 1);
    }
}

int get(int pos) {
    int sum = 0;
    while (pos >= 0) {
        sum += t[pos];
        pos = (pos & (pos + 1)) - 1;
    }
    return sum;
}

int smart() {
    set<int> s;
    fr (i, 1, n) {
        upd(i, 1);
        s.insert(i);
    }

    int ans = 1;
    fr (i, 0, sz(u) - 2) {
        int pos = u[i].se;

        auto it1 = s.lower_bound(L[pos]);
        auto it2 = s.upper_bound(R[pos]);
        --it2;

        ans = mult(ans, get(*it2) - get(*it1 - 1));
        upd(pos, -1);
    }
    return ans;
}

int brute() {
    ve<int> idx;
    fr (i, 1, n) {
        idx.pb(i);
    }

    int ans = 1;
    while (sz(idx) > 1) {
        int mn = 1e9;
        int pos = -1;
        fr (i, 0, sz(idx) - 1) {
            if (a[idx[i]] < mn) {
                mn = a[idx[i]];
                pos = i;
            }
        }

        fr (i, pos, pos) {
            int cnt = 1;
            fr (j, i + 1, sz(idx) - 1) {
                if (idx[j] > R[idx[i]]) {
                    break;
                }
                cnt++;
            }
            rf (j, i - 1, 0) {
                if (idx[j] < L[idx[i]]) {
                    break;
                }
                cnt++;
            }

            ans = mult(ans, cnt);
        }
        idx.erase(idx.begin() + pos);
    }
    return ans;
}

map<ve<int>, bool> have;

ve<int> now;

void rec() {
    if (have[now]) {
        return;
    }
    have[now] = 1;
    fr (i, 0, sz(now) - 2) {
        if (now[i] + now[i + 1] <= k) {
            swap(now[i], now[i + 1]);
            rec();
            swap(now[i], now[i + 1]);
        }
    }
}

int fact[N];
int ifact[N];

int rnd(int l, int r) {
    return rng() % (r - l + 1) + l;
}

int id[N];
ve<int> occ[N];
ve<int> U;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    fact[0] = 1;
    fr (i, 1, N - 1) fact[i] = mult(fact[i - 1], i);
    ifact[N - 1] = bpow(fact[N - 1], MOD - 2);
    rf (i, N - 2, 0) {
        ifact[i] = mult(ifact[i + 1], i + 1);
    }

    cin >> n >> k;


    fr (i, 1, n) {
        cin >> a[i];
        u.pb({a[i], i});
        U.pb(a[i]);
    }
    sort(all(u));

    sort(all(U));
    U.erase(unique(all(U)), U.end());

    {
        int p = 0;
        fr (i, 0, sz(u) - 1) {
            if (i > 0 && u[i].fi != u[i - 1].fi) {
                p++;
            }
            id[u[i].se] = p;
        }
    }

    fr (i, 1, n) {
        occ[id[i]].pb(i);
    }

    {
        ve<int> st;
        fr (i, 1, n) {

            int l = 0;
            int r = sz(st) - 1;
            while (l < r) {
                int mid = l + ((r - l + 1) >> 1);
                if (a[st[mid]] + a[i] > k) {
                    l = mid;
                } else {
                    r = mid - 1;
                }
            }

            if (sz(st) && a[st[l]] + a[i] > k) {
                L[i] = st[l] + 1;
            } else {
                L[i] = 1;
            }

            while (sz(st) && a[i] >= a[st.back()]) {
                st.pop_back();
            }
            st.pb(i);
        }
    }
    {
        ve<int> st;
        rf (i, n, 1) {
            int l = 0;
            int r = sz(st) - 1;
            while (l < r) {
                int mid = l + ((r - l + 1) >> 1);
                if (a[st[mid]] + a[i] > k) {
                    l = mid;
                } else {
                    r = mid - 1;
                }
            }

            if (sz(st) && a[st[l]] + a[i] > k) {
                R[i] = st[l] - 1;
            } else {
                R[i] = n;
            }

            while (sz(st) && a[i] >= a[st.back()]) {
                st.pop_back();
            }
            st.pb(i);
        }

    }

    ve<bool> mark(n + 1);

    int res = 1;
    fr (i, 0, sz(U) - 1) {
        int cnt = 0;
        fr (j, 0, sz(occ[i]) - 1) {
            int pos = occ[i][j];
            if (j > 0 && R[occ[i][j - 1]] < pos) {
                res = mult(res, ifact[cnt]);
                cnt = 1;
            } else {
                cnt++;
            }
        }
        res = mult(res, ifact[cnt]);
    }

    int ans = smart();

    cout << mult(ans, res) << "\n";

    return 0;
}
