
#include <bits/stdc++.h>
using ll=long long;
using namespace std;
#include <vector>
#include <utility>
#include <cassert>
#include <iostream>

static int _n;
static std::vector<bool> _a;
static long long num_queries;

static int longest_seq_of_1s(){
    int ans = 0, curr = 0;
    for(int i = 0; i < _n; ++i){
        if(_a[i]){
            ++curr;
        }
        else{
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool> &flips){
    assert((int)flips.size() == _n);
    ++num_queries;
    for(int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];
    return longest_seq_of_1s();
}

std::pair<int, int> find_longest_subarray_of_ones(int n);

int main(){
    int t;
    std::cin >> t;

    long long max_qs = 0;

    while(t--){
        num_queries = 0;

        std::cin >> _n;
        _a.resize(_n);
        for(int i = 0; i < _n; ++i){
            bool val;
            std::cin >> val;
            _a[i] = val;
        }

        auto [l, r] = find_longest_subarray_of_ones(_n);
        for(int i=0;i<_n;i++)
        {
            cout<<_a[i]<<" ";
        }
        cout<<"\n";
        if(longest_seq_of_1s() != r - l + 1){
            std::cout << "0\n";
            return 0;
        }
        if(l == 0 && r == -1){
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if(r < l || l < 0 || l >= _n || r < 0 || r >= _n){
            std::cout << "0\n";
            return 0;
        }

        for(int i = l; i <= r; ++i){
            if(_a[i] != 1){
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
    }

    std::cout << "1 " << max_qs << "\n";
    return 0;
}
pair<int,int> find_longest_subarray_of_ones(int n)
{
    vector<bool> v (n);
    for(int i=0;i<n;i++)
    {
        v[i]=0;
    }
   // cout<<"FDSW\n";
    int initial=flip_bits(v);
    //cout<<"DSF";
    if(initial==0)
    {
        return {1,0};
    }

    v[0]=1;
    int temp=flip_bits(v);
    int first=-1;
    int second=-1;
    ll last=temp;
    for(int i=1;i<n;i++)
    {
       // cout<<"DS";
        v[i]=1;

        temp=flip_bits(v);
        if(i>0)
        {
            v[i-1]=0;
        }
        if(temp>initial)
        {
            v[i]=0;
            v[i+1]=1;
            int ne=flip_bits(v);
            if(ne<temp)
            {

                first=i;
                v[i]=1;
                flip_bits(v);
                v[i+1]=0;
                v[i]=0;
            }else{
                v[i]=1;
                flip_bits(v);
                v[i+1]=0;
                    //cout<<"GDSA";
                    cout<<first<<" "<<i<<"\n";
                    return {first,i};



            }

        }
        last=temp;

    }
    cout<<first+1<<" "<<n-1<<"\n";
    flip_bits(v);
    return {first+1,n-1};
}
