// Ones.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include "ones.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;
typedef vector<int> vi;
typedef vector<bool> vb;


std::pair<int, int> find_longest_subarray_of_ones(int n)
{
	vb mask(n, 1);
	flip_bits(mask);
	int len = flip_bits(mask);
	int l = 0, r = n - 1, mid;
	while (l < r)
	{
		mid = (l + r) / 2;
		fill(mask.begin(), mask.end(), false);
		for (int i = l; i <= mid; i++) 
			mask[i] = true;
		int l1 = flip_bits(mask);
		if (l1 > len)
		{
			r = mid; len = l1;
		}
		else if(l1 == len)
		{
			vb temp_mask(n, false);
			temp_mask[mid] = true;
			int temp_len1 = flip_bits(temp_mask);
			if (temp_len1 == len + 1)
			{
				vb temp_mask2 = mask;
				temp_mask2[mid] = false;
				int temp_len2 = flip_bits(temp_mask2);
				if (temp_len2 == temp_len1)
				{
					return { mid, mid + temp_len2 };
				}
				else l = mid;
			}
		}
		else
		{
			flip_bits(mask);
			r = mid;
		}
	}
	return { l, l + len - 1 };
}


/*std::pair<int, int> find_longest_subarray_of_ones(int n)
{
	vb mask(n, 1);
	flip_bits(mask);
	int len = flip_bits(mask);
	int l = 0;
	fill(mask.begin(), mask.end(), false);
	int last = len;
	while (last == len)
	{
		mask[l] = true;
		last = flip_bits(mask);
		if(last == len - 1) flip_bits(mask);
		if (last > len)
		{
			return { l - (last - len) + 1, l + len };
		}
		mask[l] = false;
		l++;
	}
	return{ l - 1, l - 1 + len };
}*/