
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define FIO ios_base::ios_base::sync_with_stdio(false); cin.tie(NULL);
#define all(x) x.begin(), x.end()
using namespace std;

using ll = long long;
using vi = vector<int>;

ll jumps(double from, double until, ll jump_size) {
	ll res = 0;

	for (ll i = from; i <= until; i++)
		if ( i*i % jump_size == 0) res++;

	return res;
}

int main() {
	ll p, q, n;
	
	cin >> p >> q >> n;

	ll res = 0;

	
	for (ll i = 1; i <= p; i++)
	{
		long double d = i * i + 4 * q * i;
		long double cmax = n;
		long double  cmin = 1;
		if (d >= 0) {
			long double c1 = (long double)(0.5 * (-i + sqrt(d)));
			long double c2 = (long double)(0.5 * (-i - sqrt(d)));

			cmax = max(c1, c2);
			cmax = min((long double)n, cmax);

			cmin = min(c1, c2);
			cmin = max((long double)1, cmin);
		}
		cmax = min((long double)p - i, cmax);

		if (d >= 0 && cmax >= cmin) {
			res += jumps(cmin, cmax, i);

		}
		
	}
	cout << res;
}