
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define FIO ios_base::ios_base::sync_with_stdio(false); cin.tie(NULL);
#define all(x) x.begin(), x.end()
using namespace std;

using ll = long long;
using vi = vector<int>;

ll jumps1( double until, ll jump_size) {
	ll res = floor(until / (jump_size));
	if (ceil(sqrt(jump_size)) == floor(sqrt(jump_size)) ) {
		 res = floor(until / sqrt(jump_size));
	}

	return res;
}





int main() {
	ll p, q, n;
	
	cin >> p >> q >> n;

	ll res = 0;
	ll ns = sqrt(n);
	vector<bool> prime(ns+1, 1);
	vi primes;
	prime[0] = false;
	prime[1] = false;
	for (int i = 2; i <= ns; i++)
	{
		if (prime[i])
		{
			prime.push_back(i);
			for (int j = 0; j < ns; j += i)
				prime[j] = false;
		}
	}






	for (ll i = 1; i <= p; i++)
	{
		long double d = i * i + 4 * q * i;
		long double cmax = n;
		long double  cmin = 1;
		if (d >= 0) {
			long double cmax = (long double)(0.5 * (-i + sqrt(d)));
			long double cmin = (long double)(0.5 * (-i - sqrt(d)));

			cmax = min((long double)n, cmax);

			cmin = max((long double)1, cmin);
		}
		cmax = min((long double)p - i, cmax);

		if (d >= 0 && cmax >= cmin) {
			res += jumps1( cmax, i) - jumps1(cmin, i);
		}
		
	}
	
	cout << res;
}