#include <vector>
#include <utility>
#include <cassert>
#include <iostream>
#include <math.h>
#include "ones.h"
using namespace std;
/*static int _n;
static std::vector<bool> _a;
static long long num_queries;

static int longest_seq_of_1s() {
    int ans = 0, curr = 0;
    for (int i = 0; i < _n; ++i) {
        if (_a[i]) {
            ++curr;
        }
        else {
            curr = 0;
        }
        ans = std::max(ans, curr);
    }
    return ans;
}

int flip_bits(const std::vector<bool>& flips) {
    cout << "flip: ";
    for (int a = 0; a < flips.size(); a++)
        cout << flips[a] << " ";
    cout << '\n';
    assert((int)flips.size() == _n);
    ++num_queries;
    for (int i = 0; i < _n; ++i)
        _a[i] = flips[i] ^ _a[i];
    return longest_seq_of_1s();
}//*/

pair<int, int> find_longest_subarray_of_ones(int n)
{
    vector <bool> flip(n, 0);
    int answer = flip_bits(flip);
    int last = -1;
    if (answer == n)
        return { 0, n - 1 };
    if (answer == 0)
    {
        flip[0] = 1;
        flip_bits(flip);
        return { 0, 0 };
    }
    int jumps = int(sqrt(n / answer));
    //cout << "jumps: " << jumps << '\n';
    int jumpsize = answer;
    //cout << "jumpsisze: " << jumpsize << '\n';
    vector <int> places;
    while (last + jumpsize < n)
    {
        for (int a = 0; a < places.size(); a++)
            flip[places[a]] = 0;
        places = {};
        for (int i = 0; i < jumps and last + jumpsize < n; i++)
        {
            last += jumpsize;
            flip[last] = 1;
            places.push_back(last);
        }
        int newanswer = flip_bits(flip);
        if (newanswer != answer)
        {
            flip_bits(flip);
            for (int i = 0; i < n; i++)
                flip[i] = 0;
            for (int i = 0; i < places.size(); i++)
            {
                flip[places[i]] = 1;
                if (i > 0)
                    flip[places[i - 1]] = 0;
                int answergot = flip_bits(flip);
                if (answer != answergot)
                {
                    //cout << "places: " << places[i] << '\n';
                    int answernow;
                    if (answer > answergot)
                    {
                        flip_bits(flip);
                        answernow = answer;
                    }
                    else
                        answernow = answergot;
                    flip[places[i]] = 0;
                    flip[places[i] - 1] = 1;
                    if (flip_bits(flip) > answernow)
                    {
                        flip_bits(flip);
                        //cout << "left: " << places[i] << " right: " << answergot - 1 + places[i] << '\n';
                        return { places[i], answernow - 1 + places[i] };
                    }
                    else
                    {
                        flip_bits(flip);
                        flip[places[i] - 1] = 0;

                        bool isgood = true;
                        int lind = places[i] - 1;
                        while (isgood and lind >= 0)
                        {
                            flip[lind] = 1;
                            int tempanswer = flip_bits(flip);
                            if (tempanswer > answernow)
                                isgood = false;
                            flip_bits(flip);
                            flip[lind] = 0;
                            lind--;
                        }
                        if (!isgood)
                            lind++;
                        //cout << lind + 1 << " " << lind + answernow << '\n';
                        //cout << answernow << '\n';
                        return { lind + 1, lind + answernow };
                        //cout << "i is: " << i << '\n';*/


                        /*int r = places[i] - 1;
                        int l;
                        if (i == 0)
                            l = max(0, places[i] - jumpsize);
                        else
                            l = places[i - 1] + 1;
                        while (l < r)
                        {
                            //cout << "l is: " << l << " r is: " << r << '\n';
                            int mid = (l + r) / 2;
                            flip[mid] = 1;
                            int temp = flip_bits(flip);
                            flip_bits(flip);
                            flip[mid] = 0;
                            if (temp < answernow)
                                r = mid;
                            else
                                l = mid + 1;
                        }
                        //cout << "2 l is: " << l << " and right is: " << l + answergot - 1 << '\n';
                        return { r, r + answernow - 1 };*/
                    }
                }
                flip_bits(flip);
            }
        }
    }
    //cout << "here";
    return { 0, 0 };
}

/*int main() {
    int t;
    std::cin >> t;

    long long max_qs = 0;

    while (t--) {
        num_queries = 0;

        std::cin >> _n;
        _a.resize(_n);
        for (int i = 0; i < _n; ++i) {
            bool val;
            std::cin >> val;
            _a[i] = val;
        }

        pair <int, int> temp = find_longest_subarray_of_ones(_n);
        int l = temp.first, r = temp.second;
        if (longest_seq_of_1s() != r - l + 1) {
            std::cout << "0\n";
            return 0;
        }
        if (l == 0 && r == -1) {
            max_qs = std::max(num_queries, max_qs);
            continue;
        }
        if (r < l || l < 0 || l >= _n || r < 0 || r >= _n) {
            std::cout << "0\n";
            return 0;
        }

        for (int i = l; i <= r; ++i) {
            if (_a[i] != 1) {
                std::cout << "0\n";
                return 0;
            }
        }

        max_qs = std::max(num_queries, max_qs);
    }
    cout << "arr: ";
    for (int a = 0; a < _a.size(); a++)
        cout << _a[a] << " ";
    cout << '\n';
    std::cout << "1 " << max_qs << "\n";
    return 0;
}
//*/
/*

    1
        10
        1 0 1 0 1 0 1 1 1 1


    1
12
1 0 1 0 1 1 1 0 1 0 1 1
*/
/*



                        /*bool isgood = true;
                        int lind = places[i] - 1;
                        while (isgood and lind >= 0)
                        {
                            flip[lind] = 1;
                            int tempanswer = flip_bits(flip);
                            if (tempanswer > answernow)
                                isgood = false;
                            flip_bits(flip);
                            flip[lind] = 0;
                            lind--;
                        }
                        cout << lind + 1 << " " << lind + answernow - 1 << '\n' << '\n';
                        return { lind + 1, lind + answernow - 1 };*/
                        //cout << "i is: " << i << '\n';*/