#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef vector<int> vi;
typedef vector<pair<int,int>> vpii;
typedef long long ll;
typedef vector<ll> vll;
int p = 1000000007;
ll calcPos(vi& v, int i, int k) {
    int j = i + 1, count = 1;
    while (j < v.size() && v[j] <= k - v[i]) {
        if (v[j] > v[i])
            count++;
        j++;
    }
    j = i - 1;
    while (j >= 0 && v[j] <= k - v[i]) {
        if (v[j] >= v[i])
            count++;
        j--;
    }
    return count;
}
ll pow(ll i, int n) {
    if (n == 0)
        return 1;
    if (n == 1)
        return i % p;
    ll ans = pow(i, n / 2);
    if (n % 2)
        return (((i * ans)%p) * ans) % p;
    else
        return (ans * ans) % p;
}
ll inv(ll i) {
    return pow(i, p - 2);
}
vll factDP(100000);
ll fact(int i) {
    if (factDP[i])
        return factDP[i];
    if (i == 0)
        return factDP[i] = 1;
    return factDP[i] = (i * fact(i - 1)) % p;
}
int main() {
    int n, k;
    cin >> n >> k;
    vi v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vpii ind(n);
    for (int i = 0; i < n; i++) {
        ind[i] = {v[i], i};
    }
    sort(ind.begin(), ind.end());
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        ans *= calcPos(v, i, k);
        ans%=1000000007;
    }
    for (int i = 1; i < n; i++) {
        int count = 1;
        while (ind[i].first == ind[i-1].first) {
            i++;
            count++;
        }
        ans = (ans * inv(fact(count))) % p;
    }
    cout<<ans;
}
