#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>
#include "ones.h"
using namespace std;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef vector<ll> vll;
typedef vector<bool> vb;
/*int p = 1000000007;
ll calcPos(vi& v, int i, int k) {
    int j = i + 1, count = 1;
    while (j < v.size() && v[j] <= k - v[i]) {
        if (v[j] > v[i])
            count++;
        j++;
    }
    j = i - 1;
    while (j >= 0 && v[j] <= k - v[i]) {
        if (v[j] >= v[i])
            count++;
        j--;
    }
    return count;
}
ll pow(ll i, int n) {
    i%=p;
    if (n == 0)
        return 1;
    if (n == 1)
        return i % p;
    ll ans = pow(i, n / 2);
    if (n % 2)
        return (((i * ans)%p) * ans) % p;
    else
        return (ans * ans) % p;
}
ll inv(ll i) {
    return pow(i, p - 2);
}
vll factDP(100000);
ll fact(ll i) {
    if (factDP[i])
        return factDP[i];
    if (i == 0)
        return factDP[i] = 1;
    return factDP[i] = (i * fact(i - 1)) % p;
}
int main() {
    int n, k;
    cin >> n >> k;
    vi v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vpii ind(n);
    for (int i = 0; i < n; i++) {
        ind[i] = {v[i], i};
    }
    sort(ind.begin(), ind.end());
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        ans *= calcPos(v, i, k);
        ans%=p;
    }
    for (int i = 1; i < n; i++) {
        int count = 1;
        while (ind[i].first == ind[i-1].first) {
            i++;
            count++;
        }
        ans = (ans * inv(fact(count))) % p;
    }
    cout<<ans;
    /*for (ll i = 0; i < 1000000; i++) {
        if (((((i*i)%p)*inv(i*i))%p)-1)
            cout<<i<<endl;
    }*
}*/
void printv(vb v){
    for (bool i:v)
        cout<<i<<" ";
    cout<<endl;
}
vb randv(int i, int j, int n) {
    /*static int k = 0;
    //vector<vb> vvb = {{1,0,1,1,1},{1,0,1,0,0},{1,0,0,0,0},{0,0,1,0,0},{1,0,0,0,0},{1,0,0,0,0}};
    vector<vb> vvb = {{0,0,1,1,1},{0,1,1,0,0},{0,1,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,1,0,0,0}};
    printv(vvb[k]);
    return vvb[k++];*/
    vb v(n);
    srand(time(nullptr));
    for (int l = i; l <= j; l++) {
        v[l] = rand() % 2;
    }
    printv(v);
    return v;
}
vb xorv(vb v1, vb v2) {
    vb v(v1.size());
    for (int i = 0; i < v1.size(); i++)
        v[i]=v1[i]^v2[i];
    return v;
}
pii find_longest_subarray_of_ones(int n) {
    if (n == 1)
        return {0, -1};
    int a = flip_bits(randv(0, n - 1, n));
    if (a == 0)
        return {0, -1};
    int l = 0, r = n - 1, a2;
    vb vp = vb(n), v;
    while (l < r) {
        int m = (l + r) / 2;
        v = randv(l, m, n);
        a2 = flip_bits(xorv(v, vp));
        if (a2 != a) {
            r = m;
            if (a2 < a)
                vp = v;
            else {
                vp = vb(n);
                a=a2;
            }
        } else {
            v = randv(m + 1, r, n);
            a2 = flip_bits(v);
            if (a2 != a) {
                l = m + 1;
                if (a2 < a)
                    vp = v;
                else {
                    vp = vb(n);
                    a=a2;
                }
            }
        }
    }
    if (a2<a)
        for (int i = 0; i < n; i++) {
            if (i == l)
                vp[i] = 1;
            else
                vp[i] = 0;
        }
    else
        vp=vb(n);
    int count = 1;
    for (int i = 0; i < n; i++) {
        if (i == l+1)
            v[i] = 1;
        else
            v[i] = 0;
    }
    a2 = flip_bits(xorv(v,vp));
    while (a2!=a) {
        count++;
        l++;
        vp=v;
        for (int i = 0; i < n; i++) {
            if (i == l+1)
                v[i] = 1;
            else
                v[i] = 0;
        }
        a2 = flip_bits(xorv(v,vp));
    }

    vp=vb(n);
    l=r;
    int rcount = count;
    count = 0;
    for (int i = 0; i < n; i++) {
        if (i == l+1)
            v[i] = 1;
        else
            v[i] = 0;
    }
    a2 = flip_bits(xorv(v,vp));
    while (a2!=a) {
        count++;
        l--;
        vp=v;
        for (int i = 0; i < n; i++) {
            if (i == l-1)
                v[i] = 1;
            else
                v[i] = 0;
        }
        a2 = flip_bits(xorv(v,vp));
    }
    cout<<r<<" "<<count<<" "<<rcount<<endl;
    return {r-count,r+rcount};
}