#include "ones.h";
#include <bits/stdc++.h>
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
int rand(int a, int b) {
    return a+rng()%(b-a+1);
}

std::pair<int, int> find_longest_subarray_of_ones(int n) {

    vector<bool> scuza(n,0);
    int norm=flip_bits(scuza);
    if (norm==0) {
        scuza.assign(n,1);
        flip_bits(scuza);
        return {0,n-1};
    }
    if (norm==n) {
        return {0,n-1};
    }

    int len=norm;

    int i;
    for (int it=0; it<5; ++it) {
        i=0;
        while (i+len<=n) {
            scuza.assign(n,0);
            scuza[i+len-1]=1;
            int x=flip_bits(scuza);
            if (x==len) {
                flip_bits(scuza);
                i+=len;
                continue;
            }
            if (x>len) {
                scuza.assign(n,0);
                int L,R;
                int l=0,r=i+len-1;
                while (l<r) {
                    int mid=(l+r)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=x) {
                        l=mid+1;
                    } else r=mid;
                    scuza[mid]=0;
                }
                L=r;
                l=i+len-1,r=n-1;
                while(l<r) {
                    int mid=(l+r+1)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=x) {
                        r=mid-1;
                    } else l=mid;
                    scuza[mid]=0;
                }
                R=r;
                return {L,R};
            }
            if (x<len) {
                flip_bits(scuza);
                scuza.assign(n,0);
                int L,R;
                int l=0,r=i+len-1;
                while (l<r) {
                    int mid=(l+r)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        l=mid+1;
                    } else r=mid;
                    scuza[mid]=0;
                }
                L=r;
                l=i+len-1,r=n-1;
                while(l<r) {
                    int mid=(l+r+1)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        r=mid-1;
                    } else l=mid;
                    scuza[mid]=0;
                }
                R=r;
                return {L,R};
            }
        }
        i=0;
        while (i+len<=n) {
            scuza.assign(n,0);
            scuza[i+len-1]=1;
            int x=flip_bits(scuza);
            if (x==len) {
                i+=len;
                continue;
            }
            if (x>len) {
                scuza.assign(n,0);
                int L,R;
                int l=0,r=i+len-1;
                while (l<r) {
                    int mid=(l+r)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=x) {
                        l=mid+1;
                    } else r=mid;
                    scuza[mid]=0;
                }
                L=r;
                l=i+len-1,r=n-1;
                while(l<r) {
                    int mid=(l+r+1)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=x) {
                        r=mid-1;
                    } else l=mid;
                    scuza[mid]=0;
                }
                R=r;
                return {L,R};
            }
            if (x<len) {
                flip_bits(scuza);
                scuza.assign(n,0);
                int L,R;
                int l=0,r=i+len-1;
                while (l<r) {
                    int mid=(l+r)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        l=mid+1;
                    } else r=mid;
                    scuza[mid]=0;
                }
                L=r;
                l=i+len-1,r=n-1;
                while(l<r) {
                    int mid=(l+r+1)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        r=mid-1;
                    } else l=mid;
                    scuza[mid]=0;
                }
                R=r;
                return {L,R};
            }
        }
    }
                scuza.assign(n,0);
                int L,R;
                int l=0,r=i;
                while (l<r) {
                    int mid=(l+r)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        l=mid+1;
                    } else r=mid;
                    scuza[mid]=0;
                }
                L=r;
                l=i,r=n-1;
                while(l<r) {
                    int mid=(l+r+1)>>1;
                    scuza[mid]=1;
                    int y=flip_bits(scuza);
                    flip_bits(scuza);
                    if (y>=len) {
                        r=mid-1;
                    } else l=mid;
                    scuza[mid]=0;
                }
                R=r;
                return {L,R};
}