#include <bits/stdc++.h>
#include "ones.h"

#pragma GCC optimize("Ofast")


#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int nrbits = 13;

int N;
int last = 0;

int intreaba(vector <int> v){
    vector <bool> flip(N, 0);
    for(auto x : v)
        flip[x] = 1;
    return flip_bits(flip);
}

pii inSecv(int x){
    int r = x, pas = (1 << (int)(log2(x)));
    while(pas){
        if(r - pas >= 0){
            vector <int> toFlip;
            toFlip.push_back(r - pas);
            int rez = intreaba(toFlip);
            if(rez < last)
                r -= pas;
            intreaba(toFlip);
        }
        pas /= 2;
    }
    return {r, r + last - 1};
}

pair <int, int> solveBrut(vector <int> v){
    vector <int> toFlip;
    if(!v.size())
        return {0, N - 1};
    for(int i = 0; i < v.size() - 1; i++){
        int x = v[i];
        toFlip.clear();
        toFlip.push_back(x);
        int rez = intreaba(toFlip);
        if(rez != last){
            if(rez > last){
                last = rez;
            }else{
                intreaba(toFlip);
            }
            return inSecv(x);
        }
    }
    return inSecv(v.back());
}

pii jmek(vector <int> v){
    if(v.size() <= 2){
        return solveBrut(v); /// Necesar?
    }
    vector <int> a, b;
    random_shuffle(v.begin(), v.end());
    for(int i = 0; i < v.size() / 2; i++){
        a.push_back(v[i]);
    }
    for(int i = v.size() / 2; i < v.size(); i++){
        b.push_back(v[i]);
    }
    int rez = intreaba(a);
    if(rez < last){
        intreaba(a);
        return jmek(a);
    }else if(rez > last){
        last = rez;
        if(last == N)
            return {0, N - 1};
        return jmek(a);
    }
    rez = intreaba(b);
    if(rez < last){
        intreaba(b);
        return jmek(b);
    }else if(rez > last){
        last = rez;
        if(last == N)
            return {0, N - 1};
        return jmek(b);
    }
    intreaba(v);
    return jmek(v);
}

pair<int, int> find_longest_subarray_of_ones(int n){
    N = n;
    srand(time(0));
    vector <int> ind;
    last = intreaba(ind);
    if(last == n){
        return {0, n - 1};
    }
    for(int i = 0; i < n; i+=10){
        ind.push_back(i);
    }
    return jmek(ind);
}
