#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define ll long long
#define x first
#define y second
#define pii pair <int, int>
#define ld long double
#define lsb(x) ((x) & (-(x)))

using namespace std;

mt19937 gen(time(0));
uniform_int_distribution <int64_t> rng;

const int MOD = (int)1e9 + 7;

int n, k;

int v[300005], in[300005];
vector <int> g[300005];

void solve() {
    cin >> n >> k;
    for(int i = 1; i <= n; i++)
        cin >> v[i];

    for(int i = 1; i <= n; i++) {
        for(int j = i + 1; j <= n; j++) {
            if(v[i] + v[j] > k)
                g[i].push_back(j), in[j]++;
        }
    }

    queue <int> q;
    vector <int> top;
    for(int i = 1; i <= n; i++) {
        if(!in[i])
            q.push(i);
    }

    while(!q.empty()) {
        int node = q.front();
        top.push_back(node);
        q.pop();

        for(auto &son : g[node]) {
            in[son]--;
            if(!in[son])
                q.push(son);
        }
    }

    int ans = 1;
    for(int i = 0; i < top.size(); i++) {
        for(int j = i + 1; j < top.size(); j++) {
            if(v[top[i]] + v[top[j]] > k) {
                ans = 1LL * ans * (j - i) % MOD;
                break;
            }
        }
    }

    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int T = 1;
    while(T--) {
        solve();
    }
    return 0;
}
