#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define ll long long
#define x first
#define y second
#define pii pair <int, int>
#define ld long double
#define lsb(x) ((x) & (-(x)))

using namespace std;

mt19937 gen(time(0));
uniform_int_distribution <int64_t> rng;

const int MOD = (int)1e9 + 7;

int n, k;
int cnt;

int v[300005], w[300005], in[300005];
vector <int> g[300005];

/*
7 7
5 2 7 3 1 6 4
*/

bool test = 0;


void solve() {
    if(!test)
        cin >> n >> k;
    else
        n = 7, k = rng(gen) % 10 + 1, cout << n << " " << k << "\n";

    set <int> vals;
    map <int, int> cod;
    int m = 0;

    for(int i = 1; i <= n; i++) {
        if(!test)
            cin >> v[i];
        else
            v[i] = i;
        vals.insert(v[i]);
    }

    for(auto &i : vals)
        cod[i] = ++m;

    for(int i = 1; i <= n; i++)
        v[i] = cod[v[i]];

    if(test) {
        random_shuffle(v + 1, v + n + 1);
        for(int i = 1; i <= n; i++)
            cout << v[i] << " ";
        cout << "\n";
    }

    for(int i = 1; i <= n; i++) {
        for(int j = i + 1; j <= n; j++) {
            if(v[i] + v[j] > k)
                g[v[i]].push_back(v[j]), in[v[j]]++;
        }
    }

    queue <int> q;
    vector <int> top;
    for(int i = 1; i <= n; i++) {
        if(!in[i])
            q.push(i);
    }

    while(!q.empty()) {
        int node = q.front();
        top.push_back(node);
        q.pop();

        for(auto &son : g[node]) {
            in[son]--;
            if(!in[son])
                q.push(son);
        }
    }

    vector <int> poz(n + 1);
    for(int i = 0; i < top.size(); i++)
        poz[top[i]] = i;

    for(int i = 0; i < top.size(); i++) {
        for(auto &j : g[top[i]]) {
            assert(poz[j] > i);
        }
    }

    int ans = 1;
    for(int i = 0; i < top.size(); i++) {
        for(int j = i + 1; j < top.size(); j++) {
            if(top[i] + top[j] > k) {
                ans = 1LL * ans * (j - i) % MOD;
                break;
            }
        }
    }

    cout << ans << "\n";
}

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int T = 1;
    while(T--) {
        solve();
    }
    return 0;
}
