#include "ones.h"
#include <iostream>
#include <random>
#include <ctime>

using namespace std;

mt19937 gen(time(0));

pair <int, int> find_longest_subarray_of_ones(int n)
{
    vector <bool> aux, used;
    aux.resize(n);
    used.resize(n);
    for(int i = 0; i < n; i++)
    {
        aux[i] = 0;
        used[i] = 0;
    }
    int init_max = flip_bits(aux);
    if(init_max == 0)
        return {0, -1};
    if(init_max == n)
        return {0, n - 1};
    int curr;
    for(int i = 1; i <= min(n, 2000); i++)
    {
        int poz = gen() % n;
        //cout << poz << '\n';
        if(used[poz])
        {
            i--;
            continue;
        }
        used[poz] = 1;
        aux[poz] = 1;
        curr = flip_bits(aux);
        flip_bits(aux);
        aux[poz] = 0;
        if(curr > init_max)
        {
            aux[poz] = 1;
        flip_bits(aux);
        aux[poz] = 0;
            init_max = curr;
            int st = poz - 1, dr = poz + 1;
            while(st >= 0)
            {
                aux[st] = 1;
                curr = flip_bits(aux);
                flip_bits(aux);
                aux[st] = 0;
                if(curr > init_max)
                    break;
                st--;
            }
            st++;
            while(dr < n)
            {
                aux[dr] = 1;
                curr = flip_bits(aux);
                flip_bits(aux);
                aux[dr] = 0;
                if(curr > init_max)
                    break;
                dr++;
            }
            dr--;
            return {st, dr};
        }
    }
}
