#include "ones.h"
using namespace std;

pair <int, int> find_longest_subarray_of_ones(int n)
{
    vector <bool> aux;
    aux.resize(n);
    int init_max = flip_bits(aux);
    if(init_max == 0)
        return {0, -1};
    if(init_max == n)
        return {0, n - 1};
    int poz = 0, curr;
    while(poz < n)
    {
        aux[poz] = 1;
        curr = flip_bits(aux);
        flip_bits(aux);
        aux[poz] = 0;
        if(curr > init_max)
            break;
        poz++;
    }
    init_max = curr;
    if(init_max == n)
        return {0, n - 1};
    aux[poz] = 1;
    flip_bits(aux);
    aux[poz] = 0;
    int st = poz - 1, dr = poz + 1;
    while(st >= 0)
    {
        aux[st] = 1;
        curr = flip_bits(aux);
        flip_bits(aux);
        aux[st] = 0;
        if(curr > init_max)
            break;
        st--;
    }
    st++;
    while(dr < n)
    {
        aux[dr] = 1;
        curr = flip_bits(aux);
        flip_bits(aux);
        aux[dr] = 0;
        if(curr > init_max)
            break;
        dr++;
    }
    dr--;
    return {st, dr};
}
