#include <bits/stdc++.h>
#define fin cin
#define fout cout

using namespace std;

//ifstream fin("f1.in");
//ofstream fout("f1.out");

const int PMAX = 1e7, NMAX = 7;

bool ap[PMAX + 1];
int v[NMAX], aux[NMAX];
int q[PMAX + 1];
int qlen, l, r;

void print(int arr[], int n);
void norm(int arr[], int n);
int cod(int arr[], int n);
void decod(int arr[], int n, int cd);
void push(int cd);
int pop();
void bfs(int arr[], int n, int k);

int main()
{
    int n, k;

    fin >> n >> k;
    for (int i = 0; i < n; i++)
        fin >> v[i];
    bfs(v, n, k);

    int cnt = 0;
    for (int i = 0; i < PMAX; i++)
        cnt += ap[i];
    fout << cnt;
    return 0;
}

void print(int arr[], int n) {
    for (int i = 0; i < n; i++)
        cout << arr[i] << " ";
    cout << '\n';
}

void norm(int arr[], int n) {
    for (int i = 0; i < n; i++)
            aux[i] = arr[i];

    sort(aux, aux + n);
    for (int i = 0; i < n; i++) {
        int j = 0;
        for (; arr[i] != aux[j]; j++);
            arr[i] = j;
    }
}

int cod(int arr[], int n) {
    int cd = 0;
    for (int i = 0; i < n; i++)
        cd = cd * NMAX + arr[i];
    return cd;
}

void decod(int arr[], int n, int cd) {
    int i = n - 1;
    while (i >= 0) {
        arr[i--] = cd % NMAX;
        cd /= NMAX;
    }
}

void push(int cd) {
    qlen++;
    q[r++] = cd;
}

int pop() {
    qlen--;
    return q[l++];
}

void bfs(int arr[], int n, int k) {
    norm(arr, n);

    int cd = cod(arr, n), newcd;
    ap[cd] = 1;
    l = r = 0;
    qlen = 0;
    push(cd);

    while (qlen) {
        cd = pop();
        decod(arr, n, cd);

        for (int i = 0; i < n - 1; i++) {
            if (aux[arr[i]] + aux[arr[i + 1]] <= k) {
               // print(arr, n);
                swap(arr[i], arr[i + 1]);
               // print(arr, n);
               // cout << '\n';
                newcd = cod(arr, n);
                if (!ap[newcd]) {
                    ap[newcd] = 1;
                    push(newcd);
                }
                swap(arr[i], arr[i + 1]);
            }
        }
    }
}
