#include <bits/stdc++.h>
#define int long long 
using namespace std;

#ifdef EVAL
#define in cin
#define out cout
#else
ifstream in("in.in");
ofstream out("out.out");
#endif

const int MOD = 1000000007,inf = (1LL << 60);
struct Element {
    int pos, val;
    mutable int nr_behind;

    Element(int pos, int val, int nr_behind) {
        this->pos = pos;
        this->val = val;
        this->nr_behind = nr_behind;
    }
    bool operator < (const Element other) const {
        return pos < other.pos;
    }

    bool operator < (const int other) const {
        return pos < other;
    }
};

int32_t main() {
    int n,k;
    in >> n >> k;
    vector<int> a(n + 1),taken(n + 1, 0);
    vector<pair<int,int>> values;

    set<Element,less<>> s;

    for (int i = 1; i <= n; i++) {
        in >> a[i];
        values.push_back({a[i] , i});
    }
    sort(values.begin() , values.end(), [&](pair<int,int> x, pair<int,int> y) {
        return x.first > y.first;
    });

    s.insert(Element({n + 1, inf, 0}));


    auto erase_front = [&](set<Element> :: iterator it, int x_val) {
        int nr_erased = 0;
        auto after = it; /// the element that comes after
        while(after != s.end() && after->val + x_val <= k) {
            nr_erased += after->nr_behind + 1;
            after = s.erase(after);
        }
        after->nr_behind += nr_erased;
        return after;
    };

    auto erase_behind = [&](set<Element> :: iterator it, int x_val) {
        int nr_erased = 0;
        while(it != s.begin()) {
            it--;
            if (it->val + x_val <= k) {
                nr_erased += it->nr_behind + 1;
                it = s.erase(it);
            } else {
                break;
            }
        }
        return nr_erased;
    };

    auto get_so_far = [&](int x) {

        auto it = s.lower_bound(x);

        auto new_front = erase_front(it, a[x]);
        int erased_behind = erase_behind(new_front, a[x]);

        s.insert({x , a[x] , erased_behind});
        return new_front->nr_behind + 1 + erased_behind;
    };
    int prod = 1;
    for (auto k : values) {
        prod = prod * get_so_far(k.second) % MOD;
        taken[k.second] = 1;
    }

    out << prod << "\n";
}