#include <bits/stdc++.h>

#ifdef EVAL
#include "ones.h"
#else
#include "ones_grader.cpp"
#endif

using namespace std;

vector<bool> v;
int length_subarray=0;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
int rand(int l, int r) {
    return rng() % (r - l + 1) + l;
}

bool increases(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    flip_bits(v);
    v[i] = 0;
    return res > length_subarray;
}
bool decreases(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    flip_bits(v);
    v[i] = 0;
    return res < length_subarray;    
}
 
int flip(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    v[i] = 0;
    return res;
}

pair<int,int> find_longest_subarray_of_ones(int n) {
    v = vector<bool>(n,false);
    length_subarray = flip_bits(v);
    if (length_subarray == n) {
        return {0, n - 1};
    }
    if (length_subarray == 0) {
        return {0,-1};
    }

    ///find a value that when flipped makes a bigger lengrth_subarray
    bool found = false;
    vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[i] = i;
    }
    shuffle(pos.begin(), pos.end(), rng);

    int i = 0,p;
    while(!found) {
        int this_p = pos[i++];
        v[this_p] = 1;
        int x = flip_bits(v);

        if (x > length_subarray) {
            p = this_p;
            length_subarray = x; 
            found = true;
        } else {
            flip_bits(v);
        }

        v[this_p] = 0;
    }

    ///we know p is part of the subarray in some way
    for (int i = p - 1; i >= 0; i--){
        if (increases(i)) {
            return {i + 1, i + length_subarray};
        }
    }
    return {0 ,length_subarray - 1};
    
}