#include <bits/stdc++.h>

#ifdef EVAL
#include "ones.h"
#else
#include "ones_grader.cpp"
#endif

using namespace std;

vector<bool> v;
int length_subarray=0;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
int rand(int l, int r) {
    return rng() % (r - l + 1) + l;
}

bool increases(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    flip_bits(v);
    v[i] = 0;
    return res > length_subarray;
}
bool decreases(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    flip_bits(v);
    v[i] = 0;
    return res < length_subarray;    
}
 
int flip(int i) {
    v[i] = 1;
    int res = flip_bits(v);
    v[i] = 0;
    return res;
}

void randomize(int n) {
    vector<bool> v2(n);
    for (int i = 0; i < n; i++) {
        v2[i] = rand(0,1);
    }
    flip_bits(v2);
}

bool found = false;
int pos,n_global;
vector<int> shuffled;
int batch(int st, int dr) {
    vector<bool> v2(n_global);
    for (int i = st; i <= dr; i++) {
        v2[shuffled[i]] = 1;
    }
    int res = flip_bits(v2);
}
void investigate(int st, int dr) {
    if (dr > st) {
        return; /// -1 if not found, a value if found
    }
    if (found == true) {
        return;
    }
    int mid = (st + dr) / 2;
    int f = batch(st, mid);
    if (f > length_subarray) {
        if (st == mid) {
            pos = st;
            found = true;
        } 

        investigate(st , mid);
        investigate(dr , mid + 1);
    } else {
        investigate(dr, mid + 1);
        investigate(st , mid);
    }
}
int find_pos(int n) {
    /// this just needs to find an index that increases the overall sum
    found = false;
    shuffled = vector<int>(n);
    for (int i = 0; i < n; i++) {
        shuffled[i] = i;
    }
    shuffle(shuffled.begin(), shuffled.end() , rng);
    n_global = n;
    investigate(0,n-1);
    return pos;
}
pair<int,int> find_longest_subarray_of_ones(int n) {
    randomize(n);
    v = vector<bool>(n,false);
    length_subarray = flip_bits(v);
    if (length_subarray == n) {
        return {0, n - 1};
    }
    if (length_subarray == 0) {
        return {0,-1};
    }

    ///find a value that when flipped makes a bigger lengrth_subarray

    int p = find_pos(n);

    ///we know p is part of the subarray in some way
    for (int i = p - 1; i >= 0; i--){
        if (increases(i)) {
            return {i + 1, i + length_subarray};
        }
    }
    return {0 ,length_subarray - 1};
    
}