#include <bits/stdc++.h>

using namespace std;
using ii = pair<int, int>;
using ll = long long;
using vi = vector<int>;

const int MN = 300071;
const int MV = 600071;
const ll MOD = 1e9 + 7;


int V[MN];
vector<ii> Ord;
int n, k;

set<int> Zid;

struct AIB {
    int V[MN];
    void update(int p, int v) {
        while(p < MN) {
            V[p] += v;
            p += p & -p;
        }
    }
    int q(int p) {
        int re = 0;
        while(p) {
            re += V[p];
            p -= p & -p;
        }
        return re;
    }
    int query(int st, int dr) {
        if(st > dr) return 0;
        if(!st) return q(dr);
        return q(dr) - q(st - 1);
    }
} mingi;

vector<ii> ZidPop;
ll Fact[MV], IFact[MV];
ll lp(ll v, int e) {
    return !e ? 1 : (e & 1) ? v * lp(v * v % MOD, e >> 1) % MOD : lp(v * v % MOD, e >> 1);
}
ll inv(ll v) {
    return lp(v, MOD - 2);
}
ll comb(ll n, ll k) {
    return Fact[n] * IFact[k] % MOD * IFact[n - k] % MOD;
}

int main() {
    Fact[0] = 1;
    for(int i = 1; i < MV; ++i)
        Fact[i] = Fact[i - 1] * i % MOD;
    IFact[MV - 1] = inv(Fact[MV - 1]);
    for(int i = MV - 2; i >= 0; --i) {
        IFact[i] = IFact[i + 1] * (i + 1) % MOD;
    }

    cin >> n >> k;
    for(int i = 1; i <= n; ++i) {
        cin >> V[i];
        Ord.push_back({V[i], i});
    }
    sort(Ord.rbegin(), Ord.rend());
    Zid.insert(0);
    Zid.insert(n + 1);
    ll re = 1;
    for(int i = 0; i < Ord.size(); ++i) {
        int dr = i;
        while(dr + 1 < Ord.size() && Ord[dr + 1].first == Ord[dr].first)
            ++dr;
        //avem de inserat secv [i, dr];
        if(Ord[i].first * 2 > k) { ///inca sunt ziduri
            for(int j = i; j <= dr; ++j) {
                Zid.insert(Ord[i].second);
                ZidPop.push_back(Ord[i]);
            }
            continue;
        }
        ///nu mai avem de a face cu ziduri
        //sterg ziduri inutile
        while(!ZidPop.empty() && ZidPop.back().first + Ord[i].first <= k) {
            //delete zid
            Zid.erase(ZidPop.back().second);
            ///TODO apare o mingiuta
            mingi.update(ZidPop.back().second, 1);
            ZidPop.pop_back();
        }
      //  printf("Sunt la pasul %d -> %d\nAm ziduri: ", i, dr);
      //  for(auto it : Zid)
      //      printf("%d ", it);
      //  printf("\n");

        ///identific segmente pt fiecare mingiuta
        vector<ii> cape;
        for(int j = i; j <= dr; ++j) {
            auto it = Zid.lower_bound(Ord[i].second);
            int cap_dr = *it;
            --it;
            int cap_st = *it;
            cape.push_back({cap_st, cap_dr});
        }
        sort(cape.begin(), cape.end());
        for(int j = 0; j < cape.size(); ++j) {
            int jd = j;
            while(jd + 1 < cape.size() && cape[j] == cape[jd + 1])++jd;
            int nr = jd - j + 1;
            ///avem nr intre (cape[j].first si cape[j].second)
            int nr_deja = mingi.query(cape[j].first, cape[j].second);
            
            ll nrm = comb(nr_deja + nr, nr);
            //printf("avem de pus %d numere intre (%d, %d), dar deja sunt acolo %d => re *= %d", nr, cape[j].first, cape[j].second, nr_deja, nrm);
            re = re * nrm % MOD;
            j = jd;
        }
        for(int j = i; j <= dr; ++j)
            mingi.update(Ord[i].second, 1);
        i = dr;
            
    }
    cout << re << "\n";
    return 0;
}

