#include <bits/stdc++.h>
#include "ones.h"

using namespace std;

using ii = pair<int, int>;
using vi = vector<int>;

vector<bool> Op, histop;
int n;

int nuke(int st, int dr) {
    for(int i = st; i <= dr; ++i) {
        Op[i] = rand() & 1;
    }
    int re = flip_bits(Op);
    for(int i = st; i <= dr; ++i) {
        Op[i] = 0;
    }
    return re;
}



int revnuke(int st, int dr) {
    for(int i = 0; i < n; ++i) {
        if(i < st || i > dr)
            Op[i] = rand() & 1;
    }
    int re = flip_bits(Op);
    for(int i = 0; i < n; ++i) {
        if(Op[i])
            histop[i] = 1 - histop[i];
        Op[i] = 0;
    }
    return re;
}

void undo_revnuke() {
    flip_bits(histop);
    for(int i = 0; i < n; ++i)
        histop[i] = 0;
}


ii find_longest_subarray_of_ones(int nlocal) {
    n = nlocal;
    srand(72);
    Op.assign(n, 0);
    histop.assign(n, 0);
    int lma = nuke(0, n - 1);
    if(lma == n) {
        return {0, n - 1};
    }
    if(!lma)
        return {0, -1};
    if(n < 6) {
        while(1) {
            lma = nuke(0, n - 1);
            if(lma == n) {
                return {0, n - 1};
            }
            if(!lma)
                return {0, -1};
        }
    }

    int expv = 1;
    while((1 << expv) <= n) expv++;
    while(lma < expv + 1) {
        lma = nuke(0, n - 1);
    }
    
    int st = 0, dr = n - lma;
    while(st < dr) {
        int mij = (st + dr) >> 1;
        int ok = 1;
        for(int i = 0; i <= 7; ++i) {
            if(revnuke(st, mij + lma - 1) < lma){
				ok = 0;
				break;
			}
        }
        undo_revnuke();
        if(ok) {
            dr = mij; 
        } else {
            st = mij + 1;
        }
    }
    return {st, st + lma - 1};
}
