#include <bits/stdc++.h>

using namespace std;

const int nmax = 3e5;

int n,k;

int v[nmax + 5];
int p[nmax + 5];

int a[1005][1005];
vector<int> G[nmax + 5];

bool sel[nmax + 5];

vector<int> l;

void dfs(int nod)
{
    sel[nod] = true;
    for(auto it : G[nod])
    {
        if(!sel[it])
        {
            continue;
        }
        dfs(it);
    }
    l.push_back(nod);
}

void topsort()
{
    for(int i=1; i<=n; i++)
    {
        if(!sel[i])
        {
            dfs(i);
        }
    }
    reverse(l.begin(),l.end());
}

void solve_prost()
{
    for(int i=1; i<=n; i++)
    {
        p[i] = i;
    }
    int rez = 0;
    do
    {
        bool ok = true;
        for(int i=1; i<=n && ok; i++)
        {
            for(int j=i+1; j<=n; j++)
            {
                if(a[p[j]][p[i]])
                {
                    ok = false;
                    break;
                }
            }
        }
        rez += ok;
    }
    while(next_permutation(p+1,p+n+1));
    cout<<rez<<'\n';
}

void solve_bun()
{

}

void Add_edge(int i, int j)
{
    G[i].push_back(j);
    a[i][j] = true;
}

void divide(int st, int dr)
{
    if(st>=dr)
    {
        return;
    }
    int poz = st;
    for(int i=st;i<=dr;i++)
    {
        if(v[i] > v[poz])
        {
            poz = i;
        }
    }
    bool okst = false;
    for(int i=st;i<poz;i++)
    {
        if(v[i] + v[poz] > k)
        {
            okst = true;
            Add_edge(i,poz);
        }
    }
    bool okdr = false;
    for(int i=poz+1;i<=dr;i++)
    {
        if(v[poz] + v[i] > k)
        {
            okdr = true;
            Add_edge(poz,i);
        }
    }
    if(okst)
    {
        divide(st,poz-1);
    }
    if(okdr)
    {
        divide(poz+1,dr);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef HOME
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // HOME
    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        cin>>v[i];
    }
    divide(1,n);
    /*for(int i=1; i<=n; i++)
    {
        for(int j=i+1; j<=n; j++)
        {
            if(v[i] + v[j] > k)
            {
                Add_edge(i,j);
            }
        }
    }
    */
    topsort();
    solve_bun();
   // solve_prost();
    return 0;
}
