#include <bits/stdc++.h>
#define int long long

using namespace std;

const int Mod = 1e9 + 7;

int n,k;

int lgput(int a, int b)
{
    int p = 1;
    while(b)
    {
        if(b%2==0)
        {
            b/=2;
            a = 1LL * a * a % Mod;
        }
        else
        {
            --b;
            p = 1LL * p * a % Mod;
        }
    }
    return p;
}

int invmod(int x)
{
    return lgput(x,Mod-2);
}

int aranj(int a, int b)
{
    int rez = 1;
    for(int i=a-b+1;i<=a;i++)
    {
        rez = 1LL * rez * i % Mod;
    }
    return rez;
}

int fact(int a)
{
    int rez = 1;
    for(int i=1;i<=a;i++)
    {
        rez = 1LL * rez * i % Mod;
    }
    return rez;
}

int divide(vector<int> v)
{
    if(v.size()<=1)
    {
        return 1;
    }
    int poz = 0;
    map<int,int> mp;
    for(int i=0;i<v.size();i++)
    {
        if(v[i] > v[poz])
        {
            poz = i;
        }
    }
    vector<int> st,dr;
    int nr = 0;
    for(int i=0;i<poz;i++)
    {
        if(v[i] + v[poz] > k)
        {
             st.push_back(v[i]);
        }
        else
        {
            ++nr;
            ++mp[v[i]];
        }
    }
    for(int i=poz+1;i<v.size();i++)
    {
        if(v[poz] + v[i] > k)
        {
            dr.push_back(v[i]);
        }
        else
        {
            ++nr;
            ++mp[v[i]];
        }
    }
    int rez = aranj(v.size(),nr);
    for(auto it : mp)
    {
        rez = 1LL * rez * invmod(fact(it.second)) % Mod;
    }
    return 1LL * divide(st) * divide(dr) % Mod * rez % Mod;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef HOME
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // HOME
    cin>>n>>k;
    vector<int> v;
    for(int i=1;i<=n;i++)
    {
        int x;
        cin>>x;
        v.push_back(x);
    }
    cout<<divide(v)<<'\n';
    return 0;
}
