#include <iostream>
#include <cmath>

using namespace std;

long long p, q, n, x, y, lx, ly, sol;

int euclid(int a, int b)
{
    if (b == 0)
        return a;
    return euclid(b, a%b);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> p >> q >> n;
    lx = ((long long)(sqrt(p))) + 2;
    ly = ((long long)(sqrt(q))) + 2;
    for (x = 1; x <= lx; x++) {
        for (y = 1; y <= ly; y++) {
            if (euclid(x, y) == 1) {
                sol += min(n / (x*y), min(p / (x*(x+y)), q / (y*(x+y))));
            }
        }
    }
    cout << sol;
    return 0;
}
