#include <bits/stdc++.h>

using namespace std;

const int MAX = 1005;

const int md = 1e9 + 7;

long long f[MAX];

long long pas[MAX][MAX];

long long add(long long a, long long b) {
  return a + b >= md ? a + b - md : a + b;
}

long long mul(long long a, long long b) {
  return (a * b) % md;
}

long long sub(long long a, long long b) {
  return a - b < 0 ? a - b + md : a - b;
}

long long bin_pow(long long x, long long k) {
  long long r = 1;
  while (k > 0) {
    if (k & 1) {
      r = mul(r, x);
    }
    x = mul(x, x);
    k >>= 1;
  }
  return r;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  f[0] = 1;
  f[1] = 1;
  for (int i = 2; i < MAX; i++) {
    f[i] = mul(f[i - 1], i);
  }
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  /*vector<long long> dp(n);
  for (int i = 0; i < n; i++) {
    int mx = 0;
    int smx = -1;
    //dp[i] = (i == 0 ? 1LL : dp[i - 1]);
    for (int j = i; j >= 0; j--) {
      //mn = min(mn, a[j]);
      //mx = max(mx, a[j]);
      if (mx < a[j]) {
        smx = mx;
        mx = a[j];
      } else {
        smx = max(smx, a[j]);
      }
      if (j < i && smx + mx <= k) {
        dp[i] = add(dp[i], mul((j == 0 ? 1LL : dp[j - 1]), sub(f[i - j + 1], f[i - j])));
      }
    }
  }
  for (int i = 0; i < n; i++) {
    cout << dp[i] << " ";
  }
  cout << '\n';*/
  auto C = [&](int n, int k) {
    return mul(f[n], mul(bin_pow(f[k], md - 2), bin_pow(f[n - k], md - 2)));
  };
  vector<vector<int>> g(n);
  vector<int> deg(n);
  auto AddEdge = [&](int x, int y) {
    if (a[x] < a[y]) {
      swap(x, y);
    }
    g[x].push_back(y);
    deg[y]++;
  };
  for (int i = 0; i < n; i++) {
    int parL;
    int parR;
    {
      int ptr = i - 1;
      while (ptr >= 0 && (a[i] + a[ptr] <= k || a[i] >= a[ptr])) {
        ptr--;
      }
      parL = ptr;
    }
    {
      int ptr = i + 1;
      while (ptr < n && (a[i] + a[ptr] <= k || a[i] >= a[ptr])) {
        ptr++;
      }
      parR = (ptr == n ? -1 : ptr);
    }
    if (parL == -1 && parR == -1) {
      continue;
    }
    if (parL == -1) {
      swap(parL, parR);
    }
    if (parR != -1 && a[parL] > a[parR]) {
      swap(parL, parR);
    }
    if (a[i] < a[parL]) {
      AddEdge(i, parL);
    }
  }
  for (int i = 0; i < n; i++) {
    sort(g[i].begin(), g[i].end());
    g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
//    cout << "i = " << i << ": ";
//    for (int j : g[i]) {
//      cout << j << " ";
//    }
//    cout << '\n';
  }
  vector<int> q;
  for (int i = 0; i < n; i++) {
    if (deg[i] == 0) {
      q.push_back(i);
    }
  }
  for (int b = 0; b < (int) q.size(); b++) {
    int i = q[b];
    for (int j : g[i]) {
      deg[j]--;
      if (deg[j] == 0) {
        q.push_back(j);
      }
    }
  }
  reverse(q.begin(), q.end());
  vector<int> sz(n);
  vector<long long> dp(n);
  for (int b = 0; b < (int) q.size(); b++) {
    int i = q[b];
    if (g[i].empty()) {
      dp[i] = 1;
      sz[i] = 1;
    } else {
      long long prodL = 1;
      long long prodR = 1;
      int cntL = 0;
      int cntR = 0;
      sz[i] = 1;
      for (int j : g[i]) {
        if (j < i) {
          prodL = mul(prodL, dp[j]);
          cntL += 1;
        } else {
          prodR = mul(prodR, dp[j]);
          cntR += 1;
        }
        dp[i] = mul(mul(prodL, f[cntL]), mul(prodR, f[cntR]));
        sz[i] += sz[j];
        sz[j] = 0;
      }
    }
//    cout << i << " " << sz[i] << endl;
  }
//  cout << "Hi" << endl;
  long long ans = 0;
  int rem = n;
  for (int i = 0; i < n; i++) {
    if (sz[i] != 0) {
//      cout << sz[i] << '\n';
      ans += mul(C(rem, sz[i]), dp[i]);
//      ans += mul(1, dp[i]);
      rem -= sz[i];
    }
  }
  cout << ans << '\n';
  return 0;
}
