#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

int Query(int n, vector<int> v) {
  vector<bool> qv(n, false);
  for (int i = 0; i < (int) v.size(); i++) {
    qv[v[i]] = true;
  }
  return flip_bits(qv);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
  mt19937 rng(31289551);
  int len = Query(n, {});
  while (len > 10) {
    vector<int> qv;
    for (int i = 0; i < n; i++) {
      int x = rng();
      if (x % 2 == 0) {
        qv.push_back(i);
      }
    }
    len = Query(n, qv);
  }
  for (int i = 0; i < n; i++) {
    int new_len = Query(n, {i});
    if (new_len == len) {
      continue;
    }
    if (new_len > len) {
//      cerr << "SIUUU1" << endl;
      int L = i, R = i;
      auto is_L = [&]() {
        bool res = (L > 0 && Query(n, {L - 1}) <= new_len);
        if (L > 0) {
          Query(n, {L - 1});
        }
        return res;
      };
      auto is_R = [&]() {
        bool res = (R < n - 1 && Query(n, {R + 1}) <= new_len);
        if (R < n - 1) {
          Query(n, {R + 1});
        }
        return res;
      };
      while (is_L()) {
        L--;
      }
      while (is_R()) {
        R++;
      }
      return {L, R};
    } else {
//      cerr << "SIUUUU2" << endl;
      new_len = Query(n, {i});
      int L = i, R = i;
      auto is_L = [&]() {
        bool res = (L > 0 && Query(n, {L - 1}) <= new_len);
        if (L > 0) {
          Query(n, {L - 1});
        }
        return res;
      };
      auto is_R = [&]() {
        bool res = (R < n - 1 && Query(n, {R + 1}) <= new_len);
        if (R < n - 1) {
          Query(n, {R + 1});
        }
        return res;
      };
      while (is_L()) {
        L--;
      }
      while (is_R()) {
        R++;
      }
      return {L, R};
    }
  }
  return {-1, -1};
}
