#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

int Query(int n, vector<int> v) {
  vector<bool> qv(n, false);
  for (int i = 0; i < (int) v.size(); i++) {
    qv[v[i]] = true;
  }
  return flip_bits(qv);
}

pair<int, int> find_longest_subarray_of_ones(int n) {
  mt19937 rng(31289551);
  int len = Query(n, {});
  auto isBad = [&]() {
    vector<int> qv;
    for (int i = 0; i < n; i++) {
      qv.push_back(i);
    }
    int new_len = Query(n, qv);
    Query(n, qv);
    return new_len >= len;
  };
  while (len > 18 || isBad()) {
    vector<int> qv;
    for (int i = 0; i < n; i++) {
      int x = rng();
      if (x % 2 == 0) {
        qv.push_back(i);
      }
    }
    len = Query(n, qv);
  }
  vector<int> qqv;
  for (int i = 0; i < n; i++) {
    qqv.push_back(i);
  }
  int new_len = Query(n, qqv);
  if (new_len >= len) {
    len = new_len;
  } else {
    Query(n, qqv);
  }
  int l = 0, r = n - 1, pos = 0;
  bool to_flip = false;
  while (l <= r) {
    int mid = l + r >> 1;
    vector<int> qv;
    for (int i = 0; i <= mid; i++) {
      qv.push_back(i);
    }
    int new_len = Query(n, qv);
    Query(n, qv);
    if (new_len != len) {
      if (new_len > len) {
        to_flip = (new_len > len);
        pos = mid;
        break;
      }
      pos = mid;
      r = mid - 1;
    } else {
      l = mid + 1;
    }
  }
  int L = pos, R = pos;
  if (to_flip) {
    vector<int> qv;
    for (int i = 0; i <= pos; i++) {
      qv.push_back(i);
    }
    int prv_len = len;
    len = Query(n, qv);
    R = pos + prv_len;
    L = pos - (len - prv_len) + 1;
  } else {
    R = pos + len - 1;
  }
//  cerr << L << " " << R << endl;
  return {L, R};
  for (int i = pos; i <= pos; i++) {
    int new_len = Query(n, {i});
    if (new_len == len) {
      continue;
    }
    if (new_len > len) {
//      cerr << "SIUUU1" << endl;
      auto is_L = [&]() {
        bool res = (L > 0 && Query(n, {L - 1}) <= new_len);
        if (L > 0) {
          Query(n, {L - 1});
        }
        return res;
      };
      auto is_R = [&]() {
        bool res = (R < n - 1 && Query(n, {R + 1}) <= new_len);
        if (R < n - 1) {
          Query(n, {R + 1});
        }
        return res;
      };
      while (is_L()) {
        L--;
      }
      while (is_R()) {
        R++;
      }
      return {L, R};
    } else {
//      cerr << "SIUUUU2" << endl;
      new_len = Query(n, {i});
      auto is_L = [&]() {
        bool res = (L > 0 && Query(n, {L - 1}) <= new_len);
        if (L > 0) {
          Query(n, {L - 1});
        }
        return res;
      };
      auto is_R = [&]() {
        bool res = (R < n - 1 && Query(n, {R + 1}) <= new_len);
        if (R < n - 1) {
          Query(n, {R + 1});
        }
        return res;
      };
      while (is_L()) {
        L--;
      }
      while (is_R()) {
        R++;
      }
      return {L, R};
    }
  }
  return {-1, -1};
}
