#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<ll,null_type,less<ll>,rb_tree_tag,
tree_order_statistics_node_update> ordered_set;


void solve(){
    ll n,k;cin>>n>>k;
    vector<ll> vec(n);
    for(int i = 0; i < n;i++) cin>>vec[i];
    ll ans=1;

    // preserve relative order when sum is greater 
    // than k
    vector<set<ll>> left(n+1);//all that must be left
    //of number i
    set<ll> cur;
    for(int i = 0;i<n;i++){
        for(auto u : cur){
            if(u + vec[i] > k) left[vec[i]].insert(u);
        }
        cur.insert(vec[i]);
    }

    auto p = vec;
    while(next_permutation(vec.begin(),vec.end())){
        cur.clear();
        int ok=1;
        for(int i =0; i < n && ok;i++){
            for(auto u : left[vec[i]]){
                if(cur.find(u)==cur.end()) {
                    ok =0; break;
                }
            }
            cur.insert(vec[i]);
        }

        if(ok) ans++;
    }

    vec=p;
    while(prev_permutation(vec.begin(),vec.end())){
         cur.clear();
        int ok=1;
        for(int i =0; i < n && ok;i++){
            for(auto u : left[vec[i]]){
                if(cur.find(u)==cur.end()) {
                    ok =0; break;
                }
            }
            cur.insert(vec[i]);
        }

        if(ok) ans++;
    }

    cout<<ans<<endl;
}

int main(){
    ios_base::sync_with_stdio(0),cin.tie(0);
    int t=1;//cin>>t;
    while(t--)solve();
}


/*

*/