#include <vector>
// include <iostream>
#include "ones.h"

using namespace std;

std::pair<int,int> find_longest_subarray_of_ones(int n) {
    vector<short> field(n, 2);
    
    int before = flip_bits(vector<bool>(n, false));
    if (before == n) return {0, n};
    
    for (int len=1; len<n; len++) {
        bool calc_main = false;
        
        for (int ix=0; ix<4; ix++) {
            bool calc = true;
            
            for (int i=0; i < (n-len+1); i++) {
                vector<bool> flips(n, false);
                
                for (int j=0; j<len; j++) flips[i+j] = true;
                
                int now = flip_bits(flips);
                
                for (int j=0; j<len; j++) {
                    if (field[i+j] != 2) {
                        if (field[i+j] == 0) field[i+j] = 1;
                        else if (field[i+j] == 1) field[i+j] = 0;
                    }
                    
                    if (field[i+j] == 2) calc = false;
                }
                
                if (len==1 && field[i] == 2) {
                    if (now > before) field[i] = 1;
                    else if (now < before) field[i] = 0;
                }
                
                /*cout << "G: ";
                for (int j=0; j<n; j++) cout << field[j] << " ";
                cout << " -- " << before << " " << now << " (" << i << ")";
                cout << endl;
                cout << endl;*/
                
                before = now;
            }
            
            // cout << endl;
            if (calc) {
                calc_main = true;
                break;
            }
        }
        
        if (calc_main) break;
    }
    
    /*cout << "G: ";
    for (int i=0; i<n; i++) cout << field[i] << " ";
    cout << endl;*/
    
    int a=0, b=-1, len=0;
    int maxa=0, maxb=-1, maxlen=0;
    
    for (int i=0; i<=n; i++) {
        if (i == n || field[i] == 0) {
            if (len > maxlen) {
                maxa = a;
                maxb = b;
                maxlen = len;
            }
            
            continue;
        }
        
        if (field[i] == 1) {
            if (i > 0 && field[i-1] == 0) {
                a = i;
                len = 0;
            }
            
            b = i;
            len++;
        }
    }
    
    return {maxa, maxb};
}

