#include "ones.h"
#include <vector>
#include <utility>
#include <iostream>
using namespace std;
std::vector<bool> flips;
void reset_flips() {
    for(int x = 0; x < flips.size(); x++) {
        flips[x] = false;
    }
}

std::pair<int, int> find_longest_subarray_of_ones(int n) {
    for(int x = 0; x < n; x++) {
        flips.push_back(false);
    }
    int length = flip_bits(flips);
    for(int x = 0; x < n; x++) {
        reset_flips();
        flips[x] = true;
        int flipped = flip_bits(flips);
        if(flipped < length) {
            return(std::pair<int, int>(x+1, x+flipped));
        }
        else if(flipped > length) {
            //std::cout << x << std::endl;
            return(std::pair<int, int>(x-(flipped-length)+1, x+length));
        }
    }
    
    return std::pair<int, int>(1,2);
}