#include <bits/stdc++.h>

using namespace std;

#define int long long
#define mp make_pair
#define pb push_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

constexpr int N = (int)2e5 + 11;
bool sieve[N];
int prime[N];
int cntP = 0;

void getDivs(int pos,__int128 x,vector<pair<int,int>>& v,vector<__int128>& divs){
    if(pos == v.size()){
        divs.pb(x);
        return;
    }
    for(int i = 0; i <= v[pos].second; i++){
        getDivs(pos+1,x,v,divs);
        x = x * v[pos].first;
    }
    return;
}

void solve(){
    int p,q,n;
    cin >> p >> q >> n;
    if(p > q)
        swap(p,q);

    for(int i = 0; i < N; i++)
        sieve[i] = true;
    for(int i = 2; i < N; i++){
        if(!sieve[i])
            continue;
        prime[cntP++] = i;
        for(int j = i*i; j < N; j+=i)
            sieve[j] = false;
    }

    int ans = 0;
    for(int a = 1; a <= p; a++){
        vector<pair<int,int>> v;
        int _a = a;
        for(int i = 0; i < cntP; i++){
            int p = prime[i];
            if(p * p > _a)
                break;
            if(_a % p != 0)
                continue;
            int cnt = 0;
            while(_a % p == 0){
                _a /= p;
                cnt++;
            }
            v.pb(mp(p,2*cnt));
        }
        if(_a > 1)
            v.pb(mp(_a,2));
        vector<__int128> divs;
        getDivs(0,1,v,divs);
        for(auto& d1 : divs){
            __int128 d2 = ((__int128)a*a)/d1;
            __int128 b = d1 - a;
            __int128 c = a - d2;
//            cerr << (int)a << " " << (int)b << " " << (int)c << "\n";
            ans += (b >= 1 && c >= 1 && b <= q && c <= n);
        }
    }

    cout << ans << "\n";

    return;
}

signed main(){
    ios::sync_with_stdio(false); cin.tie(nullptr);cout.tie(nullptr);
    int tests = 1;
//    cin >> tests;

    for(int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
