#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//template<class T> using oset=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
//template<class T> using omset=tree<T,null_type,less_equal<T>,rb_tree_tag,tree_order_statistics_node_update>;

#define int long long
#define pb push_back
#define x first
#define y second
#define all(x) x.begin(),x.end()
#define ins insert

typedef long long ll;
typedef unsigned long long ull;
typedef __int128_t LL;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef vector<pii> vpii;

const int N=3e5+5;
const int inf=1e9+5;
const int mod=1e9+7;
const char nl='\n';

int n,k;
int a[N];
int f[N+5];
int of[N+5];

int po(int x,int y)
{
    int res=1;
    while(y>0){
        if(y&1){
            res=res*x%mod;
        }
        x=x*x%mod;
        y>>=1ll;
    }
    return res;
}

int C(int x,int y)
{
    if(!x || !y || y>=x){
        return 1;
    }
    return f[x]*of[y]%mod*of[x-y]%mod;
}

bool used[N];

int solve(int l,int r)
{
    if(l>r){
        return 1;
    }
    int mx=0;
    for(int i=l;i<=r;++i){
        if(!used[i] && a[i]>mx){
            mx=a[i];
        }
    }
    vi mxs;
    mxs.pb(l-1);
    for(int i=l;i<=r;++i){
        if(!used[i] && a[i]==mx){
            mxs.pb(i);
        }
    }
    mxs.pb(r+1);
    int cnt=0;
    int dec=0;
    for(int i=l;i<=r;++i){
        if(used[i]){
            dec++;
        }
    }
    for(int i=1;i<mxs.size()-1;++i){
        used[mxs[i]]=1;
    }
    map<int,int>mp;
    for(int i=l;i<=r;++i){
        if(!used[i] && a[i]+mx<=k){
            used[i]=1;
            mp[a[i]]++;
            cnt++;
        }
    }
    int res=1;
    res=res*C(r-l+1-dec,cnt)%mod;
    res=res*f[cnt]%mod;
    for(auto it:mp){
        res=res*of[it.y]%mod;
    }
    for(int i=0;i<mxs.size()-1;++i){
        int l_=mxs[i]+1,r_=mxs[i+1]-1;
        bool go=0;
        for(int j=l_;j<=r_;++j){
            if(!used[j]){
                go=1;
                break;
            }
        }
        if(go){
            res=res*solve(l_,r_)%mod;
        }
    }
    return res;
}

set<pii> st[N*4];
int t[N*4];

void build(int v,int lv,int rv)
{
    if(lv==rv){
        st[v].ins({a[lv],lv});
        t[v]=lv;
        return;
    }
    int mid=lv+rv>>1;
    build(v+v,lv,mid);
    build(v+v+1,mid+1,rv);
    st[v]=st[v+v];
    for(auto [i,j]:st[v+v+1]){
        st[v].ins({i,j});
    }
    t[v]=(a[t[v+v]]>a[t[v+v+1]] ? t[v+v]:t[v+v+1]);
}

void upd(int v,int lv,int rv,int pos)
{
    if(lv==rv){
        st[v].erase({a[pos],pos});
        return;
    }
    int mid=lv+rv>>1;
    if(pos<=mid){
        upd(v+v,lv,mid,pos);
    }
    else{
        upd(v+v+1,mid+1,rv,pos);
    }
    st[v].erase({a[pos],pos});
}

int get(int v,int lv,int rv,int l,int r)
{
    if(l==lv && r==rv){
        return t[v];
    }
    int mid=lv+rv>>1;
    if(r<=mid){
        return get(v+v,lv,mid,l,r);
    }
    else if(l>mid){
        return get(v+v+1,mid+1,rv,l,r);
    }
    int l_=get(v+v,lv,mid,l,mid);
    int r_=get(v+v+1,mid+1,rv,mid+1,r);
    return (a[l_]>a[r_] ? l_:r_);
}

vi del;
vi L,R;
vi dL,dR;

void find_dels(int v,int lv,int rv,int l,int r,int mx)
{
    if(l==lv && r==rv){
        for(auto [i,j]:st[v]){
            if(i>mx){
                break;
            }
            del.pb(j);
        }
        return;
    }
    int mid=lv+rv>>1;
    if(r<=mid){
        find_dels(v+v,lv,mid,l,r,mx);
    }
    else if(l>mid){
        find_dels(v+v+1,mid+1,rv,l,r,mx);
    }
    else{
        find_dels(v+v,lv,mid,l,mid,mx);
        find_dels(v+v+1,mid+1,rv,mid+1,r,mx);
    }
}

int solve_for_21(int l,int r)
{
    if(l>r){
        return 1;
    }
//    cout<<l<<' '<<r<<nl;
    int mid=get(1,1,n,l,r);
    int mx=a[mid];

    del.clear();
    L.clear();
    R.clear();
    dL.clear();
    dR.clear();
    if(mid!=l){
        find_dels(1,1,n,l,mid-1,inf);
        L=del;
        del.clear();
        find_dels(1,1,n,l,mid-1,k-mx);
        dL=del;
        del.clear();
    }
    if(mid!=r){
        find_dels(1,1,n,mid+1,r,inf);
        R=del;
        del.clear();
        find_dels(1,1,n,mid+1,r,k-mx);
        dR=del;
        del.clear();
    }

    int cnt=dL.size()+dR.size();
    bool go_l=(L.size()>dL.size()),go_r(R.size()>dR.size());

    for(int i:dL){
        upd(1,1,n,i);
    }
    for(int i:dR){
        upd(1,1,n,i);
    }

    int res=1;
    res=res*C(L.size()+R.size()+1,cnt)%mod;
    res=res*f[cnt]%mod;
    if(go_l){
        res=res*solve(l,mid-1)%mod;
    }
    if(go_r){
        res=res*solve(mid+1,r)%mod;
    }
    return res;
}

/**
5 4
4 3 1 5 2

5 6
1 2 3 4 5

5 9
1 2 3 4 5
**/

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    f[0]=1;
    for(int i=1;i<N;++i){
        f[i]=f[i-1]*i%mod;
    }
    of[N-1]=po(f[N-1],mod-2);
    of[0]=1;
    for(int i=N-2;i>=1;--i){
        of[i]=of[i+1]*(i+1)%mod;
    }

    cin>>n>>k;
    for(int i=1;i<=n;++i){
        cin>>a[i];
    }
    build(1,1,n);
    cout<<solve_for_21(1,n);
}
