#include "ones.h"
// #include "Lgrader.cpp"

using namespace std;

pair<int, int> find_longest_subarray_of_ones(int n) {
    vector<bool> flips(n);
    int longest = flip_bits(flips);
    vector<bool> defo1(n, 0);
    for (int i = 0; longest < n; i = (i+1)%n) {
        if (defo1[i]) continue;
        flips[i] = true;
        int current = flip_bits(flips);
        flips = vector<bool>(n);
        if (current < longest) { // now 0
            flips[i] = true; // flip back to 1 next query
            defo1[i] = true;
        } else if (current > longest) { // now 1
            defo1[i] = true;
        }
        longest = flip_bits(flips);
        flips = vector<bool>(n);
    }
    return {0, n-1};
}

